# BrnTech makefile Version 1.01
#   Created by Huang Tzu-Fong, 2002/12/20

# *****************************************************************************
# remember to modify these 2 directories
# root directory for the project. just for the convenience of the following
# directorys, and will not be used elsewhere.
ROOT_DIR = d:/prj_ti/gpl/bnchen_03/source

# directory for project related code, begin from SOURCE_ROOT_DIR
PROJECT_DIR = project

# where is the root directory for output object code
OUTPUT_ROOT_DIR = d:/prj_ti/gpl/bnchen_03/output

ToolChainPath = c:/cygwin
# for ARM
#CC=$(ToolChainPath)/arm-elf-gcc
#AS=$(ToolChainPath)/arm-elf-gcc
#LIBR=$(ToolChainPath)/arm-elf-ar -rc
#LNK=$(ToolChainPath)/arm-elf-gcc
# for MIPS
#CC=$(ToolChainPath)/mips-elf-gcc
#AS=$(ToolChainPath)/mips-elf-as
#LIBR=$(ToolChainPath)/mips-elf-ar -rc
#LNK=$(ToolChainPath)/mips-elf-gcc
# for IDT MIPS
CC=mipsisa32-elf-gcc
AS=mipsisa32-elf-as
LIBR=mipsisa32-elf-ar -rc
LNK=mipsisa32-elf-gcc

# *****************************************************************************

# root directory for source code
SOURCE_ROOT_DIR = $(ROOT_DIR)

# directory for realtime OS
OS_DIR = $(SOURCE_ROOT_DIR)/os








# do not modify this variable
SOURCE_SUB_DIR = $(SOURCE_ROOT_DIR)
OUTPUT_SUB_DIR = $(OUTPUT_ROOT_DIR)

include $(SOURCE_ROOT_DIR)/$(PROJECT_DIR)/Gtools.def
include $(SOURCE_ROOT_DIR)/$(PROJECT_DIR)/Gmodule.def
include $(SOURCE_ROOT_DIR)/00makeutil/Gmodule.mk



#SOURCE_SUB_DIR = $(SOURCE_ROOT_DIR)

ifeq "$(strip $(MAKELEVEL))" "0"
  -include $(SOURCE_ROOT_DIR)/00target.mk
else
  -include 00target.mk
endif


ALL_THINGS = subdirs
ifeq "$(strip $(MAKELEVEL))" "0"
ALL_THINGS = cfgRootBegin subdirs mkcfg
endif

all:  $(ALL_THINGS)   # subdirs
	@echo === config done ===



.PHONY:  all mkcfg targetcfg cfgRootBegin showMsg
.PHONY: subdirs $(MakeDIRS)

subdirs: targetcfg $(MakeDIRS)

$(MakeDIRS): targetcfg
	@echo config $@
#	@echo config \[$(MAKELEVEL). $@\]
#	@echo target_name: \[$(TARGET_NAME)\]
#	@cp -fv $(SOURCE_ROOT_DIR)/00makeutil/makefile .
#	@if [ ! -z '$(strip $(TARGET_NAME))' ]; then \
#	    echo LIBRARYS += $(shell pwd)/$(TARGET_NAME) >> $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
#	fi
	@if [ ! -d $@ ]; then \
	    mkdir $@; \
	fi
	@echo ModulePath += $(SOURCE_SUB_DIR)/$@ >> $(OUTPUT_ROOT_DIR)/ModulePath.mk
	@if [ -f $(SOURCE_SUB_DIR)/$@/00target.mk ]; then \
	    cp -f $(SOURCE_SUB_DIR)/$@/00target.mk $@; \
	    cp -f 00config.mk $@; \
	    echo $(MAKELEVEL). $@ -------\>; \
	    cd $@; \
	    $(MAKE) -f 00config.mk SOURCE_SUB_DIR=$(SOURCE_SUB_DIR)/$@ OUTPUT_SUB_DIR=$(OUTPUT_SUB_DIR)/$@; \
	      if [ $$? -ne 0 ]; then \
	          echo ; \
	          echo !!!error occurs in sub-directory [$$dir]; \
	          echo Please check the last log file; \
	          exit 2; \
	      fi; \
	    echo MY_SOURCE_DIR \= $(SOURCE_SUB_DIR)/$@ >> targetcfg.mk; \
	    rm -f 00config.mk; \
	    rm -f 00target.mk; \
	    rm -f *.dep; \
	    cd ..; \
	    echo \<--- $(MAKELEVEL). $@; \
	fi
#	    rm -f $@/targetcfg.mk; \



targetcfg:
	@echo
	@echo do $@
	@echo --------------------------------
	@echo MAKELEVEL=$(MAKELEVEL)
	@echo Generate targetcfg.mk
#	@echo in \($(shell pwd)\)
	@echo MakeDIRS:\($(MakeDIRS)\)
	@echo target_name: \[$(TARGET_NAME)\]
	@echo --------------------------------
#	@echo
	-@rm -f targetcfg.mk
	@echo \# >> targetcfg.mk
	@echo \# This file was created from $(SOURCE_ROOT_DIR)/makeutil/00config.mk >> targetcfg.mk
	@echo \# by \"make -f 00config.mk\" >> targetcfg.mk
	@echo \#     create time: $(shell date) >> targetcfg.mk
	@echo \# >> targetcfg.mk
	@echo >> targetcfg.mk
	@echo OUTPUT_ROOT_DIR = $(OUTPUT_ROOT_DIR) >> targetcfg.mk
	@echo OUTPUT_DIR      = $(OUTPUT_SUB_DIR) >> targetcfg.mk
	@echo SOURCE_ROOT_DIR = $(SOURCE_ROOT_DIR) >> targetcfg.mk
	@echo SOURCE_DIR      = $(SOURCE_SUB_DIR) >> targetcfg.mk
	@echo PROJECT_DIR = $(PROJECT_DIR) >> targetcfg.mk
	@echo OS_DIR = $(OS_DIR) >> targetcfg.mk
	@echo >> targetcfg.mk
	@echo >> targetcfg.mk
	@echo TARGET_NAME \= $(TARGET_NAME) >> targetcfg.mk
	@if [ ! -z '$(strip $(EXE_NAME))' ]; then \
	    echo EXE_NAME \= $(EXE_NAME) >> targetcfg.mk; \
	fi
	@echo VPATH \= $(VPATH) >> targetcfg.mk
	@echo ModuleDefine \= $(ModuleDefine) >> targetcfg.mk
	@echo TARGET_C \= $(TARGET_C) >> targetcfg.mk
	@echo TARGET_CPP \= $(TARGET_CPP) >> targetcfg.mk
	@echo TARGET_S \= $(TARGET_S) >> targetcfg.mk
	@echo MakeDIRS \= $(MakeDIRS) >> targetcfg.mk
	@cp -f $(SOURCE_ROOT_DIR)/00makeutil/makefile .
	@if [ ! -z '$(strip $(TARGET_NAME))' ]; then \
	    echo LIBRARYS += $(OUTPUT_SUB_DIR)/$(TARGET_NAME) >> $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	fi
#	@echo ModulePath += $(SOURCE_SUB_DIR)/$@ >> $(OUTPUT_ROOT_DIR)/ModulePath.mk


cfgRootBegin:
	@echo do $@
	@if [ $(MAKELEVEL) -eq 0 ]; then \
	      rm -f $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	        echo \# > $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	        echo \# This file was created from $(SOURCE_ROOT_DIR)/makeutil/00config.mk >> $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	        echo \#   by \"make -f 00config.mk\" >> $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	        echo \#     create time: $(shell date) >> $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	        echo \# >> $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	        echo >> $(OUTPUT_ROOT_DIR)/ModulePath.mk; \
	      cp -f $(SOURCE_ROOT_DIR)/00makeutil/00makerule.mk $(OUTPUT_ROOT_DIR); \
	      cp -f $(SOURCE_ROOT_DIR)/$(PROJECT_DIR)/*.bat $(OUTPUT_ROOT_DIR); \
	      if [ ! -d 00release ]; then \
	          mkdir 00release; \
	      fi; \
	fi


mkcfg:
	@echo do $@
	-@rm -f makecfg.mk
	@echo \# >> makecfg.mk
	@echo \# This file was created from $(SOURCE_ROOT_DIR)/makeutil/00config.mk >> makecfg.mk
	@echo \# by using \"make -f 00config.mk mkcfg\" >> makecfg.mk
	@echo \#     create time: $(shell date) >> makecfg.mk
	@echo \# >> makecfg.mk
	@echo >> makecfg.mk
#	@echo RTOS_LIBS = $(RTOS_LIBS) >> makecfg.mk
	@echo ToolChainPath = $(ToolChainPath) >> makecfg.mk
	@echo CC = $(CC) >> makecfg.mk
	@echo AS = $(AS) >> makecfg.mk
	@echo LIBR = $(LIBR) >> makecfg.mk
	@echo LNK = $(LNK) >> makecfg.mk
	@echo >> makecfg.mk
	@echo >> makecfg.mk
	@echo PROJECT = $(PROJECT) >> makecfg.mk
	@echo COMPILER = $(COMPILER) >> makecfg.mk
	@echo ASSEMBLER = $(ASSEMBLER) >> makecfg.mk
	@echo MMODL = $(MMODL) >> makecfg.mk
	@echo LIBER = $(LIBER) >> makecfg.mk
	@echo LINKER = $(LINKER) >> makecfg.mk
	@echo CODE = $(CODE) >> makecfg.mk
	@echo >> makecfg.mk
	@echo >> makecfg.mk
	@echo MTPTH = $(MTPTH) >> makecfg.mk
	@echo ADD = $(ADD) >> makecfg.mk
	@echo S = $(S) >> makecfg.mk
	@echo O = $(O) >> makecfg.mk
	@echo L = $(L) >> makecfg.mk
	@echo E = $(E) >> makecfg.mk
	@echo CFLAGS = $(CFLAGS) >> makecfg.mk
	@echo LFLAGS = $(LFLAGS) >> makecfg.mk
	@echo Cdefined = $(Cdefined) -D_COMPILER=$(COMPILER) >> makecfg.mk
	@echo OS_LIBS = $(OS_LIBS) >> makecfg.mk


showMsg:
	@echo
	@echo XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	@echo in $(shell pwd)
	@echo SubDirs:\($(MakeDIRS)\)
	@echo SOURCE_SUB_DIR=$(SOURCE_SUB_DIR)
	@echo TARGET_NAME=$(TARGET_NAME)
	@echo XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	@echo


