# BrnTech makefile Version 1.01
#   Created by Huang Tzu-Fong, 2002/12/20


# =========================================================================
#    This file is used for ARM9, Gcc toolchain, little endian.
# =========================================================================




# the following macros defined in makeutil.ref
ECHO=@echo
RM=rm
LOG=log
TMPLNK = tmp.lnk

# set CFG = release that will not generate symbolic debug code
CFG = release


libs = $(foreach dir,$(LIBRARYS),$(dir).$(L))   # the output example ../telnetd/telnetd.a
libs += $(OS_LIBS)
#libs = $(foreach dir,$(ModulePath),../$(dir)/$(dir).$(L))   # the output example ../telnetd/telnetd.a
#libs = $(wildcard $(patsubst %,../%/*.$(L),$(ModulePath)))  # the output example ../telnetd/rsd.a
#libs = $(foreach dir,$(ModulePath),$(wildcard ../$(dir)/*.$(L))) # this is the same as above line
#libs += d:/projects/mips/ttf2004/source/firmware/linklayer/APDK_5.5.20_GA/sample/make/tiwlanap.a
# end of makeutil.ref


# default rule for liber =====================================================

$(TARGET_NAME).$(L): $(libobj1) $(libobj2) $(libobj3) $(libobj4) $(libobj5) $(TARGET_NAME).dep
	@echo do $@
#	@echo $(libobj1) $(libobj2) $(libobj3) $(libobj4) $(libobj5)
    ifneq "$(strip $(Liber_Notice))" ""
	@echo -
	@echo $(Liber_Notice)
	@echo -
    endif
	-@rm -f $(TMPLNK)
	-@rm -f $@
	$(ECHO) =====================
	$(ECHO) generate $@
	$(ECHO) ---------------------
    ifneq "$(strip $(libobj1))" ""
	@$(LIBR) $@ $(libobj1)
    endif
    ifneq "$(strip $(libobj2))" ""
	@$(LIBR) $@ $(libobj2)
    endif
    ifneq "$(strip $(libobj3))" ""
	@$(LIBR) $@ $(libobj3)
    endif

##    ifneq "$(strip $(libobj1))" ""
##	@$(LIBR) -c -o $@ $(subst .$(O) ,.$(O) $(ADD) ,$(libobj1))
##    endif
##    ifneq "$(strip $(libobj2))" ""
##	@$(LIBR) -c -o $@ $(subst .$(O) ,.$(O) $(ADD) ,$(libobj1))
##    endif
##    ifneq "$(strip $(libobj3))" ""
##	@$(LIBR) -c -o $@ $(subst .$(O) ,.$(O) $(ADD) ,$(libobj1))
##    endif
##    ifneq "$(strip $(libobj4))" ""
##	@$(LIBR) -c -o $@ $(subst .$(O) ,.$(O) $(ADD) ,$(libobj1))
##    endif
##    ifneq "$(strip $(libobj5))" ""
##	@$(LIBR) -c -o $@ $(subst .$(O) ,.$(O) $(ADD) ,$(libobj1))
##    endif
#	@echo --- test ---
#	@echo $(libobj1) $(libobj2) $(libobj3) $(libobj4) $(libobj5)
#	$(ECHO) debug msg \($(patsubst %.c,%.$(O),$(subst .c ,.$(O) + ,$(TARGET_C)))\)
#	$(ECHO) debug msg \($(subst .$(O) ,.$(O) + ,$(patsubst %.c,%.$(O),$(TARGET_C)))\)
#	$(ECHO) debug msg \($(subst .$(O) ,.$(O) + ,$(libmpz_C:.c=.$(O)))\)
#	$(ECHO) debug msg \($^\)
#	$(ECHO) debug msg \($(TARGET_C:.c=.$(O))\)
#	$(ECHO) debug msg \($(OUTPUT_DIR)\)
#	$(ECHO) $(PROJECT_root)
#	@echo --- end ---






INCPATH = -I$(OS_DIR)/$(MTPTH) -I. $(patsubst %,-I%,$(ModulePath)) -I$(ToolChainPath)/usr/local/$(subst -gcc,,$(CC))/include


.c.$(O):
	@echo
    ifneq "$(strip $(Compiler_notice))" ""
	@echo -
	@echo $(Compiler_notice)
	@echo -
    endif
	-@$(RM) -f $*.$(LOG)
	$(ECHO) -------------------------------------------------------------------
#	$(ECHO) $<
	$(ECHO) generate $@ ... if error, check error log in $*.log
	$(ECHO) in $(OUTPUT_DIR)
	$(ECHO) by compile $(SOURCE_DIR)/$*.c
##	$(ECHO) CFLAGS \<$(CFLAGS)\>
#	$(ECHO) Cdefined \<$(Cdefined)\>
#	$(ECHO) INCPATH \<$(INCPATH)\>
#	$(ECHO) ModuleDefine \<$(ModuleDefine)\>
#	$(ECHO) COMPILER \<$(COMPILER)\>
	$(ECHO) -------------------------------------------------------------------
#	@gcc -specs=$(makeRuleDir)/CppSPECS -nostdinc -E $(Cdefined) $(ModuleDefine) $(INCPATH)  $<
#	@gcc -specs=$(makeRuleDir)/CppSPECS -nostdinc $(Cdefined) $(ModuleDefine) $(INCPATH)  $<
#	$(CC) -E $(Cdefined) $(INCPATH) $(CFLAGS) $(ModuleDefine)  $<  2> $*.$(LOG)
#	@$(CC) $(Cdefined) $(INCPATH) $(CFLAGS) $(ModuleDefine)  $<  2> $*.$(LOG)
	for x in $*; do \
	    $(CC) $(Cdefined) $(INCPATH) $(CFLAGS) $(ModuleDefine)  $(SOURCE_DIR)/$*.c  2> $*.$(LOG); \
	    if [ $$? -ne 0 ]; then \
	        cat $*.$(LOG); \
	        echo ;\
	        echo !!!error, log in $(OUTPUT_DIR)/$*.$(LOG); \
	        exit 1; \
	    fi; \
	done
	@cat $*.$(LOG)



.cpp.$(O):
	@echo
    ifneq "$(strip $(Compiler_notice))" ""
	@echo -
	@echo $(Compiler_notice)
	@echo -
    endif
	-@$(RM) -f $*.$(LOG)
	$(ECHO) -------------------------------------------------------------------
#	$(ECHO) $<
	$(ECHO) generate $@ ... if error, check error log in $*.log
	$(ECHO) in $(OUTPUT_DIR)
#	$(ECHO) CFLAGS \<$(CFLAGS)\>
	$(ECHO) -------------------------------------------------------------------
#	@$(CC) $(Cdefined) $(INCPATH) $(CFLAGS) $(ModuleDefine)  $<  2> $*.$(LOG)
	for x in $*; do \
	    $(CC) $(Cdefined) $(INCPATH) $(CFLAGS) $(ModuleDefine)  $(SOURCE_DIR)/$*.cpp  2> $*.$(LOG); \
	    if [ $$? -ne 0 ]; then \
	        cat $*.$(LOG); \
	        echo ;\
	        echo !!!error, log in $(OUTPUT_DIR)/$*.$(LOG); \
	        exit 1; \
	    fi; \
	done
	@cat $*.$(LOG)




.S.o:
	@echo
    ifneq "$(strip $(Asm_Notice))" ""
	@echo -
	@echo $(Asm_Notice)
	@echo -
    endif
	-@$(RM) -f $*.$(LOG)
	$(ECHO) -------------------------------------------------------------------
#	$(ECHO) $<
	$(ECHO) generate $@ ... if error, check error log in $*.log
	$(ECHO) in $(OUTPUT_DIR)
#	$(ECHO) CFLAGS \<$(CFLAGS)\>
	$(ECHO) -------------------------------------------------------------------
	echo $(CC) $(Cdefined) $(INCPATH) $(CFLAGS) $(ModuleDefine)  $<
	for x in $*; do \
	    $(CC) $(Cdefined) $(INCPATH) $(CFLAGS) $(ModuleDefine)  $(SOURCE_DIR)/$*.S  2> $*.$(LOG); \
	    if [ $$? -ne 0 ]; then \
	        cat $*.$(LOG); \
	        echo ;\
	        echo !!!error, log in $(OUTPUT_DIR)/$*.$(LOG); \
	        exit 1; \
	    fi; \
	done
	@cat $*.$(LOG)



#	$(ECHO) ===================================================================
#	$(ECHO) generate $@ ... if error, check error log in $*.log
#	$(ECHO) ===================================================================
#	@$(AS) $(AFLAGS) $*.o $*.s > $*.$(LOG)




$(EXE_NAME).$(E): $(libs) #soho.o $(TARGET).dep $(makeGenDir)/Gtool_path.mak
#	@echo $(libs)
	@echo =========================
	@echo generate $(EXE_NAME).$(E)
#	@echo $(LNK) -v $(LFLAGS) -o $(EXE_NAME).elf -Wl,-\( $(libs) -Wl,-\) -lm
	@echo =========================
#	$(LNK) -v $(LFLAGS) -o $(EXE_NAME).elf -Wl,--start-group $(libs) -Wl,--end-group -lm
	@for x in $(EXE_NAME); do \
	    $(LNK)  -v $(LFLAGS) -o $(EXE_NAME).elf -Wl,-\( $(libs) -Wl,-\) -lm -lc 2> $(EXE_NAME).log; \
	    if [ $$? -ne 0 ]; then \
	        cat $(EXE_NAME).log; \
	        echo ;\
	        echo !!!link error, see $(EXE_NAME).$(LOG); \
	        rm -f $(OUTPUT_ROOT_DIR)/$(PROJECT_DIR)/../config.o; \
	        exit 1; \
	    fi; \
	    rm -f $(OUTPUT_ROOT_DIR)/$(PROJECT_DIR)/../config.o; \
	    cat $(EXE_NAME).log; \
	    echo -----------------; \
	    if [ -f ../afterlnk.bat ]; then ../afterlnk.bat; fi; \
	done
	@if [ ! -f ./soho.bin ]; then exit; fi;
	@echo === pack firmware ===;
	@if [ -f ../build.bat ]; then ../build.bat; fi;
#	-@rm -f $(OUTPUT_ROOT_DIR)/$(PROJECT_DIR)/config.o

## arm sdt211 compiler
#	$(LNK) -nozeropad -libpath $(ToolChainPath)/lib $(LFLAGS) $(libs) #$(ToolChainPath)/lib/armlib.32l
#	-rm ../soho.zip
#	../pkzip ../soho.zip soho.bin
#	../version ../soho.zip BRN
#	cp ../soho.zip c:/




clean : clean_lib
#	  echo clean $$dir
	@for dir in $(MakeDIRS); do \
	  $(MAKE) -s -C $$dir clean; \
	done


clean_lib:
	@echo
	@echo clean $(OUTPUT_DIR)
    ifneq "$(strip $(Clean_Notice))" ""
	@echo -
	@echo $(Clean_Notice)
	@echo -
    endif
    ifneq "$(O)" ""
	-@rm -f *.[Oo]   #$(O)
    endif
    ifneq "$(L)" ""
	-@rm -f *.[Aa]   #$(L)
    endif
    ifneq "$(E)" ""
	-@rm -f *.[Bb][Ii][Nn]   #$(E)
    endif
    ifneq "$(LOG)" ""
	-@rm -f *.[Ll][Oo][Gg]   #$(LOG)
    endif
	-@rm -f *.bak
	-@rm -f *.[Mm][Aa][Pp]   #map
#	-@rm -f *.[Mm][Aa][Pp]   #map
	-@rm -f *.[Ee][Ll][Ff]   #sym
#	-@rm -f *.dep




$(TARGET_NAME).dep: $(TARGET_C) $(TARGET_CPP) $(TARGET_S)
	@echo
	@echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@echo modifing dependency file \($(TARGET_NAME).dep\)
#	@echo -\($^\)-
	@echo TARGET_C: $(TARGET_C)
#	@echo INCPATH $(INCPATH)
#	@echo -specs=$(SOURCE_ROOT_DIR)/00makeutil/CppSPECS -MM $(Cdefined) $(INCPATH) $(ModuleDefine)
	@echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	-@rm $(TARGET_NAME).dep
    ifneq "$(strip $(Dependence_Notice))" ""
	@echo -
	@echo $(Dependence_Notice)
	@echo -
    endif
	@$(CC) -specs=$(SOURCE_ROOT_DIR)/00makeutil/CppSPECS -MM $(Cdefined) $(ModuleDefine) $(INCPATH)  $^ > ./$(TARGET_NAME).dep
# set -specs=CppSPECS -nostdinc options to reset system include directories
#	-@gcc -nostdinc -isystem D:\CTOOL\ARM211\Include -MM $(Cdefined) $(ModuleDefine) $(INCPATH) $^ > ./$(TARGET_NAME).dep
#	@echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#	@echo dependency file \($(TARGET).dep\) modified, it\'s up to you
#	@echo to make clean and remake the project \($(TARGET)\)
#	@echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#	@echo





dep depend:
	@echo TARGET_C $(TARGET_C)
	@echo TARGET_NAME $(TARGET_NAME)
#	@echo INCPATH $(INCPATH)
#	    echo > $(TARGET_NAME).dep; \
#	@if [ ! -z $(strip $(TARGET_NAME)) ]; then \
#	    $(MAKE) -s $(TARGET_NAME).dep; \
#	fi
	@for dir in $(MakeDIRS); do \
	  echo make dep for $$dir; \
	  set -e; $(MAKE) -s -C $$dir dep; \
	done

