
// Name of File : UsbCfg.h
// ====================================================================

// Major Change List : 
// 2003/09/26 : Admtek 5120 : Fix Print via Hub Data Loss
// 2003/09/27 : LPT : Fix Prt_Init() while usblp_probe()
// 2003/09/27 : Admtek 5120 : BugFix when with HUB
//		Some delay on localhc_irq() SOTA_INTR_TD_COMPLETE
//      BugFix : LPT with HUB durning printing plug out
//                           then plug in let system hang
// 2003/10/01 : Admtek 5120 : for with USBMAC
//		localhc_irq() : one Interrupt Service for only one control ED 
//      td_submit_urb() : Set candidate last_TDH_num
//		dl_done_list() : Set SOTA_IRQ_BUGFIX for PIPE_CONTROL only
//		localhc_irq()  Some delay on fix for bulk-in pipe
// ?? 2003/10/01 : USBLPT : Prt_Init() add send 0CH : FF , Form Feed
//                 --> 2003/10/02 : Comment out this !!
// 2003/10/02 : LPD : add Prt_Reset afeter 30 Seconds
//              USBMAC : usbmac_read() packet size total -8
//				Admtek 5120 : for USBMAC td_done() Bulk-In size count
// 2003/10/02 : USBLPT :
//          Add support on Lexmark E210 Laser Printer
// 			usblp_open()  donot do read on usblp_open() for looser I/O 
//                       check on printers
//          USBLPT_READ_BY_CHECK for looser I/O access on printers
// 2003/10/03 USBMAC : bridge.c br_PortIntr() fix for receive packet
//                              allow call BR_UPPER_INTR()
// 2003/10/08 USBLPT : BugFix for Admtek 5120
//          USBLP_BUF_SIZE change to 4096
//                  Admtek 5120 cannot work on 8192
//          prdrv.h PR_INIT_RETRY_TIMES change to 20
// 2003/10/09 All : Add _USB_SYSLOG , this need define on feature.h
// 2003/10/13 USBLPT : 
//				add #undef USBLPT_BIDIR for set printer output only
//				add	#undef USBLPT_PROBE_RESET for not reset to test 
// 					Net Bios Hot Plug
//				add	#undef USBLPT_INIT_STR  to test 
// 					Net Bios Hot Plug
// 2003/10/14 USBLPT : 
//			add USBLP_QUIRK_NORESET for Brother HL-5040 cannot reset
// 2003/10/17 USBLPT :
// 			add USBLP_QUIRK_RESET11 for Brother HL-5040
// 2003/10/20 : USBMAC : InitPegasus() add call usbmac_br_forward_reg()
// 2003/11/06 : USBLPT : 
// 			add Support for HP DeskJet 3650
//              Core : UsMsg.c 
//              usb_start_wait_urb_nf() use Second for longer time out
//              set USBLPT_WRITE_TIMEOUT to 20 seconds
// 2003/11/12 : USBLPT : add Prt_GetId() for netbios
// 2003/12/31 : Admtek 5120 : for with USBMS
//				BugFix : Crash In ISR with Synnex Intelligent Stick 128 MB
//                       discard td_list
//              Improve Speed : 1018read/30sec --> 2933read/30sec
//								(with Int Scheduling)
//                       use SOTA_IRQ_WAIT_DELAY
// 2004/1/7 : Admtek 5120 :
//              add #define SOTA_SOFT_ISR , avoid delay/wait loop in ISR !!
// 2004/1/8 : USBMS :
//              BugFix : Read Sector Error while IntScheduling turn off
//						 this is race condition between two task !!
// 2004/1/9 : USBMS :
//              BugFix : Partition (Logical Disk) Number
// 2004/1/14 : USBMS :
//              BugFix : #define USBMS_NO_PROBE_MAXLUN for some device
//                       Donot Call usb_stor_Bulk_max_lun()
//                       Just Young JEG5114JF 3.5" USB2.0
//              BugFix : Hot Plug-Out while read sector
// 2004/1/16 : USBMS :
//              Add Read 8 Sectors Cache (write only 1 sector)
//              BugFix : Write Sector Not Actually Do the write
//              Add Supported Partition from 8 to 16
// 2004/2/4 : USBMS :
//              Add Write 8 Sectors Cache
//          : Admtek 5120 : for with USBMS
//				BugFix : Data Transfer Can Larger than 4K Bytes
//                       Max 64K Bytes
//              Improve Speed : 16 setctors (8KBytes)
//                      1125 read/30sec (with Int Scheduling)
//								2/3 of 8 sectors
//                      2717 read/30sec (Int Scheduling OFF)
//								16/12=4/3 of 8 sectors
// 2004/2/5 : USBMS :
//				Add usb_cluster_read()/usb_cluster_read()

// ====================================================================

/*
// This need put on feature.h if need
#ifdef _SYSLOG
    #define _USB_SYSLOG
#endif // _SYSLOG
*/

// ====================================================================
// === for OsPort =====================================================
// ====================================================================

#define NO_KSET
#define NO_WORKQUEUE
#define NO_WAITQUEUE

#define NO_TIMER

#define NO_SYS_FS
#define NO_SCATTER_LIST

#define USB_NO_VMM // no vitrtul memory management
        // undef for physical page need copy to logical page
        // dma_map_single
		// struct vm_area_struct

#define USB_NO_DMA_POOL // for pci_pool / dma_pool management
						// define ok !!

#if defined(_S3C2510)
    //adai comment out	#undef USB_NO_LIB   
     #define USB_NO_LIB
#elif defined(_AR7300)
     #define USB_NO_LIB
#elif defined(_ADM5120)
    #define USB_NO_LIB
    // library havenot : snprintf()
#elif defined(_ATHEROS)
     #define USB_NO_LIB
#else
	#undef USB_NO_LIB   
#endif

#define USB_MEM_LIB // Not use NonCache_contigmalloc

#define USB_BIGBUF_M_POOL // bigbuffer not use L pool

#define USB_NO_ISR_FREE   
#define USB_NO_ISR_CALLBACK

// ====================================================================
// === for System =====================================================
// ====================================================================

/* Move to ramAddr.h
#define USB_DEV_MAX       8 // 2003/7/5 B. S. Liaw 
                            // 2 RH * 2 HUB * 2 DEV
*/

#define USB_HUB_MAX       4 // 2003/7/5 B. S. Liaw 
							// RH 2 ports * 2 HUB
                            // External HUB 4 Ports

#define USB_DEV_IF_MAX    2 // 6 // 2003/7/5 B. S. Liaw

// #define USB_DEV_ED_MAX    (USB_DEV_IF_MAX*6) // 6 // 2003/7/5 B. S. Liaw
#define USB_DEV_ED_MAX      (USB_DEV_IF_MAX*10) // 2004/1/13 B. S. Liaw BugFix
												// Donot smaller than 8
							// It's better use Even value

#define USB_ED_TD_MAX   (USB_DEV_MAX*USB_DEV_ED_MAX*3)
						// 2003/7/5 B. S. Liaw
						// 3 : ED , Dummy TD , First TD 

// #undef USB_GLOBAL_EP // 2003/7/15 B. S. Liaw , Local EP

/*
#ifdef USB_GLOBAL_EP // 2003/7/15 B. S. Liaw
	#define USB_HCD_EP_MAX    ((USB_DEV_MAX-2)*USB_DEV_ED_MAX)
 #else
*/
	// #define USB_HCD_EP_MAX 32 // 2003/7/4 B. S. Liaw , move from UsbHcd
	// #define USB_HCD_EP_MAX    5 
	#define USB_HCD_EP_MAX    (USB_DEV_ED_MAX)
/*
#endif
*/

#if (_USB_MS >= 1)
	// USB_MC_S_MS : Usb Memory Cached Small size for Mass Storage
	// #define USB_MC_S_MS (100)
	#define USB_MC_S_MS    (50)
	// #define USB_MC_S_MS (20)     // for 8 Partitions
	// USB_MC_M_MS : Usb Memory Cached Medium size for Mass Storage
	#define USB_MC_M_MS    (20)
 #else
	#define USB_MC_S_MS (0)
	#define USB_MC_M_MS (0)
#endif

// USBMEM_C_S_SZ : Usb Memory Cached Small Size , Total
#define USBMEM_C_S_SZ (USB_S_MEM_BLOCK+USB_HUB_MAX*2+USB_MC_S_MS)
// USBMEM_C_M_SZ : Usb Memory Cached Medium Size , Total
#define USBMEM_C_M_SZ (USB_M_MEM_BLOCK+USB_HUB_MAX  +USB_MC_M_MS)

#ifndef USB_NO_DMA_POOL
	#define USB_DMAPOOL_L_MAX 7
 #else
	// #define USB_DMAPOOL_L_MAX 1
	// #define USB_DMAPOOL_L_MAX    (USB_HUB_MAX)
    #define USB_DMAPOOL_L_MAX       (USB_DEV_MAX*2)
#endif


#if defined(_S3C2510)
/*adai
    #ifdef INT_SCHEDULING
    	// #define USB_INT_SCHEDULING
	    #undef USB_INT_SCHEDULING
     #else
    	#undef USB_INT_SCHEDULING
    #endif // INT_SCHEDULING
*/
	#undef USB_INT_SCHEDULING
	#define USB_INT_ON_DEMAND // _S3C2510 only
	#undef USB_DMA_ON_DEMAND
#elif defined(_AR7300)
	#undef USB_INT_SCHEDULING
	#define USB_INT_ON_DEMAND
	#undef USB_DMA_ON_DEMAND
	#if defined(_USB2)
		/* bnchen */
	#else
		#define TNV105_INTBUG		/* Charles 20040414 */
	#endif
#elif defined(_ADM5120)
	// #define USB_INT_SCHEDULING
	#undef USB_INT_SCHEDULING
	#undef USB_INT_ON_DEMAND
	#define USB_DMA_ON_DEMAND // _ADM5120 only
	// #undef USB_DMA_ON_DEMAND
#elif defined(_ATHEROS)
	#undef USB_INT_SCHEDULING
	#define USB_INT_ON_DEMAND
	#undef USB_DMA_ON_DEMAND
	#if defined(_USB2)
		/* bnchen */
	#else
		#define TNV105_INTBUG		/* Charles 20040414 */
	#endif
#endif

// #define USB_RES_SEMPHORE    // use MT_RES_USB semphore

// #define USB_CRITICAL_SECTION // use BLOCK_PREEMPTION and
                                //     UNBLOCK_PREEMPTION pairs

#undef DEVNUM_ROUND_ROBIN // round_robin alloc of devnums 
	// Try to allocate the next devnum beginning at bus->devnum_next.
    // Normal undef it !!
    
// 2003/6/11 B. S. Liaw , BugFix for firmware upgrade time out
         // (30 sec) maybe need to tune USB_DLY_TSK_MS value !!
#define USB_WAIT_DLY_TSK   // use dlytsk() to replace YIELD()

#ifdef USB_WAIT_DLY_TSK
	// #define USB_DLY_TSK_MS   5 // dlytsk() 5 ms and more
	// #define USB_DLY_TSK_TICK  10 // dlytsk 10 ticks , Donot Set to 0 !!
	// #define USB_DLY_TSK_TICK  3 // dlytsk 3 ticks , Donot Set to 0 !!
	#define USB_DLY_TSK_TICK  1 // dlytsk 1 tick , Donot Set to 0 !!
#endif // USB_WAIT_DLY_TSK

#if (USB_DLY_TSK_TICK <=0)
    // Donot Set to 0 !!
	#error :  invalid USB_DLY_TSK_TICK value !!
#endif    

#define USB_NO_ABC // No usb_api_blocking_completion()

#define USB_NO_ISO

#if (_USB_MAC >= 1) // 2003/8/15 B. S. Liaw
	#define SOTA_SPEEDUP_FOR_MAC // 2003/10/31 B. S. Liaw
	// #undef SOTA_SPEEDUP_FOR_MAC // 2003/10/31 B. S. Liaw

	// #define USB_MEM_POOL_LARGE_CLEAR
	#undef USB_MEM_POOL_LARGE_CLEAR  // undef for speed-up !!
 #else
	#undef SOTA_SPEEDUP_FOR_MAC // 2003/10/31 B. S. Liaw

	#define USB_MEM_POOL_LARGE_CLEAR
	// #undef USB_MEM_POOL_LARGE_CLEAR  // undef for speed-up !!
#endif

// ====================================================================

// #ifdef OHCI_ED_SKEP_FIX
	#define OHCI_WAIT_SOF_TIMEOUT (50000) // unit : iteration times
										  // range : int
// #endif // OHCI_ED_SKEP_FIX   

#if defined(_S3C2510)
	#undef USB_MORE_DELAY  // e.g. : add some wait_ms(30) 
	// #define USB_MORE_DELAY  // e.g. : add some wait_ms(30) 
	#undef TIMEOUT_LOOSER_CHECK // e.g. : if (err != -EINPROGRESS)
	// #define TIMEOUT_LOOSER_CHECK // pass time out
#elif defined(_AR7300)
	#undef USB_MORE_DELAY  // e.g. : add some wait_ms(30) 
	#undef TIMEOUT_LOOSER_CHECK // e.g. : if (err != -EINPROGRESS)
#elif defined(_ADM5120)
	// #define USB_MORE_DELAY  // e.g. : add some wait_ms(30) 
	// #define TIMEOUT_LOOSER_CHECK // pass time out
    							//  e.g. : if (err != -EINPROGRESS)
#elif defined(_ATHEROS)
	#undef USB_MORE_DELAY  // e.g. : add some wait_ms(30) 
	#undef TIMEOUT_LOOSER_CHECK // e.g. : if (err != -EINPROGRESS)
#endif

#if defined(_S3C2510)
	#define HZ (3*CLOCKHZ)
#else
	// #define HZ 100
	#define HZ (CLOCKHZ)
	// #define   rt_osSecs2Ticks(t)               (t*100)
#endif

// #define TIME_FACTOR 3 // for delay wait_ms() MSECTOTICKS()
#define TIME_FACTOR 10 // for delay wait_ms() MSECTOTICKS()
#define TIME_PLUS   40 // for delay wait_ms() MSECTOTICKS()


#if defined(_S3C2510)
	#define TIMEOUT_FACTOR (1) // (3) // for time out check
                               // 10 : too large !!
#elif defined(_AR7300)
	#define TIMEOUT_FACTOR (1) // for time out check
#elif defined(_ADM5120)
	#define TIMEOUT_FACTOR (1) // for time out check
#elif defined(_ATHEROS)
	#define TIMEOUT_FACTOR (1) // for time out check
#endif

// 20003/7/1 B. S. Liaw , move from usb.h
/*
#ifndef _ETCPIP
	
	// #define USB_CTRL_GET_TIMEOUT	5
    
#else
*/
	/*
	#define USB_CTRL_GET_TIMEOUT	(20 * 1000 * TIMEOUT_FACTOR) // 7
	*/
	#define USB_CTRL_GET_TIMEOUT	(7)
/*
#endif
*/
/*
#ifndef _ETCPIP
	#define USB_CTRL_SET_TIMEOUT	  5
#else
*/
	/*
	#define USB_CTRL_SET_TIMEOUT	 (30 * 1000 * TIMEOUT_FACTOR) // 8
	*/
	#define USB_CTRL_SET_TIMEOUT	 (8)
/*
#endif
*/

// #ifdef _ETCPIP
#ifdef TIMEOUT_LOOSER_CHECK 
	// #define USB_CTRL_SETADDR_TIMEOUT  (5000 * 1000) // (120 * 1000)  // 10
	/*
	#define USB_CTRL_SETADDR_TIMEOUT  (50 * 1000 * TIMEOUT_FACTOR)  // 10
	*/
	#define USB_CTRL_SETADDR_TIMEOUT  (20)
 #else
	/*
	#define USB_CTRL_SETADDR_TIMEOUT  (40 * 1000 * TIMEOUT_FACTOR) // (40 * 1000)  // 10
    */
	#define USB_CTRL_SETADDR_TIMEOUT  (10)
#endif
// #define USB_PRE_TIMEOUT	      3
// #endif

// ====================================================================
// === for Memory Management ==========================================
// ====================================================================
// for Uncached pool
#define USB_MEM_U_S_SIZE    (128)  // 64
#define USB_MEM_U_M_SIZE    (512)  // 256
#define USB_MEM_U_L_SIZE    (8192) // 16384 // 32768
// #define USB_MEM_U_L_SIZE (4096) // for USBLP_BUF_SIZE change to 4096


// for cached memory
#define USB_MEM_C_S_SIZE    (128)
#define USB_MEM_C_M_SIZE    (512)

// #define USB_MEM_C_L_SIZE (8192) // for USBLP_BUF_SIZE is 8192
// #define USB_MEM_C_L_SIZE (4096) // for USBLP_BUF_SIZE change to 4096
#define USB_MEM_C_L_SIZE    (USB_MEM_U_L_SIZE)

// ====================================================================
// === for HCD ========================================================
// ====================================================================

#if defined(_S3C2510)
	#define OHCI_DOUBLE_EDRMLIST     // ed_rm_list[2]
	// #undef  OHCI_DOUBLE_EDRMLIST     // ed_rm_list

	// #define OHCI_NULL_PIPE_FIX // Donot Enable Now !!

	#define OHCI_BULK_TOGGLE_FIX
	#define OHCI_CTL_TOGGLE_FIX

	#define OHCI_BULK_BUFFERSIZE     (4096)	// 4096 byte buffer
	// #define OHCI_BULK_BUFFERSIZE  (1024)  // Donot Set this Now !!

	#undef OHCI_SECOND_RESET
	#ifdef OHCI_DOUBLE_EDRMLIST
		#define OHCI_ED_SKEP_FIX 
	#endif // OHCI_DOUBLE_EDRMLIST

#elif defined(_AR7300)
	#define OHCI_DOUBLE_EDRMLIST     // ed_rm_list[2]

	#define OHCI_BULK_TOGGLE_FIX
	#define OHCI_CTL_TOGGLE_FIX

	#define OHCI_BULK_BUFFERSIZE     (4096)	// 4096 byte buffer

	#undef OHCI_SECOND_RESET
	#ifdef OHCI_DOUBLE_EDRMLIST
		#define OHCI_ED_SKEP_FIX 
	#endif // OHCI_DOUBLE_EDRMLIST
#elif defined(_ATHEROS)
	#define OHCI_DOUBLE_EDRMLIST     // ed_rm_list[2]

	#define OHCI_BULK_TOGGLE_FIX
	#define OHCI_CTL_TOGGLE_FIX

	#define OHCI_BULK_BUFFERSIZE     (4096)	// 4096 byte buffer

	#undef OHCI_SECOND_RESET
	#ifdef OHCI_DOUBLE_EDRMLIST
		#define OHCI_ED_SKEP_FIX 
	#endif // OHCI_DOUBLE_EDRMLIST
#endif // _S3C2510

#if defined(_S3C2510)
	#ifdef OHCI_DOUBLE_EDRMLIST
		#define USB_NO_ISR_UNLINK
	#endif // OHCI_DOUBLE_EDRMLIST
#elif defined(_AR7300)
	#ifdef OHCI_DOUBLE_EDRMLIST
		#define USB_NO_ISR_UNLINK
	#endif // OHCI_DOUBLE_EDRMLIST
#elif defined(_ADM5120)
	#undef USB_NO_ISR_UNLINK  // for ADMTEK 5120 donot define !!
	// #define USB_NO_ISR_UNLINK // for ADMTEK 5120 this under Debug !!
#elif defined(_ATHEROS)
	#ifdef OHCI_DOUBLE_EDRMLIST
		#define USB_NO_ISR_UNLINK
	#endif // OHCI_DOUBLE_EDRMLIST
#endif // _S3C2510

#if (_USB2 == 1)			// VIA 6212 USB2.0 PCI
    #undef USB_OHCI
    #define USB_EHCI

	#define CONFIG_PCI
	#undef USB_ED_TD_ADDR_FIX
#elif defined(_S3C2510)
	#define USB_OHCI   // ss2510 use OHCI
	// 2003/6/18 B. S. LIaw , Move from UsOsport.h
	#define CONFIG_PCI
    #undef USB_NO_DUMMY_TD // 2003/7/2 B. S. Liaw 
                           //   OHCI need dummmy td
	#undef USB_ED_TD_ADDR_FIX 
	// #define USB_ED_TD_ADDR_FIX 
#elif defined(_AR7300)
	#define USB_OHCI   // ss2510 use OHCI
	#undef CONFIG_PCI
    #undef USB_NO_DUMMY_TD // 2003/7/2 B. S. Liaw 
                           //   OHCI need dummmy td
	#undef USB_ED_TD_ADDR_FIX 
#elif defined(_ADM5120)
    #undef USB_OHCI
    #define USB_SOTA   // Sota USB 1.1 Host
	// 2003/6/18 B. S. LIaw , Move from UsOsport.h
	#undef CONFIG_PCI // Not PCI or Glue !!
    
    // B. S. Liaw : Donot Try to enable this !! Why ??
    // #define USB_GLOBAL_EP // 2003/7/15 B. S. Liaw
    
    // #undef USB_NO_DUMMY_TD // 2003/7/2 B. S. Liaw 
    
    #define USB_NO_DUMMY_TD // 2003/7/2 B. S. Liaw
                            // SOTA donot need dummy td
	// #define USB_ED_TD_ADDR_FIX 
	#undef USB_ED_TD_ADDR_FIX 
    
	#define USB_CTL_TOGGLE    // control pipe use TD_T_TOGGLE
                              // This one Must Set !!

    // donot try to disable this !!
    #define USB_CTL_MORE_TD // add 1 td , so total 2 td at least
                              // This one Must Set !!
    
    // #define USB_NO_SW_DEQUEUE
	
    // #define USB_LASTTD_INT // TD_HBL_COMPLETE_INT_EN only on latst td
							  // Donot Define This !!
    
    // donot try to disable this !!
    #define USB_BULK_MORE_TD // add 1 td , so total 2 td at least
                              // This one Must Set !!
    // #define USB_RH_ISR
	#undef SOTA_SKIP_BY_CALL
	#define USB_TD_NO_LIST 

#elif defined(_ATHEROS)
	#define USB_OHCI   // ss2510 use OHCI
	#undef CONFIG_PCI
    #undef USB_NO_DUMMY_TD // 2003/7/2 B. S. Liaw 
                           //   OHCI need dummmy td
	#undef USB_ED_TD_ADDR_FIX 
#else
    #undef USB_OHCI
	// 2003/6/18 B. S. LIaw , Move from UsOsport.h
	#define CONFIG_PCI
#endif


#ifdef USB_SOTA   // Sota USB 1.1 Host
	// #define USB_SIMPLE_RH       // donot reset
    							// comment out Now !!
	#define	SOTA_RH_POTPGT_MS	1  // 100 // power on to power good time 
    							   // unit : ms
    #undef  SOTA_RH_SW_PORTCHANGE
	// #define SOTA_RH_LOCAL_ACTION   // auto enable if connected
    								// comment out Now !!
                                    // for default connected
	#define SOTA_HUB_BUGFIX
    #define SOTA_RH_RESET_WAIT_TIME  (1000)  // unit : times
	#define SOTA_IRQ_BUGFIX

	#if (_USB_MAC >=1) // 2003/8/15 B. S. Liaw
    	// #define SOTA_BUGFIX_MAC_HUB // 2003/10/21 B. S. Liaw
								// this lead to USBLPT print slow
								// so normal undef !!
        		// this under debug !!
    	#undef  SOTA_BUGFIX_MAC_HUB // 2003/10/21 B. S. Liaw

    	// #define SOTA_BUGFIX_MAC_BULKIN // 2003/10/23 B. S. Liaw
		#undef SOTA_BUGFIX_MAC_BULKIN // 2003/10/23 B. S. Liaw
     #else
    	#undef SOTA_BUGFIX_MAC_HUB // 2003/10/21 B. S. Liaw
		#undef SOTA_BUGFIX_MAC_BULKIN // 2003/10/23 B. S. Liaw
    #endif
	/*
	#undef SOTA_IRQ_BUGFIX_DELAY_ON // 2003/09/27 B. S. Liaw
	// #define SOTA_IRQ_BUGFIX_DELAY_ON // 2003/09/27 B. S. Liaw
	// donot undef SOTA_IRQ_BUGFIX_DELAY_ON !!

	#ifdef  SOTA_IRQ_BUGFIX_DELAY_ON

		// for x
		// 3000 : too long , system hang
		// 50 : too small , 100 : ok
		// #define SOTA_IRQ_PRE_DELAY      (1000) // unit : times
		// #define SOTA_IRQ_MID_DELAY      (1000) // (1000) // unit : times
		#ifdef SOTA_SPEEDUP_FOR_MAC // 2003/10/31 B. S. Liaw
			// 2003/11/04 B. S. Liaw , this is bottle neck for speed !!
			#define SOTA_IRQ_PRE_DELAY      (80) // unit : times
			#define SOTA_IRQ_MID_DELAY      (80) // unit : times
			#define SOTA_IRQ_POST_DELAY     (80) // unit : times
			#define SOTA_IRQ_CTLPIPE_DELAY  (80) // unit : times
		#else
			#define SOTA_IRQ_PRE_DELAY      (100) // (1000) // unit : times
			#define SOTA_IRQ_MID_DELAY      (100) // (1000) // unit : times
			#define SOTA_IRQ_POST_DELAY     (100) // (1000) // unit : times
			#define SOTA_IRQ_CTLPIPE_DELAY  (100) // (1000) // unit : times
						// 3000 : too long , system hang
		#endif
		// #define SOTA_IRQ_POST_DELAY     (1000) // (1000) // unit : times
		// #define SOTA_IRQ_CTLPIPE_DELAY  (1000) // unit : times

		// for y
		#define SOTA_IRQ_DELAY_FACTOR       (1000) // unit : times

	#endif // SOTA_IRQ_BUGFIX_DELAY_ON
	*/
	#undef  SOTA_ED_RING // 2003/09/27 B. S. Liaw
	#define USB_TD_END_NULL 
	#define SOTA_BULK_DATA_MAX_LEN (USB_MEM_U_L_SIZE) // 2004/2/4 B. S. Liaw

	/*
	#define SOTA_WAIT_SOF_TIMEOUT (50000) // unit : iteration times
	*/									  // range : int
	#define SOTA_IRQ_BUGFIX_WAIT_ON   // 2003/12/31 B. S. Liaw
	#define SOTA_IRQ_WAIT_DELAY     (3000) // unit : 1000 times

	// B. S. Liaw : why define USB_WAIT_BY_EVENT lead to slower ??
	// #define USB_WAIT_BY_EVENT     // 2003/12/31 B. S. Liaw

	#define SOTA_SOFT_ISR         // 2004/1/7 B. S. Liaw
						// define this avoid delay/wait loop in ISR !!

	// B. S. Liaw : why define USB_HC_WAIT_BY_EVENT lead to slower ??
	// #define USB_HC_WAIT_BY_EVENT  // 2003/1/7 B. S. Liaw
#endif // USB_SOTA


// ====================================================================
// ========== for Root/External HUB ===================================
// ====================================================================

// B. S. Liaw : why define USB_HUB_LOOP_EVENT lead to slower ??
// #define USB_HUB_LOOP_EVENT // 2004/1/4 B. S. Liaw

#ifdef USB_HUB_LOOP_EVENT // 2004/1/4 B. S. Liaw
	#define USB_HUB_PERIOD   2   // unit : second 
#endif // USB_HUB_LOOP_EVENT

#define HUB_SHORT_RESET_TIME	30
#define USB_HUB_MAX_PORTS  8

// ====================================================================
// ========== for USB External HUB ====================================
// ====================================================================
/*
#ifndef _ETCPIP
    
	// #define USB_HUB_TIMEOUT	  (HZ)
    
 #else
*/
#define USB_HUB_TIMEOUT   (20 * 1000 * TIMEOUT_FACTOR) // (50 * TIMEOUT_FACTOR) // (9 * 1000)
// #define USB_HUB_TIMEOUT	  (HZ)
/*
#endif
*/

#undef HUB_NO_INT_PIPE

// ====================================================================
// ========== for USB Root HUB ========================================
// ====================================================================

#if defined(_S3C2510)
	// #define USB_ALL_HUB_1_PORT // All HUB only check Port 1
	#define USB_RH_1_PORT  // Root Hub only enable Port 1 !!
#elif defined(_AR7300)
/*	#define USB_RH_1_PORT  // Root Hub only enable Port 1 !! *//* Charles 20040329 */
#elif defined(_ADM5120)
	// #define USB_ALL_HUB_1_PORT // All HUB only check Port 1
	// #define USB_RH_1_PORT  // Root Hub only enable Port 1 !!
#elif defined(_ATHEROS)
#endif

#define RH_INT_BY_POLL  // Root Hub use polling MT_RES_USB loop
						// to start Interrupt Pipe

#ifdef RH_INT_BY_POLL
	#define RH_WAITFREE_TIME 100000
#endif

#undef RH_POLL_TSK    // 2003/9/8 B. S. Liaw , use usb_rh_task
			// donot enable this , for has recursive function call !!
// #define RH_POLL_TSK

// ====================================================================
// ========== for USB MOUSE ===========================================
// ====================================================================

#define MOUSE_INT_BY_POLL  	// use polling MT_RES_USB loop
						// to start Interrupt Pipe


// ====================================================================
// ========== for USB LPT =============================================
// ====================================================================

#if (_USB_LPT >=1)

	#undef USBLPT_WAIT_FOR_ADSL

	#undef USBLPT_BIDIR // 2003/10/13 B. S. Liaw
	// #define USBLPT_BIDIR // 2003/10/13 B. S. Liaw

	// #undef USBLPT_INIT_STR    // 2003/10/13 B. S. Liaw
	#define USBLPT_INIT_STR    // 2003/10/13 B. S. Liaw

	#define USBLPT_RESET_CMD // 2003/10/14 B. S. Liaw
							// 2003/10/14 : Brother HL-5040 cannot reset

	#ifdef USBLPT_RESET_CMD // 2003/10/14 B. S. Liaw
	// #undef USBLPT_PROBE_RESET // 2003/10/13 B. S. Liaw
							// 2003/10/14 : Brother HL-5040 cannot reset
	#define USBLPT_PROBE_RESET // 2003/10/13 B. S. Liaw
	#endif // USBLPT_RESET_CMD


	/*
	#define USBLPT_INIT_DLY_TSK_TICK  (50) // 10 , dlytsk , Donot Set to 0 !!
	*/
	#define USBLPT_INIT_WAIT_MS (200) // Unit : MS

	#undef  USBLPT_READ_ON_PROBE     // 2003/10/02 B. S. Liaw
						// Normal undef for looser on other printers

	#if defined(_S3C2510)
		#define USBLPT_READ_NO_DELAY
		//#undef USBLPT_READ_NO_DELAY
	#elif defined(_AR7300)
		#define USBLPT_READ_NO_DELAY
	#elif defined(_ADM5120)
		#define USBLPT_READ_NO_DELAY
		// #undef USBLPT_READ_NO_DELAY
	#elif defined(_ATHEROS)
		#define USBLPT_READ_NO_DELAY
	#endif

	#ifndef USBLPT_READ_NO_DELAY
		#if defined(_S3C2510)
			#ifdef INT_SCHEDULING
				#define USBLPT_DLY_TSK_TICK  50 // dlytsk , Donot Set to 0 !!
		    #else
				// #define USBLPT_DLY_TSK_TICK  (3) // 20 // dlytsk , Donot Set to 0 !!
				// 3 + USBLPT_READ_BY_START_WAIT ok but too soon on hub
				#define USBLPT_DLY_TSK_TICK  (1)   // 1,2 too soon for hub !!
				// 3 + USBLPT_READ_BY_START_WAIT ok
	            // USBLPT_READ_BY_CHECK can use 1
		    #endif
		#elif defined(_AR7300)
				#define USBLPT_DLY_TSK_TICK  50 // dlytsk , Donot Set to 0 !!
		#elif defined(_ADM5120)
			#define USBLPT_DLY_TSK_TICK  (1) // 20 // dlytsk , Donot Set to 0 !!
						// ADM5120 : After Bulk Read , Need Delay !!
		#elif defined(_ATHEROS)
				#define USBLPT_DLY_TSK_TICK  50 // dlytsk , Donot Set to 0 !!
		#endif
	#endif // ndef USBLPT_READ_NO_DELAY

	#if defined(_S3C2510)
		#define USBLPT_READ_BEFORE_WRITE
		#define USBLPT_CHECK_BEFORE_WRITE
	#elif defined(_AR7300)
		#define USBLPT_READ_BEFORE_WRITE
		#define USBLPT_CHECK_BEFORE_WRITE
	#elif defined(_ADM5120)
		// #undef USBLPT_READ_BEFORE_WRITE // Since 2003/10/02 need undef
		#define USBLPT_READ_BEFORE_WRITE
		#define USBLPT_CHECK_BEFORE_WRITE // Prt_Check_Port_Pwr_Connect()
	#elif defined(_ATHEROS)
		#define USBLPT_READ_BEFORE_WRITE
		#define USBLPT_CHECK_BEFORE_WRITE
	#endif

	// ======= Select One Item !! ======
	#if defined(_S3C2510)
		#define USBLPT_READ_BY_CHECK     // ok for Epson Stylus CX5100
								// will discard read data !!
                                // 2510 use this to speed up !!
		#undef USBLPT_READ_BY_START_WAIT
                                // 2510 use this to speed up more !!
	#elif defined(_AR7300)
		#define USBLPT_READ_BY_CHECK     // ok for Epson Stylus CX5100
								// will discard read data !!
                                // 2510 use this to speed up !!
		#undef USBLPT_READ_BY_START_WAIT
                                // 2510 use this to speed up more !!
	#elif defined(_ADM5120)
		#define USBLPT_READ_BY_CHECK     // ok for Epson Stylus CX5100
								// will discard read data !!
    							// ADM5210 ok !!
		#undef USBLPT_READ_BY_START_WAIT // ok for Epson Stylus CX5100
    							// ADM5210 ok !!
	#elif defined(_ATHEROS)
		#define USBLPT_READ_BY_CHECK     // ok for Epson Stylus CX5100
								// will discard read data !!
                                // 2510 use this to speed up !!
		#undef USBLPT_READ_BY_START_WAIT
                                // 2510 use this to speed up more !!
	#endif

	#undef USBLPT_READ_BY_URBTASK
	// =================================
	/*
	#if defined(_S3C2510)
		#define USBLPT_TIMEOUT_FACT (1)
	#elif defined(_ADM5120)
		#define USBLPT_TIMEOUT_FACT (2)
	#endif
	*/
	// Not use long delay , so , value larger
	#define USBLPT_CTLMSG_TIMEOUT (10) // unit : second (300*1000)

	#define USBLPT_WRITE_TIMEOUT  (20) // unit : second
				// 10 seconds : too short for HP DeskJet 3650 !!
								// (1000*USBLPT_TIMEOUT_FACT)
								// (100*1000) // (20000)
								// 10*1000 : too long time !!
	#ifdef USBLPT_READ_BY_START_WAIT
	    #error: Please Donot Define USBLPT_READ_BY_START_WAIT !!
		#define USBLPT_READ_TIMEOUT  (3000) // (30*1000) // (3*10000)
	#else
		// Donot Need Now !!
		// #define USBLP_READ_TIMEOUT	 (300)
    #endif
	// 2003/10/08 B. S. Liaw BugFix, change to 4096
    //                  adm 5120 donot work on 8192
	// #define USBLP_BUF_SIZE		8192
	#define USBLPT_BUF_SIZE			4096
	// #define USBLP_BUF_SIZE		64 // 32 // 128
	#define USBLPT_DEVICE_ID_SIZE	1024

#endif // _USB_LPT

// ====================================================================
// ========== for USB MAC =============================================
// ====================================================================

// USB MAC Device is not Duplex , read/write can do only either one !!

#if (_USB_MAC >=1) // 2003/8/15 B. S. Liaw

	// ======= Select Only One or None Item !! ======
	/*
	#undef  USBMAC_READ_WDT    // 2003/10/20 B. S. Liaw
	#define USBMAC_WRITE_CANCEL_READ // 2003/10/20 B. S. Liaw
	*/
	/*
	#define USBMAC_READ_WDT    // 2003/10/20 B. S. Liaw
	#undef  USBMAC_WRITE_CANCEL_READ // 2003/10/20 B. S. Liaw
	*/
	// =================================

	#ifdef USBMAC_READ_WDT // 2003/10/20 B. S. Liaw
		#define USBMAC_READ_WDT_TIMEOUT  (10*1000) // unit : iteration
		#define USBMAC_READ_REST_TIME    (10*1000) // unit : iteration
	#endif // USBMAC_READ_WDT
	// #undef USBMAC_READ_SUBMIT

	#define USBMAC_READ_DEEP_NO_DELAY // for USB_DLY_TSK_TICK
	#define USBMAC_WRITE_DEEP_NO_DELAY // for USB_DLY_TSK_TICK

	#define USBMAC_READ_NO_DELAY

	#ifndef USBMAC_READ_NO_DELAY
		#define USBMAC_DLY_TSK_TICK  1 // 20 // dlytsk , Donot Set to 0 !!
	#endif // ndef USBMAC_READ_NO_DELAY
	/*
	#define SOTA_SPEEDUP_FOR_MAC // 2003/10/31 B. S. Liaw

	// #define USB_MEM_POOL_LARGE_CLEAR
	#undef USB_MEM_POOL_LARGE_CLEAR  // undef for speed-up !!
	*/

	#ifndef USBMAC_LAN_BRIDGE
	#ifndef USBMAC_WAN_ROUTER    // WAN Router mode
        	#error : Need Define one of USBMAC_LAN_BRIDGE/USBMAC_WAN_ROUTER !!
    #endif
    #endif
    
	#ifdef USBMAC_LAN_BRIDGE
	#ifdef USBMAC_WAN_ROUTER    // WAN Router mode
        	#error : Only one of USBMAC_LAN_BRIDGE/USBMAC_WAN_ROUTER can define !!
    #endif
    #endif
    
	// #define USBMAC_REWRITE_MAC_ADDR
	// MAC Address :  as WAN:   LAN+1 , so LAN+1
	// MAC Address :  as HWLAN: LAN+2 , so LAN+3

	#ifdef USBMAC_REWRITE_MAC_ADDR
		#ifdef USBMAC_LAN_BRIDGE
			#define USBMAC_LAN_MAC_ADDR    // use LAN MAC as bridge mode
					// ??? 2003/10/01 : donot define this 
					// ???      otherwise ping echo to LAN not to USBMAC
		#endif // USBMAC_LAN_BRIDGE
	#endif // USBMAC_REWRITE_MAC_ADDR
    
	#define USBMAC_SEND_NO_QUEUE   // not use ifp->hwflags
	#define USBMAC_SEND_RETRY      0 // (10000L) // unsigned long
								// 0 :  infinite wait !!

	// ======= Select Only One Item !! ======
	#undef  USBMAC_WRITE_BY_CHECK
	#define USBMAC_WRITE_BY_START_WAIT   // well for ping test
	/*
	#define USBMAC_WRITE_BY_CHECK
	#undef  USBMAC_WRITE_BY_START_WAIT   // well for ping test
	*/
	// =================================

	// ======= Select Only One Item !! ======
	
	#define USBMAC_READ_BY_CHECK     
	#undef  USBMAC_READ_BY_START_WAIT   // well for ping test
										// but donot use !!
	
	/*
	#undef  USBMAC_READ_BY_CHECK     
	#define USBMAC_READ_BY_START_WAIT   // well for ping test
	*/
	#undef  USBMAC_READ_BY_URBTASK
	// =================================

	// 2003/10/28 B. S. Liaw , 8192 --> 2048
	// #define USBMAC_BUF_SIZE		8192
	#define USBMAC_BUF_SIZE			2048

	#define USBMAC_DEVICE_ID_SIZE	1024

	// =================================

	#define USBMAC_CTLMSG_TIMEOUT   (300*1000) // (300000)	

	#define USBMAC_WRITE_TIMEOUT	(5) // unit : second 
									// (1000) // (100*1000) // (20000)

	// #define USBMAC_READ_TIMEOUT	(2*HZ)	  // 2 seconds
	// #define USBMAC_READ_TIMEOUT	(6000)	
	#define USBMAC_READ_TIMEOUT	    (3000) // (30*1000) // (3*10000)

#endif // _USB_MAC

// ====================================================================
// ========== for USB Mass Storage ====================================
// ====================================================================

#ifndef _USB_MS
	#define _USB_MS 0
#endif // ndef _USB_MS

// ====================================================================
// End of File : UsbCfg.h

