
// Name of File : UsbDbg.h
// ====================================================================

#ifndef __USB_DBG_H__
#define __USB_DBG_H__

// ====================================================================
#ifdef _NEWLIB
	#include "string.h"
#endif

// ====================================================================
// Macro for deciding whether to print a lot of 
// debugging information for USB .

#undef _CODE_TYPE_DEBUG 
//#define _CODE_TYPE_DEBUG

#ifdef _CODE_TYPE_DEBUG // 2003/01/24 B. S. Liaw
    
    // Turn On debug message Needed
    #define USB_CODE_TYPE_DEBUG // 2003/5/19 B. S. Liaw
    #define USB_BS_ASSERT
    
    /*
    // Turn Off all debug message and Turn On Debug Assert Only !!
    #undef USB_CODE_TYPE_DEBUG // 2003/5/19 B. S. Liaw
    #undef USB_DBG_MEM_AREA_VERIFY_ON
    #undef USB_BS_ASSERT
    */
 #else
    #undef USB_CODE_TYPE_DEBUG // 2003/5/19 B. S. Liaw
    #undef USB_DBG_MEM_AREA_VERIFY_ON
    #undef USB_BS_ASSERT
#endif // _CODE_TYPE_DEBUG // 2003/01/24 B. S. Liaw

// ====================================================================
// Macro for deciding whether to print a lot of 
// debugging information.

#ifdef USB_CODE_TYPE_DEBUG // 2003/01/24 B. S. Liaw
	#warning : USB Debug Message : ON !!

	 #define USB_DBG_INFO_ON
    
	// #define USB_DBG_INIT_ON

    // #define USB_DBG_PLUG_ON

    // #define USB_DBG_FLOW_ON
    // #define USB_DBG_FLOWLOOP_ON
    // #define USB_DBG_FLOWTIMCRY_ON // Time Crytical , No Show !!
    
    // #define USB_DBGSTRING_ON // for :
    // USB_DBGSTRING_ON : 
    //   char   *bus_name;   stable id (PCI slot_name etc) 
    //   char   devpath [16]; // Use in messages: /port/port/... 
    //   name ??
    //   product_desc
    //   usb_pci_pool_create()
    //             hcd_name
    //  const char          *description;   /* "ehci-hcd" etc */
    // &usb_dev->dev.bus_id[0]    
    
    // #define USB_DBG_MEM_ON
    // #define USB_DBG_MEMIRQ_ON
    
    // #define USB_DBG_MEM_COUNT_ON      // Normal Cached Memeory Pool
    // #define USB_DBG_MEM_C_ON      // Normal Cached Memeory Pool
    // #define USB_DBG_MEM_U_ON      // Uncached Memeory Pool
    
    // #define USB_DBG_REG_ON          // register address
   
    // #define USB_DBG_CALLBACK_ON
    
    // #define USB_DBG_TIMER_ON
    // #define USB_DBG_EVT_ON        // HUB Event
    // #define USB_DBG_EVTLOOP_ON    // HUB Event Loop
    
    // #define USB_DBG_IRQ_INFO_ON   // Show ISR Begin/End Only
    // #define USB_DBG_IRQ_ON        // Detail
	// #define USB_DBG_IRQ_WDH_INFO_ON    // Write Done Head , Begin/End Only
    // #define USB_DBG_IRQ_WDH_ON    // Write Done Head , TD processed
    
    // #define USB_DBG_ATTACH_ON
    
     //#define USB_DBG_URB_INFO_ON      // show data output
     //#define USB_DBG_URB_ON

     //#define USB_DBG_URBBULK_ON
     //#define USB_DBG_URBINT_ON

     //#define USB_DBG_PIPE_ON
//     #define USB_DBG_CTLMSG_ON
    
    // #define USB_DBG_HC_ON          // Host Controller
    // #define USB_DBG_ROOTHUB_ON     // Root Hub
    // #define USB_DBG_ROOTHUB_LOOP_ON

    // #define USB_DBG_HUB_ON     // HUB
    // #define USB_DBG_HUB_LOOP_ON     // HUB
    
     // #define USB_DBG_ED_ON      // Dump ED/TD data structure value
     // #define USB_DBG_EDTC_ON // Time Crytical , No Show !!
     // #define USB_DBG_TDMSG_ON
     // #define USB_DBG_TDMSGTC_ON // Time Crytical , No Show !!

//     #define USB_DBG_TDINT_ON
    
    // for show if USB_DBG_MEM_AREA_VERIFY_ON
//     #define USB_DBG_AREA_MSG_ON // for USB_DBG_MEM_AREA_VERIFY_ON
    
    // ============================= 
    #define USB_DEBUG_MSG       1  // 1: include message..
    // #define USB_DEBUG_MSG    0  //0: does not include message..

    #define CONFIG_USB_DEBUG
    #ifdef USB_DBG_INFO_ON
        #define OHCI_VERBOSE_DEBUG
    #endif
    //#define CONFIG_DEBUG_WAITQ
    //#define CONFIG_PCIPOOL_DEBUG
    // ===============================
    
	#if defined(_S3C2510)
	    //#define USB_DBG_MEM_AREA_VERIFY_ON
	#endif // _S3C2510
    // Debug Assert !!
    //#define USB_BS_ASSERT        
    //#define USB_BS_ASSERT_CACHE
    #ifdef USB_DBG_INIT_ON
		#define USB_BS_SYSCAL_ASSERT
	 #else
		#undef USB_BS_SYSCAL_ASSERT
		// #define USB_BS_SYSCAL_ASSERT
    #endif
    // ===============================
    // Specific Debug Code , normal off when no bug !!
    // #define USB_DBG_ABORT   // for debug Abort/Prefetch Error !!
    // #define USB_DBG_TEMP_DISABLE  // for debug Prefetch Error !!
    // ----------------------------------------------------------------
    // USB_DBG_SIMULTAE_VERIFY  : for Simuation and Verify
    //                            with actural value
    // #define USB_DBG_SIMULTAE_VERIFY
    // ----------------------------------------------------------------

 #else
   // #error : Not Turn Debug Message !!
   // #warning : USB Debug Message : OFF !!
#endif

// --------------------------------------------------------------------

#ifdef USB_DBG_INFO_ON
     #define USB_DBG_INFO(A) { A ; }
 #else
     #define USB_DBG_INFO(A)
#endif

#ifdef USB_DBG_PLUG_ON
     #define USB_DBG_PLUG(A) { A ; }
 #else
     #define USB_DBG_PLUG(A)
#endif

#ifdef USB_DBG_FLOW_ON
     #define USB_DBG_FLOW(A) { A ; }
 #else
     #define USB_DBG_FLOW(A)
#endif

#ifdef USB_DBG_FLOWLOOP_ON
     #define USB_DBG_FLOWLOOP(A) { A ; }
 #else
     #define USB_DBG_FLOWLOOP(A)
#endif

#ifdef USB_DBG_FLOWTIMCRY_ON
     #define USB_DBG_FLOWTIMCRY(A) { A ; }
 #else
     #define USB_DBG_FLOWTIMCRY(A)
#endif


#ifdef USB_DBG_INIT_ON
     #define USB_DBG_INIT(A) { A ; }
   #else
     #define USB_DBG_INIT(A)
#endif

#ifdef USB_DBG_MEM_ON
     #define USB_DBG_MEM(A) { A ; }
   #else
     #define USB_DBG_MEM(A)
#endif

#ifdef USB_DBG_MEMIRQ_ON
     #define USB_DBG_MEMIRQ(A) { A ; }
   #else
     #define USB_DBG_MEMIRQ(A)
#endif

#ifdef USB_DBG_MEM_U_ON
     #define USB_DBG_MEM_U(A) { A ; }
   #else
     #define USB_DBG_MEM_U(A)
#endif

#ifdef USB_DBG_MEM_C_ON
     #define USB_DBG_MEM_C(A) { A ; }
   #else
     #define USB_DBG_MEM_C(A)
#endif

#ifdef USB_DBG_REG_ON
     #define USB_DBG_REG(A) { A ; }
   #else
     #define USB_DBG_REG(A)
#endif

#ifdef USB_DBG_CALLBACK_ON
     #define USB_DBG_CALLBACK(A) { A ; }
   #else
     #define USB_DBG_CALLBACK(A)
#endif

#ifdef USB_DBG_TIMER_ON
     #define USB_DBG_TIMER(A) { A ; }
   #else
     #define USB_DBG_TIMER(A)
#endif

#ifdef USB_DBG_EVT_ON
     #define USB_DBG_EVT(A) { A ; }
   #else
     #define USB_DBG_EVT(A)
#endif

#ifdef USB_DBG_EVTLOOP_ON
     #define USB_DBG_EVTLOOP(A) { A ; }
   #else
     #define USB_DBG_EVTLOOP(A)
#endif

#ifdef USB_DBG_IRQ_ON
     #define USB_DBG_IRQ(A) { A ; }
   #else
     #define USB_DBG_IRQ(A)
#endif

#ifdef USB_DBG_IRQ_INFO_ON
     #define USB_DBG_IRQ_INFO(A) { A ; }
   #else
     #define USB_DBG_IRQ_INFO(A)
#endif

#ifdef USB_DBG_IRQ_WDH_INFO_ON
     #define USB_DBG_IRQ_WDH_INFO(A) { A ; }
   #else
     #define USB_DBG_IRQ_WDH_INFO(A)
#endif

#ifdef USB_DBG_IRQ_WDH_ON
     #define USB_DBG_IRQ_WDH(A) { A ; }
   #else
     #define USB_DBG_IRQ_WDH(A)
#endif

#ifdef USB_DBG_ATTACH_ON
     #define USB_DBG_ATTACH(A) { A ; }
   #else
     #define USB_DBG_ATTACH(A)
#endif

#ifdef USB_DBG_URB_INFO_ON
     #define USB_DBG_URB_INFO(A) { A ; }
   #else
     #define USB_DBG_URB_INFO(A)
#endif

#ifdef USB_DBG_URB_ON
     #define USB_DBG_URB(A) { A ; }
   #else
     #define USB_DBG_URB(A)
#endif

#ifdef USB_DBG_URBBULK_ON
     #define USB_DBG_URBBULK(A) { A ; }
   #else
     #define USB_DBG_URBBULK(A)
#endif

#ifdef USB_DBG_URBINT_ON
     #define USB_DBG_URBINT(A) { A ; }
   #else
     #define USB_DBG_URBINT(A)
#endif

#ifdef USB_DBG_PIPE_ON
     #define USB_DBG_PIPE(A) { A ; }
   #else
     #define USB_DBG_PIPE(A)
#endif

#ifdef USB_DBG_CTLMSG_ON
     #define USB_DBG_CTLMSG(A) { A ; }
   #else
     #define USB_DBG_CTLMSG(A)
#endif

#ifdef USB_DBG_HC_ON
     #define USB_DBG_HC(A) { A ; }
   #else
     #define USB_DBG_HC(A)
#endif

#ifdef USB_DBG_ROOTHUB_ON
     #define USB_DBG_ROOTHUB(A) { A ; }
   #else
     #define USB_DBG_ROOTHUB(A)
#endif

#ifdef USB_DBG_ROOTHUB_LOOP_ON
     #define USB_DBG_ROOTHUB_LOOP(A) { A ; }
   #else
     #define USB_DBG_ROOTHUB_LOOP(A)
#endif

#ifdef USB_DBG_HUB_ON
     #define USB_DBG_HUB(A) { A ; }
   #else
     #define USB_DBG_HUB(A)
#endif

#ifdef USB_DBG_HUB_LOOP_ON
     #define USB_DBG_HUB_LOOP(A) { A ; }
   #else
     #define USB_DBG_HUB_LOOP(A)
#endif

#ifdef USB_DBG_ED_ON
     #define USB_DBG_ED(A) { A ; }
   #else
     #define USB_DBG_ED(A)
#endif

#ifdef USB_DBG_EDTC_ON
     #define USB_DBGTC_ED(A) { A ; }
   #else
     #define USB_DBGTC_ED(A)
#endif

#ifdef USB_DBG_TDMSG_ON
     #define USB_DBG_TDMSG(A) { A ; }
   #else
     #define USB_DBG_TDMSG(A)
#endif

#ifdef USB_DBG_TDMSGTC_ON
     #define USB_DBG_TDMSGTC(A) { A ; }
   #else
     #define USB_DBG_TDMSGTC(A)
#endif

#ifdef USB_DBG_TDINT_ON
     #define USB_DBG_TDINT(A) { A ; }
   #else
     #define USB_DBG_TDINT(A)
#endif

#ifdef USB_DBG_AREA_MSG_ON
     #define USB_DBG_AREA_MSG(A) { A ; }
   #else
     #define USB_DBG_AREA_MSG(A)
#endif

// ====================================================================

#define USB_DUMP_DEFAULT  (0x0000     ) // buffer address
#define USB_DUMP_OFFSET   (0x0001 << 1) // offset from start of buffer
#define USB_DUMP_ASCII    (0x0001 << 2) // Show ASCII Char

// format : USB_DUMP_DEFAULT : memory address ,
//          USB_DUMP_OFFSET : offset
//          USB_DUMP_ASCII  : Show ASCII Char
extern void usb_DumpMem(unsigned char *bufptr, int size,
				unsigned int format) ;

#define USB_CURRENT_TICKS	(*((volatile unsigned int *)0xa8610c08))

// ====================================================================

#endif // ndef __USB_DBG_H__

// ====================================================================
// End of File : UsbDbg.h

