

// Name of File : UsbSysInit.h
// ====================================================================

#ifndef __USB_SYS_INIT_H__
#define __USB_SYS_INIT_H__

// ====================================================================

#ifndef _USB_MS
	#define _USB_MS 0
#endif // ndef _USB_MS

// ====================================================================


extern int usb_device_count ; // for enable ISR , >= 1 : enable ISR

extern  char usb_info_str[128] ; // for Web UI message 

// #ifdef _USB_SYSLOG
//    char usbsyslog_buf[128];
// #endif // _SYSLOG

// ====================================================================

#if defined(USB_INT_SCHEDULING) || defined(USB_INT_ON_DEMAND)
	extern void UsbEnableInt(void) ;
	extern void UsbDisableInt(void) ;
#endif // defined(USB_INT_SCHEDULING) || defined(USB_INT_ON_DEMAND)

#ifdef USB_DMA_ON_DEMAND
	extern void UsbEnableDma(void) ;
	extern void UsbDisableDma(void) ;
#endif // USB_DMA_ON_DEMAND

extern void UsbSysInit(void) ;

#ifdef _AR7300
	extern void VlynqSystemInit(void) ;
#endif

// #ifdef __USB_SYS_INIT_C__
extern int usb_hcd_init(void) ;
extern int usb_mouse_init(void) ;
extern int usblp_init(void) ;
extern int usbmac_io_init(void) ;
// #endif // __USB_SYS_INIT_C__

#ifdef USB_INT_SCHEDULING
	extern void usb_hcd_io_handler(void);
#endif // USB_INT_SCHEDULING

extern int SysVerifyMemArea(void) ; // for super task !! MTINIT.C

extern void BackUpMemArea(void) ;
extern int  VerifyMemArea(void) ;
extern void EnableIpRtVerify(void) ;

#ifdef USBLPT_WAIT_FOR_ADSL
	#error : Please Donot Define USBLPT_WAIT_FOR_ADSL !!
	#if defined(_S3C2510)
	#ifdef _ADSL
		extern int  volatile adsl_access ;
		extern int volatile usblpt_write ;
	#endif // _ADSL
	#endif // _S3C2510
#endif // USBLPT_WAIT_FOR_ADSL

#if (_USB_MS >= 1)
	extern void UsbMsInit(void) ; // on storage/UsbMsInit.c
	extern int usb_ms_unplug(void) ;
#endif // _USB_MS

// ====================================================================

#endif // ndef __USB_SYS_INIT_H__

// ====================================================================

// End of File : UsbSysInit.h
