
#ifndef USB_NO_DMA_POOL

#ifdef CONFIG_PCI
	#ifdef USB_DBGSTRING_ON
		struct pci_pool *usb_pci_pool_create (const char *name,
	    	struct pci_dev *dev,
			size_t size, size_t align, size_t allocation, int flags);
	 #else
		struct pci_pool *usb_pci_pool_create (
	    	struct pci_dev *dev,
			size_t size, size_t align, size_t allocation, int flags);
	#endif
    
    #define usb_dma_pool_create usb_pci_pool_create
    
 #else
 
	#ifdef USB_DBGSTRING_ON
		struct dma_pool *usb_dma_pool_create(const char *name,
			size_t size, size_t align, size_t allocation, int flags);
	 #else
		struct dma_pool *usb_dma_pool_create(
			size_t size, size_t align, size_t allocation, int flags);
	#endif
    
#endif

#ifdef CONFIG_PCI

	extern void usb_pci_pool_destroy(struct pci_pool *pool) ;
    
	#ifdef USB_NO_DMA_POOL
        /*
		extern void * usb_pci_pool_alloc( unsigned long *handle,
        				int size) ;
        */
	#else
		extern void *usb_pci_pool_alloc(struct pci_pool *pool,
		     int flags, dma_addr_t *handle) ;
	#endif
    
	#ifdef USB_NO_DMA_POOL
        /*
		extern void usb_pci_pool_free(void *vaddr);
        */
	#else
		extern void usb_pci_pool_free(struct pci_pool *pool, void *vaddr,
    		 dma_addr_t addr);
	#endif
             
	#define usb_dma_pool_destroy usb_pci_pool_destroy
	#define usb_dma_pool_alloc usb_pci_pool_alloc
	#define usb_dma_pool_free  usb_pci_pool_free
    #define dma_pool           pci_pool
    
 #else
 
	extern void usb_dma_pool_destroy (struct dma_pool *pool);
	extern void *usb_dma_pool_alloc (struct dma_pool *pool,
		     int flags, dma_addr_t *handle);
	extern void usb_dma_pool_free (struct dma_pool *pool, void *vaddr,
    		 dma_addr_t addr);
             
#endif

#endif // ndef USB_NO_DMA_POOL
