
// Name of File : usb.h
// ====================================================================


#ifndef __LINUX_USB_H
#define __LINUX_USB_H
// ====================================================================

#ifndef _ETCPIP
	#include <linux/mod_devicetable.h>
 #else
	#include "PoDevTab.h" // mod_devicetable.h
#endif

#ifndef _ETCPIP
    #include <linux/usb_ch9.h>
 #else
    #include "usb_ch9.h"
#endif

#define USB_MAJOR			180


#ifdef __KERNEL__

#ifndef _ETCPIP
#include <linux/config.h>
#endif
#ifndef _ETCPIP
    #include <linux/errno.h>        /* for -ENODEV */
 #else
	#include "PoErrno.h" // osport_errno.h
#endif
#ifndef _ETCPIP
    #include <linux/delay.h>	/* for mdelay() */
   #include <linux/interrupt.h>	/* for in_interrupt() */
#endif // ndef _ETCPIP
#ifndef _ETCPIP
    #include <linux/list.h>		/* for struct list_head */
 #else
   #include "PoList.h" // osport_list.h <linux/list.h>
#endif

#ifndef _ETCPIP
    #include <linux/device.h>	/* for struct device */
 #else
    #include "PoDevice.h" // osport_device.h
    #include "kdev_t.h"
#endif
#ifndef _ETCPIP
    #include <linux/fs.h>		/* for struct file_operations */
 #else
	/* // USB lower level donot need this !!
    #include "osport_fs.h" 
    */
#endif // ndef _ETCPIP
#ifndef _ETCPIP
    #include <linux/completion.h>	/* for struct completion */
    #include <linux/sched.h>	/* for current && schedule_timeout */
#endif // ndef _ETCPIP

//=====================================================================

#if defined(_AR5315)
// for Atheros 5315 with 240MHz
#define uSEC_TIMEOUT_LOOP		22
#else
// for AR7300 with 150MHz
#define uSEC_TIMEOUT_LOOP		5
#endif
// #ifdef _ETCPIP
static __inline__ void udelay(unsigned long usecs)
{
 // #ifdef WAIT_BY_LOOP
       unsigned int loop;
 // #endif
 unsigned long end_time;
   
 #ifdef USB_BS_ASSERT
		#warning : USB_BS_ASSERT : ON !!
		if(in_interrupt())
	       {
	        iprintf("[ASSERT][USB] You call udelay on interrupt !!\n") ;
	        iprintf("[ASSERT][USB] It's Better ISR donot use delay !!\n") ;
			iprintf("[ASSERT][USBLPT] Continue .. \n" ) ;
	       }
          /*
	      else
	       {
	        iprintf("[ASSERT][USB] You call udelay() , "
            		"please replace by wait_ms !!\n") ;
			iprintf("[ASSERT][USBLPT] Continue .. \n" ) ;
	       }
          */ 
	 #else
       /*
	   #error : Please Make Sure : Not USB_BS_ASSERT
       */
	   // #warning : USB_BS_ASSERT : OFF !!
 #endif // USB_BS_ASSERT
    
 // #ifdef WAIT_BY_LOOP
 for (loop=0 ; loop<usecs;loop++)
           {
            // for ( end_time = 0 ; end_time < 10 ; )
            for ( end_time = 0 ; end_time < uSEC_TIMEOUT_LOOP ; )
                {
                 end_time ++ ;
                 NULL ;
                }
            NULL ;
           }
     /*
     #else
       // #error : Please Make Sure , this cannot run on ISR !!
       
       end_time = GetTime()+usecs;
   
       while (end_time > GetTime())
          YIELD();
    #endif
    */
   }
// #endif



// #define mdelay(n) { udelay((n)*1000) ; }

#ifdef _ETCPIP
   static __inline__ void mdelay(unsigned long m_secs)
   {
	#ifdef USB_BS_ASSERT
		if(in_interrupt())
	       {
	        dprintf("[ASSERT][USB] You call mdelay on interrupt !!\n") ;
	        dprintf("[ASSERT][USB] It's Better ISR donot use delay !!\n") ;
			iprintf("[ASSERT][USBLPT] Continue .. \n" ) ;
	       }
	      else
	       {
	        iprintf("[ASSERT][USB] You call mdelay() , "
            		"please replace by wait_ms !!\n") ;
			iprintf("[ASSERT][USBLPT] Continue .. \n" ) ;
	       } 
     #else
       // #error : Please Make Sure !!
	#endif // USB_BS_ASSERT
	udelay((m_secs)*1000) ;
   }
#endif


#ifndef NO_TIMER
   // #define mdelay(n) wait_ms(n)
   // may be < 1 , so , need plus 1
   // #define mdelay(msecs)  dlytsk(cur_task, DLY_TICKS, MSECTOTICKS(msecs)+1)
#endif // ndef NO_TIMER
/*
#define MSECTOTICKS(msecs) (unsigned long)(((unsigned long)msecs*CLOCKHZ)/1000)
#define SEC_TO_TICKS(secs) (unsigned long)((unsigned long)secs*CLOCKHZ)
#define   rt_osSecs2Ticks(t)               (t*100)
// #define   rt_osSecs2Ticks(time) 1000*(MSECTOTICKS(time))
#define   rt_osSecs2Ticks(time) (SEC_TO_TICKS(time))
*/

//=====================================================================

// #ifndef _ETCPIP
// #ifndef NO_TIMER
   static __inline__ void wait_ms(unsigned int ms)
   {
	// #ifndef USB_INT_SCHEDULING
	#ifdef USB_BS_ASSERT
		if(in_interrupt())
	       {
	        iprintf("[ASSERT][USB] You call wait_ms on interrupt !!\n") ;
	        iprintf("[ASSERT][USB] It's Better ISR donot use delay !!\n") ;
            iprintf("[ASSERT][USB] Anyway, please use mdelay \n") ;
			iprintf("[ASSERT][USB] Continue .. \n" ) ;
	       }
           /*
	      else
	       {
	        iprintf("[ASSERT][USB] You call wait_ms() , "
            		"please replace by wait_ms !!\n") ;
			iprintf("[ASSERT][USBLPT] Continue .. \n" ) ;
	       } 
           */
     #else
       // #error : Please Make Sure !!
	#endif // USB_BS_ASSERT
	// #endif // ndef USB_INT_SCHEDULING
    /*
	if(!in_interrupt())
    */
      {
		/*
       #ifndef _ETCPIP
		  current->state = TASK_UNINTERRUPTIBLE;
       #endif
		*/
	   // schedule_timeout(1 + ms * HZ / 1000);
       // dlytsk(cur_task, DLY_SECS, sec);
       // DELAYMS(ms);           
       // mdelay(ms) ;
       
       // #define   rt_osSecs2Ticks(t)   (t*100)
       
       /*

		USB_DBG_INIT(iprintf(
			"[USB INIT] wait_ms() : MSECTOTICKS(ms) = %d \n",
			MSECTOTICKS(ms)
			));
            
       // dlytsk(cur_task, DLY_TICKS, MSECTOTICKS(ms)+1) ;
       
       USB_DBG_INIT(iprintf(
			"[USB INIT] wait_ms() : MSECTOTICKS(ms*TIME_FACTOR)+1+TIME_PLUS = %d \n",
			MSECTOTICKS(ms*TIME_FACTOR)+1+TIME_PLUS
			));
       */
            
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
       // add 1 for no zero !!     
       dlytsk(cur_task, DLY_TICKS, MSECTOTICKS(ms*TIME_FACTOR)
       								+1+TIME_PLUS) ;

	  }
     /* 
	 else
      {
		// mdelay(ms);
        // dlytsk(cur_task, DLY_SECS, sec);
       // #define DELAYMS(msecs)    dlytsk(cur_task, DLY_TICKS, MSECTOTICKS(msecs))
       // #define DELAYTK(tick)     dlytsk(cur_task, DLY_TICKS, tick)

       // DELAYMS(ms);           
       mdelay(ms) ;
     }
    */
   }
 /*
 #else
   #error : Please Make Sure : NO_TIMER
   // wait t msec 
   
   // void WaitMSec(unsigned long delay_time)
   static __inline__ void wait_ms(unsigned int ms)
   {
    #ifdef WAIT_BY_LOOP
       unsigned int loop;
    #endif
    unsigned long end_time;
   
    // #ifdef _BOOT_LOADER
    #ifdef WAIT_BY_LOOP
       #error : Please Make Sure , this use loop !!
       for (loop=0 ; loop<ms;loop++)
           {
            for ( end_time = 0 ; end_time < 10000 ; )
                {
                 end_time ++ ;
                 NULL ;
                }
           }
     #else
       // #error : Please Make Sure , this cannot run on ISR !!
       // GetTime() unit : ms
       end_time = GetTime()+ (unsigned long)ms;
       dprintf("[WAIT] end_time = %08XH\n",end_time) ;
       while (end_time > GetTime())
          {
           dprintf("[WAIT] GetTime() = %08XH\n",GetTime()) ;
			#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, 
                		MSECTOTICKS(USB_DLY_TSK_MS*TIME_FACTOR)
                        +1+TIME_PLUS) ;
             #else
                #error : Please Make Sure !!
            	YIELD();
            #endif
          }
    #endif
   }
   
#endif
*/

// #define mdelay(n) wait_ms(n)

static inline void wait_sec(unsigned int sec)
{
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_sec() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
 dlytsk(cur_task, DLY_SECS, sec);
}

static inline int sleep(int sec)
{
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] sleep() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
 dlytsk(cur_task, DLY_SECS, sec);
}


// #define sleep(sec) dlytsk(cur_task, DLY_SECS, sec)

//=====================================================================

#ifdef NO_SYS_FS
/*
	#define USB_MAXBUS		64

	struct usb_busmap {
		unsigned long busmap[USB_MAXBUS / (8*sizeof(unsigned long))];
	};
*/
#endif // NO_SYS_FS

//=====================================================================

struct usb_device;

/*-------------------------------------------------------------------------*/

/*
 * Host-side wrappers for standard USB descriptors ... these are parsed
 * from the data provided by devices.  Parsing turns them from a flat
 * sequence of descriptors into a hierarchy:
 *
 *  - devices have one (usually) or more configs;
 *  - configs have one (often) or more interfaces;
 *  - interfaces have one (usually) or more settings;
 *  - each interface setting has zero or (usually) more endpoints.
 *
 * And there might be other descriptors mixed in with those.
 *
 * Devices may also have class-specific or vendor-specific descriptors.
 */

/* host-side wrapper for parsed endpoint descriptors */
struct usb_host_endpoint {
	struct usb_endpoint_descriptor	desc;

   	unsigned char *extra;   /* Extra descriptors */
	int extralen;
};

/* host-side wrapper for one interface setting's parsed descriptors */
struct usb_host_interface {
	struct usb_interface_descriptor	desc;

	/* array of desc.bNumEndpoint endpoints associated with this
	 * interface setting.  these will be in no particular order.
	 */
	struct usb_host_endpoint *endpoint;

	unsigned char *extra;   /* Extra descriptors */
	int extralen;
};

/**
 * struct usb_interface - what usb device drivers talk to
 * @altsetting: array of interface descriptors, one for each alternate
 * 	setting that may be selected.  each one includes a set of
 * 	endpoint configurations.
 * @num_altsetting: number of altsettings defined.
 * @act_altsetting: index of current altsetting.  this number is always
 *	less than num_altsetting.  after the device is configured, each
 *	interface uses its default setting of zero.
 * @dev: driver model's view of this device
 *
 * USB device drivers attach to interfaces on a physical device.  Each
 * interface encapsulates a single high level function, such as feeding
 * an audio stream to a speaker or reporting a change in a volume control.
 * Many USB devices only have one interface.  The protocol used to talk to
 * an interface's endpoints can be defined in a usb "class" specification,
 * or by a product's vendor.  The (default) control endpoint is part of
 * every interface, but is never listed among the interface's descriptors.
 *
 * The driver that is bound to the interface can use standard driver model
 * calls such as dev_get_drvdata() on the dev member of this structure.
 *
 * Each interface may have alternate settings.  The initial configuration
 * of a device sets the first of these, but the device driver can change
 * that setting using usb_set_interface().  Alternate settings are often
 * used to control the the use of periodic endpoints, such as by having
 * different endpoints use different amounts of reserved USB bandwidth.
 * All standards-conformant USB devices that use isochronous endpoints
 * will use them in non-default settings.
 */
struct usb_interface {
 /* array of alternate settings for this interface.
  * these will be in numeric order, 0..num_altsettting
  */
 struct usb_host_interface *altsetting;

 unsigned act_altsetting;	/* active alternate setting */
 unsigned num_altsetting;	/* number of alternate settings */
 unsigned max_altsetting;	/* total memory allocated */
 
 struct usb_driver *driver;	/* driver */
 kdev_t kdev;			/* node this interface is bound to */
 struct device dev;		/* interface specific device info */
};

#define	to_usb_interface(d) container_of(d, struct usb_interface, dev)
#define	interface_to_usbdev(intf) \
	container_of(intf->dev.parent, struct usb_device, dev)

static inline void *usb_get_intfdata (struct usb_interface *intf)
{
 return dev_get_drvdata(&intf->dev);
}

static inline void usb_set_intfdata (struct usb_interface *intf,
									 void *data)
{
 return dev_set_drvdata(&intf->dev, data);
}

/* USB_DT_CONFIG: Configuration descriptor information.
 *
 * USB_DT_OTHER_SPEED_CONFIG is the same descriptor, except that the
 * descriptor type is different.  Highspeed-capable devices can look
 * different depending on what speed they're currently running.  Only
 * devices with a USB_DT_DEVICE_QUALIFIER have an OTHER_SPEED_CONFIG.
 */
struct usb_host_config {
	struct usb_config_descriptor	desc;

	/* the interfaces associated with this configuration
	 * these will be in numeric order, 0..desc.bNumInterfaces
	 */
	struct usb_interface *interface;

   	unsigned char *extra;   /* Extra descriptors */
	int extralen;
};

// FIXME remove; exported only for drivers/usb/misc/auserwald.c
// prefer usb_device->epnum[0..31]
extern struct usb_endpoint_descriptor *
	usb_epnum_to_ep_desc(struct usb_device *dev, unsigned epnum);

int __usb_get_extra_descriptor(char *buffer, unsigned size,
	unsigned char type, void **ptr);
#define usb_get_extra_descriptor(ifpoint,type,ptr)\
	__usb_get_extra_descriptor((ifpoint)->extra,(ifpoint)->extralen,\
		type,(void**)ptr)

/* -------------------------------------------------------------------------- */

struct usb_operations;
/*
 * USB device number allocation bitmap. There's one bitmap
 * per USB tree.
 */

/* USB device number allocation bitmap */
struct usb_devmap {
	unsigned long devicemap[128 / (8*sizeof(unsigned long))];
   };

/*
 * Allocated per bus (tree of devices) we have:
 */
struct usb_bus {
 struct device *controller;	/* host/master side hardware */
 int busnum;			/* Bus number (in order of reg) */
 #ifdef USB_DBGSTRING_ON
	char *bus_name;			/* stable id (PCI slot_name etc) */
 #endif // USB_DBGSTRING_ON

 int devnum_next;		/* Next open device number in round-robin allocation */

 struct usb_devmap devmap;	/* device address allocation map */
 struct usb_operations *op;	/* Operations (specific to the HC) */
 struct usb_device *root_hub;	/* Root hub */
 struct list_head bus_list;	/* list of busses */
 void *hcpriv_hcd;          /* Host Controller private data */

 int bandwidth_allocated;	/* on this bus: how much of the time
					 * reserved for periodic (intr/iso)
					 * requests is used, on average?
					 * Units: microseconds/frame.
					 * Limits: Full/low speed reserve 90%,
					 * while high speed reserves 80%.
					 */
 int bandwidth_int_reqs;		/* number of Interrupt requests */
 int bandwidth_isoc_reqs;	/* number of Isoc. requests */

 struct dentry *usbfs_dentry;	/* usbfs dentry entry for the bus */
 struct dentry *usbdevfs_dentry;	/* usbdevfs dentry entry for the bus */
 /*
 #ifndef _ETCPIP
 */
	atomic_t refcnt;
 /*
  #else
	int refcnt;
 #endif
 */
};


/* -------------------------------------------------------------------------- */

/* This is arbitrary.
 * From USB 2.0 spec Table 11-13, offset 7, a hub can
 * have up to 255 ports. The most yet reported is 10.
 */
#define USB_MAXCHILDREN		(16)

struct usb_tt;

struct usb_device {
 int		devnum;		/* Address on USB bus */

 struct usb_device *hub_usb_device ; // now , root hub
 struct usb_hub    *hub ; 
 int	           hub_port ;     // Attached on root hub port 

 #ifdef USB_DBGSTRING_ON
	char		devpath [16];	/* Use in messages: /port/port/... */
 #endif // USB_DBGSTRING_ON
 enum usb_device_state	state;	/* configured, not attached, etc */
 enum usb_device_speed	speed;	/* high/full/low (or error) */

 struct usb_tt	*tt; 		/* low/full speed dev, highspeed hub */
 int		ttport;		/* device port on that tt hub */

 #ifndef NO_SEMPHORE
	struct semaphore serialize;
 #endif // ndef NO_SEMPHORE

 unsigned int toggle[2];		/* one bit for each endpoint ([0] = IN, [1] = OUT) */
 unsigned int halted[2];		/* endpoint halts; one bit per endpoint # & direction; */
					/* [0] = IN, [1] = OUT */
 int epmaxpacketin[16];		/* INput endpoint specific maximums */
 int epmaxpacketout[16];		/* OUTput endpoint specific maximums */

 struct usb_device *parent;	/* our hub, unless we're the root */
 struct usb_bus *bus;		/* Bus we're part of */

 struct device dev;		/* Generic device interface */

 struct usb_device_descriptor descriptor;/* Descriptor */
 struct usb_host_config *config;	/* All of the configs */
 struct usb_host_config *actconfig;/* the active configuration */

 char **rawdescriptors;		/* Raw descriptors for each config */

 int have_langid;		/* whether string_langid is valid yet */
 int string_langid;		/* language ID for strings */

 void *hcpriv;			/* Host Controller private data */

 struct list_head filelist;
 struct dentry *usbfs_dentry;	/* usbfs dentry entry for the device */
 struct dentry *usbdevfs_dentry;	/* usbdevfs dentry entry for the device */

 /*
  * Child devices - these can be either new devices
  * (if this is a hub device), or different instances
  * of this same device.
  *
  * Each instance needs its own set of data structures.
  */

 int maxchild;			/* Number of ports if hub */
 struct usb_device *children[USB_MAXCHILDREN];
 int sw_unplug[USB_MAXCHILDREN];  /* Charles 20040429 */
};
#define	to_usb_device(d) container_of(d, struct usb_device, dev)

extern struct usb_device *usb_alloc_dev(struct usb_device *parent, struct usb_bus *);
extern struct usb_device *usb_get_dev(struct usb_device *dev);
extern void usb_put_dev(struct usb_device *dev);

/* mostly for devices emulating SCSI over USB */
extern int usb_reset_device(struct usb_device *dev);

/* for drivers using iso endpoints */
extern int usb_get_current_frame_number (struct usb_device *usb_dev);

/* used these for multi-interface device registration */
/*
extern void usb_driver_claim_interface(struct usb_driver *driver,
			struct usb_interface *iface, void* priv);
*/
extern void usb_driver_claim_interface(struct usb_driver *driver,
			struct usb_interface *iface );
            
extern int usb_interface_claimed(struct usb_interface *iface);
extern void usb_driver_release_interface(struct usb_driver *driver,
			struct usb_interface *iface);
// #ifndef NO_SYS_FS
const struct usb_device_id *usb_match_id(struct usb_interface *interface,
					 const struct usb_device_id *id);
//#else
//const struct usb_device_id *
//usb_match_id(struct usb_device *dev, struct usb_interface *interface,
//	     const struct usb_device_id *id) ;
//#endif
extern struct usb_interface *usb_find_interface(struct usb_driver *drv, kdev_t kdev);
extern struct usb_interface *usb_ifnum_to_if(struct usb_device *dev, unsigned ifnum);


/**
 * usb_make_path - returns stable device path in the usb tree
 * @dev: the device whose path is being constructed
 * @buf: where to put the string
 * @size: how big is "buf"?
 *
 * Returns length of the string (> 0) or negative if size was too small.
 *
 * This identifier is intended to be "stable", reflecting physical paths in
 * hardware such as physical bus addresses for host controllers or ports on
 * USB hubs.  That makes it stay the same until systems are physically
 * reconfigured, by re-cabling a tree of USB devices or by moving USB host
 * controllers.  Adding and removing devices, including virtual root hubs
 * in host controller driver modules, does not change these path identifers;
 * neither does rebooting or re-enumerating.  These are more useful identifiers
 * than changeable ("unstable") ones like bus numbers or device addresses.
 *
 * With a partial exception for devices connected to USB 2.0 root hubs, these
 * identifiers are also predictable.  So long as the device tree isn't changed,
 * plugging any USB device into a given hub port always gives it the same path.
 * Because of the use of "companion" controllers, devices connected to ports on
 * USB 2.0 root hubs (EHCI host controllers) will get one path ID if they are
 * high speed, and a different one if they are full or low speed.
 */
#ifdef USB_DBGSTRING_ON
#ifndef USB_NO_LIB
static inline int usb_make_path (struct usb_device *dev, char *buf, size_t size)
{
 int actual;
 
 actual = snprintf (buf, size, "usb-%s-%s", dev->bus->bus_name, dev->devpath);
 return (actual >= size) ? -1 : actual;
}
#endif // ndef USB_NO_LIB
#endif // USB_DBGSTRING_ON

/*-------------------------------------------------------------------------*/

#define USB_DEVICE_ID_MATCH_DEVICE		(USB_DEVICE_ID_MATCH_VENDOR | USB_DEVICE_ID_MATCH_PRODUCT)
#define USB_DEVICE_ID_MATCH_DEV_RANGE		(USB_DEVICE_ID_MATCH_DEV_LO | USB_DEVICE_ID_MATCH_DEV_HI)
#define USB_DEVICE_ID_MATCH_DEVICE_AND_VERSION	(USB_DEVICE_ID_MATCH_DEVICE | USB_DEVICE_ID_MATCH_DEV_RANGE)
#define USB_DEVICE_ID_MATCH_DEV_INFO \
	(USB_DEVICE_ID_MATCH_DEV_CLASS | USB_DEVICE_ID_MATCH_DEV_SUBCLASS | USB_DEVICE_ID_MATCH_DEV_PROTOCOL)
#define USB_DEVICE_ID_MATCH_INT_INFO \
	(USB_DEVICE_ID_MATCH_INT_CLASS | USB_DEVICE_ID_MATCH_INT_SUBCLASS | USB_DEVICE_ID_MATCH_INT_PROTOCOL)

/**
 * USB_DEVICE - macro used to describe a specific usb device
 * @vend: the 16 bit USB Vendor ID
 * @prod: the 16 bit USB Product ID
 *
 * This macro is used to create a struct usb_device_id that matches a
 * specific device.
 */
#define USB_DEVICE(vend,prod) \
	.match_flags = USB_DEVICE_ID_MATCH_DEVICE, .idVendor = (vend), .idProduct = (prod)
/**
 * USB_DEVICE_VER - macro used to describe a specific usb device with a version range
 * @vend: the 16 bit USB Vendor ID
 * @prod: the 16 bit USB Product ID
 * @lo: the bcdDevice_lo value
 * @hi: the bcdDevice_hi value
 *
 * This macro is used to create a struct usb_device_id that matches a
 * specific device, with a version range.
 */
#define USB_DEVICE_VER(vend,prod,lo,hi) \
	.match_flags = USB_DEVICE_ID_MATCH_DEVICE_AND_VERSION, .idVendor = (vend), .idProduct = (prod), .bcdDevice_lo = (lo), .bcdDevice_hi = (hi)

/**
 * USB_DEVICE_INFO - macro used to describe a class of usb devices
 * @cl: bDeviceClass value
 * @sc: bDeviceSubClass value
 * @pr: bDeviceProtocol value
 *
 * This macro is used to create a struct usb_device_id that matches a
 * specific class of devices.
 */
#define USB_DEVICE_INFO(cl,sc,pr) \
	.match_flags = USB_DEVICE_ID_MATCH_DEV_INFO, .bDeviceClass = (cl), .bDeviceSubClass = (sc), .bDeviceProtocol = (pr)

/**
 * USB_INTERFACE_INFO - macro used to describe a class of usb interfaces 
 * @cl: bInterfaceClass value
 * @sc: bInterfaceSubClass value
 * @pr: bInterfaceProtocol value
 *
 * This macro is used to create a struct usb_device_id that matches a
 * specific class of interfaces.
	 */
#define USB_INTERFACE_INFO(cl,sc,pr) \
	.match_flags = USB_DEVICE_ID_MATCH_INT_INFO, .bInterfaceClass = (cl), .bInterfaceSubClass = (sc), .bInterfaceProtocol = (pr)

/* -------------------------------------------------------------------------- */

/**
 * struct usb_driver - identifies USB driver to usbcore
 * @owner: Pointer to the module owner of this driver; initialize
 *	it using THIS_MODULE.
 * @name: The driver name should be unique among USB drivers,
 *	and should normally be the same as the module name.
 * @probe: Called to see if the driver is willing to manage a particular
 *	interface on a device.  If it is, probe returns zero and uses
 *	dev_set_drvdata() to associate driver-specific data with the
 *	interface.  It may also use usb_set_interface() to specify the
 *	appropriate altsetting.  If unwilling to manage the interface,
 *	return a negative errno value.
 * @disconnect: Called when the interface is no longer accessible, usually
 *	because its device has been (or is being) disconnected or the
 *	driver module is being unloaded.
 * @ioctl: Used for drivers that want to talk to userspace through
 *	the "usbfs" filesystem.  This lets devices provide ways to
 *	expose information to user space regardless of where they
 *	do (or don't) show up otherwise in the filesystem.
 * @id_table: USB drivers use ID table to support hotplugging.
 *	Export this with MODULE_DEVICE_TABLE(usb,...).  This must be set
 *	or your driver's probe function will never get called. 
 *
 * USB drivers must provide a name, probe() and disconnect() methods,
 * and an id_table.  Other driver fields are optional.
 *
 * The id_table is used in hotplugging.  It holds a set of descriptors,
 * and specialized data may be associated with each entry.  That table
 * is used by both user and kernel mode hotplugging support.
 *
 * The probe() and disconnect() methods are called in a context where
 * they can sleep, but they should avoid abusing the privilege.  Most
 * work to connect to a device should be done when the device is opened,
 * and undone at the last close.  The disconnect code needs to address
 * concurrency issues with respect to open() and close() methods, as
 * well as forcing all pending I/O requests to complete (by unlinking
 * them as necessary, and blocking until the unlinks complete).
	 */
struct usb_driver {
 struct module *owner;

 #ifdef USB_DBGSTRING_ON
	const char *name;
 #endif // USB_DBGSTRING_ON

 int (*usbdev_probe) (struct usb_interface *intf,
		      const struct usb_device_id *id);

 void (*disconnect) (struct usb_interface *intf);

 int (*ioctl) (struct usb_interface *intf, unsigned int code, void *buf);
 #ifdef NO_SYS_FS
	struct list_head driver_list;

	struct file_operations *fops;
	int minor;

 #endif // NO_SYS_FS

 /* support for "new-style" USB hotplugging
  * binding policy can be driven from user mode too
  */
 const struct usb_device_id *id_table;

 struct device_driver driver;
	

 
 #ifndef NO_SEMPHORE
	struct semaphore serialize;
 #endif // ndef NO_SEMPHORE
};
#define	to_usb_driver(d) container_of(d, struct usb_driver, driver)

extern struct bus_type usb_bus_type;

/*
 * use these in module_init()/module_exit()
 * and don't forget MODULE_DEVICE_TABLE(usb, ...)
 */
extern int usb_register(struct usb_driver *);
extern void usb_deregister(struct usb_driver *);

#ifdef CONFIG_USB_DEVICEFS
	extern int usb_register_dev(struct file_operations *fops, int minor, int num_minors, int *start_minor);
#endif // CONFIG_USB_DEVICEFS
#ifndef _ETCPIP
	extern void usb_deregister_dev(int num_minors, int start_minor);
#endif // ndef _ETCPIP

extern int usb_device_probe(struct device *dev);
extern int usb_device_remove(struct device *dev);
extern int usb_disabled(void);

/* -------------------------------------------------------------------------- */
	
/*
 * URB support, for asynchronous request completions
 */

/*
 * urb->transfer_flags:
 */
#define URB_SHORT_NOT_OK	0x0001	/* report short reads as errors */
#define URB_ISO_ASAP		0x0002	/* iso-only, urb->start_frame ignored */
#define URB_NO_DMA_MAP		0x0004	/* urb->*_dma are valid on submit */
#define URB_ASYNC_UNLINK	0x0008	/* usb_unlink_urb() returns asap */
#define URB_NO_FSBR		0x0020	/* UHCI-specific */
#define URB_ZERO_PACKET		0x0040	/* Finish bulk OUTs with short packet */
#define URB_NO_INTERRUPT	0x0080	/* HINT: no non-error interrupt needed */
#define URB_TIMEOUT_KILLED      0x1000  // only set by HCD!

struct usb_iso_packet_descriptor {
	unsigned int offset;
	unsigned int length;		/* expected length */
	unsigned int actual_length;
	unsigned int status;
};

struct urb;
struct pt_regs;

#ifndef _ETCPIP
	/*
	typedef void (*usb_complete_t)(struct urb *, struct pt_regs *);
    */
 #else
	typedef void (*usb_callback_t)(struct urb *);
#endif
/**
 * struct urb - USB Request Block
 * @urb_list: For use by current owner of the URB.
 * @pipe: Holds endpoint number, direction, type, and more.
 *	Create these values with the eight macros available;
 *	usb_{snd,rcv}TYPEpipe(dev,endpoint), where the type is "ctrl"
 *	(control), "bulk", "int" (interrupt), or "iso" (isochronous).
 *	For example usb_sndbulkpipe() or usb_rcvintpipe().  Endpoint
 *	numbers range from zero to fifteen.  Note that "in" endpoint two
 *	is a different endpoint (and pipe) from "out" endpoint two.
 *	The current configuration controls the existence, type, and
 *	maximum packet size of any given endpoint.
 * @dev: Identifies the USB device to perform the request.
 * @status: This is read in non-iso completion functions to get the
 *	status of the particular request.  ISO requests only use it
 *	to tell whether the URB was unlinked; detailed status for
 *	each frame is in the fields of the iso_frame-desc.
 * @transfer_flags: A variety of flags may be used to affect how URB
 *	submission, unlinking, or operation are handled.  Different
 *	kinds of URB can use different flags.
 * @transfer_buffer:  This identifies the buffer to (or from) which
 * 	the I/O request will be performed (unless URB_NO_DMA_MAP is set).
 *	This buffer must be suitable for DMA; allocate it with kmalloc()
 *	or equivalent.  For transfers to "in" endpoints, contents of
 *	this buffer will be modified.  This buffer is used for data
 *	phases of control transfers.
 * @transfer_dma: When transfer_flags includes URB_NO_DMA_MAP, the device
 * 	driver is saying that it provided this DMA address, which the host
 * 	controller driver should use instead of the transfer_buffer.
 * @transfer_buffer_length: How big is transfer_buffer.  The transfer may
 *	be broken up into chunks according to the current maximum packet
 *	size for the endpoint, which is a function of the configuration
 *	and is encoded in the pipe.  When the length is zero, neither
 *	transfer_buffer nor transfer_dma is used.
 * @actual_length: This is read in non-iso completion functions, and
 *	it tells how many bytes (out of transfer_buffer_length) were
 *	transferred.  It will normally be the same as requested, unless
 *	either an error was reported or a short read was performed.
 *	The URB_SHORT_NOT_OK transfer flag may be used to make such
 *	short reads be reported as errors. 
 * @setup_packet: Only used for control transfers, this points to eight bytes
 *	of setup data.  Control transfers always start by sending this data
 *	to the device.  Then transfer_buffer is read or written, if needed.
 *	(Not used when URB_NO_DMA_MAP is set.)
 * @setup_dma: For control transfers with URB_NO_DMA_MAP set, the device
 * 	driver has provided this DMA address for the setup packet.  The
 * 	host controller driver should use this instead of setup_buffer.
 * 	If there is a data phase, its buffer is identified by transfer_dma.
 * @start_frame: Returns the initial frame for interrupt or isochronous
 *	transfers.
 * @number_of_packets: Lists the number of ISO transfer buffers.
 * @interval: Specifies the polling interval for interrupt or isochronous
 *	transfers.  The units are frames (milliseconds) for for full and low
 *	speed devices, and microframes (1/8 millisecond) for highspeed ones.
 * @error_count: Returns the number of ISO transfers that reported errors.
 * @context: For use in completion functions.  This normally points to
 *	request-specific driver context.
 * @complete: Completion handler. This URB is passed as the parameter to the
 *	completion function.  The completion function may then do what
 *	it likes with the URB, including resubmitting or freeing it.
 * @iso_frame_desc: Used to provide arrays of ISO transfer buffers and to 
 *	collect the transfer status for each buffer.
 *
 * This structure identifies USB transfer requests.  URBs must be allocated by
 * calling usb_alloc_urb() and freed with a call to usb_free_urb().
 * Initialization may be done using various usb_fill_*_urb() functions.  URBs
 * are submitted using usb_submit_urb(), and pending requests may be canceled
 * using usb_unlink_urb().
 *
 * Data Transfer Buffers:
 *
 * Normally drivers provide I/O buffers allocated with kmalloc() or otherwise
 * taken from the general page pool.  That is provided by transfer_buffer
 * (control requests also use setup_packet), and host controller drivers
 * perform a dma mapping (and unmapping) for each buffer transferred.  Those
 * mapping operations can be expensive on some platforms (perhaps using a dma
 * bounce buffer or talking to an IOMMU),
 * although they're cheap on commodity x86 and ppc hardware.
 *
 * Alternatively, drivers may pass the URB_NO_DMA_MAP transfer flag, which
 * tells the host controller driver that no such mapping is needed since
 * the device driver is DMA-aware.  For example, they might allocate a DMA
 * buffer with usb_buffer_alloc(), or call usb_buffer_map().
 * When this transfer flag is provided, host controller drivers will use the
 * dma addresses found in the transfer_dma and/or setup_dma fields rather than
 * determing a dma address themselves.
 *
 * Initialization:
 *
 * All URBs submitted must initialize dev, pipe,
 * transfer_flags (may be zero), complete, timeout (may be zero).
 * The URB_ASYNC_UNLINK transfer flag affects later invocations of
 * the usb_unlink_urb() routine.
 *
 * All URBs must also initialize 
 * transfer_buffer and transfer_buffer_length.  They may provide the
 * URB_SHORT_NOT_OK transfer flag, indicating that short reads are
 * to be treated as errors; that flag is invalid for write requests.
 *
 * Bulk URBs may
 * use the URB_ZERO_PACKET transfer flag, indicating that bulk OUT transfers
 * should always terminate with a short packet, even if it means adding an
 * extra zero length packet.
 *
 * Control URBs must provide a setup_packet.
 *
 * Interrupt UBS must provide an interval, saying how often (in milliseconds
 * or, for highspeed devices, 125 microsecond units)
 * to poll for transfers.  After the URB has been submitted, the interval
 * and start_frame fields reflect how the transfer was actually scheduled.
 * The polling interval may be more frequent than requested.
 * For example, some controllers have a maximum interval of 32 microseconds,
 * while others support intervals of up to 1024 microseconds.
 * Isochronous URBs also have transfer intervals.  (Note that for isochronous
 * endpoints, as well as high speed interrupt endpoints, the encoding of
 * the transfer interval in the endpoint descriptor is logarithmic.)
 *
 * Isochronous URBs normally use the URB_ISO_ASAP transfer flag, telling
 * the host controller to schedule the transfer as soon as bandwidth
 * utilization allows, and then set start_frame to reflect the actual frame
 * selected during submission.  Otherwise drivers must specify the start_frame
 * and handle the case where the transfer can't begin then.  However, drivers
 * won't know how bandwidth is currently allocated, and while they can
 * find the current frame using usb_get_current_frame_number () they can't
 * know the range for that frame number.  (Ranges for frame counter values
 * are HC-specific, and can go from 256 to 65536 frames from "now".)
 *
 * Isochronous URBs have a different data transfer model, in part because
 * the quality of service is only "best effort".  Callers provide specially
 * allocated URBs, with number_of_packets worth of iso_frame_desc structures
 * at the end.  Each such packet is an individual ISO transfer.  Isochronous
 * URBs are normally queued, submitted by drivers to arrange that
 * transfers are at least double buffered, and then explicitly resubmitted
 * in completion handlers, so
 * that data (such as audio or video) streams at as constant a rate as the
 * host controller scheduler can support.
 *
 * Completion Callbacks:
 *
 * The completion callback is made in_interrupt(), and one of the first
 * things that a completion handler should do is check the status field.
 * The status field is provided for all URBs.  It is used to report
 * unlinked URBs, and status for all non-ISO transfers.  It should not
 * be examined before the URB is returned to the completion handler.
 *
 * The context field is normally used to link URBs back to the relevant
 * driver or request state.
 *
 * When completion callback is invoked for non-isochronous URBs, the
 * actual_length field tells how many bytes were transferred.
 *
 * ISO transfer status is reported in the status and actual_length fields
 * of the iso_frame_desc array, and the number of errors is reported in
 * error_count.  Completion callbacks for ISO transfers will normally
 * (re)submit URBs to ensure a constant transfer rate.
 */
struct urb {
 #ifndef NO_SPINLOCK
	spinlock_t lock;		/* lock for the URB */
 #endif // ndef NO_SPINLOCK
 /*
 #ifndef _ETCPIP
 */
	atomic_t count;			// reference count of the URB
 /*
  #else
	int count;
 #endif
 */
 void *hcpriv;			/* private data for host controller */
 struct list_head urb_list;	/* list pointer to all active urbs */
 struct usb_device *dev; 	/* (in) pointer to associated device */
 unsigned int pipe;		/* (in) pipe information */
 int status;			/* (return) non-ISO status */
 unsigned int transfer_flags;	/* (in) URB_SHORT_NOT_OK | ...*/
 void *transfer_buffer;		/* (in) associated data buffer */
 #ifndef USB_NO_VMM // vitrtul memory management
	dma_addr_t transfer_dma;	/* (in) dma addr for transfer_buffer */
 #endif // ndef USB_NO_VMM
 int transfer_buffer_length;	/* (in) data buffer length */
 int actual_length;		/* (return) actual transfer length */
 int bandwidth;			/* bandwidth for INT/ISO request */
 unsigned char *setup_packet;	/* (in) setup packet (control only) */
 #ifndef _ETCPIP
	dma_addr_t setup_dma;		/* (in) dma addr for setup_packet */
 #endif
 int start_frame;		/* (modify) start frame (INT/ISO) */
 int number_of_packets;		/* (in) number of ISO packets */
 int interval;			/* (in) transfer interval (INT/ISO) */
 int error_count;		/* (return) number of ISO errors */
 unsigned long timeout;			/* (in) timeout, in jiffies */
 void *context;			/* (in) context for completion */
 usb_callback_t callback ;	/* (in) completion routine */
 struct usb_iso_packet_descriptor iso_frame_desc[0];	/* (in) ISO ONLY */
 
 #ifdef USB_NO_ABC // No usb_api_blocking_completion()
	int awd_done_old ;
	int awd_done ;
 #endif
 #ifdef USB_NO_ISR_CALLBACK
    #define NEXT_STEP_NONE   (0) // Bit Field
    #define NEXT_STEP_PAUSE  (1)
    #define NEXT_STEP_WC     (2)
    #define NEXT_STEP_CONTI  (4)
    #define NEXT_STEP_KILL   (8)
    #define NEXT_STEP_FREE   (16) // Bit Field
    #define NEXT_STEP_SUBMIT (32)  /* Charles 20040422 */
	unsigned int next_step ;
    // int kill ;
 #endif // USB_NO_ISR_CALLBACK
};

/* -------------------------------------------------------------------------- */

/**
 * usb_fill_control_urb - initializes a control urb
 * @urb: pointer to the urb to initialize.
 * @dev: pointer to the struct usb_device for this urb.
 * @pipe: the endpoint pipe
 * @setup_packet: pointer to the setup_packet buffer
 * @transfer_buffer: pointer to the transfer buffer
 * @buffer_length: length of the transfer buffer
 * @complete: pointer to the usb_complete_t function
 * @context: what to set the urb context to.
 *
 * Initializes a control urb with the proper information needed to submit
 * it to a device.
 */
static inline void usb_fill_control_urb (struct urb *urb,
					 struct usb_device *dev,
					 unsigned int pipe,
					 unsigned char *setup_packet,
					 void *transfer_buffer,
					 int buffer_length,
					 usb_callback_t callback ,
					 void *context)
{
 #ifdef USB_BS_ASSERT
	if (buffer_length) {
		if (!(  (unsigned long)  transfer_buffer
   	          > ((unsigned long) 0x20000L)
		   ) ) {
			iprintf("[ASSERT][USB] usb_fill_control_urb(1) : " ) ;
   		    iprintf("Error : Invalid Address !!\n" ) ;
	        iprintf("[ASSERT][USB] transfer_buffer addr = %08XH \n",
					transfer_buffer) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
		   }
	   } // if has length
 #endif // USB_BS_ASSERT

 #ifdef USB_BS_ASSERT_CACHE
	if (transfer_buffer) {
		if ( !(USB_IS_UN_CACHED(transfer_buffer)) ) {
					iprintf("[ASSERT][USB] usb_fill_control_urb(2) : " ) ;
	    		    iprintf("Error : Not Un-Cached !!\n" ) ;
			        iprintf("[ASSERT][USB] transfer_buffer addr = %08XH \n", transfer_buffer) ;
			        iprintf("[ASSERT][USB] Continue ..\n") ;
    			   }
	   } // if has data
 #endif // USB_BS_ASSERT

 #ifndef NO_SPINLOCK
    #error : Please Make Sure : Not NO_SPINLOCK
	spin_lock_init(&urb->lock);
 #endif // ndef NO_SPINLOCK
	urb->dev = dev;
	urb->pipe = pipe;
	urb->setup_packet = setup_packet;
	USB_DBG_MEM(iprintf(
		"[USB MEM] usb_fill_control_urb() : urb->setup_packet = %08XH \n",
    	urb->setup_packet
    	));
	urb->transfer_buffer = transfer_buffer;
	urb->transfer_buffer_length = buffer_length;
	urb->callback = callback ;
	urb->context = context;
}

/**
 * usb_fill_bulk_urb - macro to help initialize a bulk urb
 * @urb: pointer to the urb to initialize.
 * @dev: pointer to the struct usb_device for this urb.
 * @pipe: the endpoint pipe
 * @transfer_buffer: pointer to the transfer buffer
 * @buffer_length: length of the transfer buffer
 * @complete: pointer to the usb_complete_t function
 * @context: what to set the urb context to.
 *
 * Initializes a bulk urb with the proper information needed to submit it
 * to a device.
 */
static inline void usb_fill_bulk_urb (struct urb *urb,
				      struct usb_device *dev,
				      unsigned int pipe,
				      void *transfer_buffer,
				      int buffer_length,
				      usb_callback_t callback ,
				      void *context)
{
 #ifdef USB_BS_ASSERT
	if (buffer_length) {
		if (!(  (unsigned long)  transfer_buffer
   	          > ((unsigned long) 0x20000L)
		   ) ) {
			iprintf("[ASSERT][USB] usb_fill_bulk_urb(1) : " ) ;
   		    iprintf("Error : Invalid Address !!\n" ) ;
	        iprintf("[ASSERT][USB] transfer_buffer addr = %08XH \n",
					transfer_buffer) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
		   }
	   } // if has length
 #endif // USB_BS_ASSERT

 #ifdef USB_BS_ASSERT_CACHE
	if (transfer_buffer) {
		if ( !(USB_IS_UN_CACHED(transfer_buffer)) ) {
					iprintf("[ASSERT][USB] usb_fill_bulk_urb(2) : " ) ;
	    		    iprintf("Error : Not Un-Cached !!\n" ) ;
			        iprintf("[ASSERT][USB] transfer_buffer addr = %08XH \n", transfer_buffer) ;
			        iprintf("[ASSERT][USB] Continue ..\n") ;
    			   }
	   } // if has data
 #endif // USB_BS_ASSERT_CACHE

 #ifndef NO_SPINLOCK
	spin_lock_init(&urb->lock);
 #endif // ndef NO_SPINLOCK
	urb->dev = dev;
	urb->pipe = pipe;
	urb->transfer_buffer = transfer_buffer;
	urb->transfer_buffer_length = buffer_length;
	urb->callback = callback ;
	urb->context = context;
}

/**
 * usb_fill_int_urb - macro to help initialize a interrupt urb
 * @urb: pointer to the urb to initialize.
 * @dev: pointer to the struct usb_device for this urb.
 * @pipe: the endpoint pipe
 * @transfer_buffer: pointer to the transfer buffer
 * @buffer_length: length of the transfer buffer
 * @complete: pointer to the usb_complete_t function
 * @context: what to set the urb context to.
 * @interval: what to set the urb interval to, encoded like
 *	the endpoint descriptor's bInterval value.
 *
 * Initializes a interrupt urb with the proper information needed to submit
 * it to a device.
 * Note that high speed interrupt endpoints use a logarithmic encoding of
 * the endpoint interval, and express polling intervals in microframes
 * (eight per millisecond) rather than in frames (one per millisecond).
 */
static inline void usb_fill_int_urb (struct urb *urb,
				     struct usb_device *dev,
				     unsigned int pipe,
				     void *transfer_buffer,
				     int buffer_length,
				     usb_callback_t callback ,
				     void *context,
				     int interval)
{

 #ifdef USB_BS_ASSERT
	if (buffer_length) {
		if (!(  (unsigned long)  transfer_buffer
   	          > ((unsigned long) 0x20000L)
		   ) ) {
			iprintf("[ASSERT][USB] usb_fill_int_urb(1) : " ) ;
   		    iprintf("Error : Invalid Address !!\n" ) ;
	        iprintf("[ASSERT][USB] transfer_buffer addr = %08XH \n",
					transfer_buffer) ;
	        iprintf("[ASSERT][USB] Continue ..\n") ;
		   }
	   } // if has length
 #endif // USB_BS_ASSERT

 #ifdef USB_BS_ASSERT_CACHE
	if (transfer_buffer) {
		if ( !(USB_IS_UN_CACHED(transfer_buffer)) ) {
					iprintf("[ASSERT][USB] usb_fill_int_urb(2) : " ) ;
	    		    iprintf("Error : Not Un-Cached !!\n" ) ;
			        iprintf("[ASSERT][USB] transfer_buffer addr = %08XH \n", transfer_buffer) ;
			        iprintf("[ASSERT][USB] Continue ..\n") ;
    			   }
	   } // if has data
 #endif // USB_BS_ASSERT

 #ifndef NO_SPINLOCK
	spin_lock_init(&urb->lock);
 #endif // ndef NO_SPINLOCK
	urb->dev = dev;
	urb->pipe = pipe;
	urb->transfer_buffer = transfer_buffer;
	urb->transfer_buffer_length = buffer_length;
	urb->callback = callback ;
	urb->context = context;
	if (dev->speed == USB_SPEED_HIGH)
		urb->interval = 1 << (interval - 1);
	else
		urb->interval = interval;
	urb->start_frame = -1;
}

#ifndef _ETCPIP
	extern struct urb *usb_alloc_urb(int iso_packets, int mem_flags);
 #else
	extern struct urb *usb_alloc_urb(int iso_packets);
#endif
extern void usb_free_urb(struct urb *urb);
#define usb_put_urb usb_free_urb
extern struct urb *usb_get_urb(struct urb *urb);
#ifndef _ETCPIP
	extern int usb_submit_urb(struct urb *urb, int mem_flags);
 #else
	extern int usb_submit_urb(struct urb *urb);
#endif
extern int usb_unlink_urb(struct urb *urb);

#define HAVE_USB_BUFFERS
void *usb_buffer_alloc (struct usb_device *dev, size_t size,
	int mem_flags, dma_addr_t *dma);
void usb_buffer_free (struct usb_device *dev, size_t size,
	void *addr, dma_addr_t dma);

struct urb *usb_buffer_map (struct urb *urb);
void usb_buffer_dmasync (struct urb *urb);
void usb_buffer_unmap (struct urb *urb);
/*
#ifndef NO_SCATTER_LIST
	// struct scatterlist is on include/asm-xxx/scatterlist.h
	struct scatterlist;
	int usb_buffer_map_sg (struct usb_device *dev, unsigned pipe,
		struct scatterlist *sg, int nents);
	void usb_buffer_dmasync_sg (struct usb_device *dev, unsigned pipe,
		struct scatterlist *sg, int n_hw_ents);

	void usb_buffer_unmap_sg (struct usb_device *dev, unsigned pipe,
		struct scatterlist *sg,
        int n_hw_ents);
#endif // ndef NO_SCATTER_LIST
*/

/*-------------------------------------------------------------------*
 *                         SYNCHRONOUS CALL SUPPORT                  *
 *-------------------------------------------------------------------*/

extern int usb_control_msg(struct usb_device *dev, unsigned int pipe,
	__u8 request, __u8 requesttype, __u16 value, __u16 index,
	void *data, __u16 size, unsigned long timeout);
extern int usb_bulk_msg(struct usb_device *usb_dev, unsigned int pipe,
	void *data, int len, int *actual_length,
	unsigned long timeout);
 
/* wrappers around usb_control_msg() for the most common standard requests */
extern int usb_get_descriptor(struct usb_device *dev, unsigned char desctype,
	unsigned char descindex, void *buf, int size);
extern int usb_get_device_descriptor(struct usb_device *dev);
extern int usb_get_status(struct usb_device *dev,
	int type, int target, void *data);
extern int usb_get_string(struct usb_device *dev,
	unsigned short langid, unsigned char index, void *buf, int size);
#ifdef USB_DBGSTRING_ON
	extern int usb_string(struct usb_device *dev, int index,
		char *buf, size_t size);
 #else
	extern int usb_string(struct usb_device *dev, int index) ;
#endif

/* wrappers that also update important state inside usbcore */
extern int usb_clear_halt(struct usb_device *dev, int pipe);
extern int usb_set_configuration(struct usb_device *dev, int configuration);
extern int usb_set_interface(struct usb_device *dev, int ifnum, int alternate);

/*
 * timeouts, in seconds, used for sending/receiving control messages
 * they typically complete within a few frames (msec) after they're issued
 * USB identifies 5 second timeouts, maybe more in a few cases, and a few
 * slow devices (like some MGE Ellipse UPSes) actually push that limit.
 */

/* 20003/7/1 B. S. Liaw , move to UsbCfg.h
#ifndef _ETCPIP
	#define USB_CTRL_GET_TIMEOUT	5
#else
	#define USB_CTRL_GET_TIMEOUT	10 // 7
#endif

#ifndef _ETCPIP
	#define USB_CTRL_SET_TIMEOUT	5
#else
	#define USB_CTRL_SET_TIMEOUT	8 // 8
#endif
#ifdef _ETCPIP
	#define USB_CTRL_SETADDR_TIMEOUT  9 // 10
	// #define USB_PRE_TIMEOUT	          3
#endif
*/

/**
 * struct usb_sg_request - support for scatter/gather I/O
 * @status: zero indicates success, else negative errno
 * @bytes: counts bytes transferred.
 *
 * These requests are initialized using usb_sg_init(), and then are used
 * as request handles passed to usb_sg_wait() or usb_sg_cancel().  Most
 * members of the request object aren't for driver access.
 *
 * The status and bytecount values are valid only after usb_sg_wait()
 * returns.  If the status is zero, then the bytecount matches the total
 * from the request.
 *
 * After an error completion, drivers may need to clear a halt condition
 * on the endpoint.
 */
struct usb_sg_request {
	int			status;
	size_t			bytes;

	// members not documented above are private to usbcore,
	// and are not provided for driver access!
 #ifndef NO_SPINLOCK
	spinlock_t		lock;
 #endif // ndef NO_SPINLOCK

	struct usb_device	*dev;
	int			pipe;
 /*
 #ifndef NO_SCATTER_LIST
	// struct scatterlist is on include/asm-xxx/scatterlist.h
	struct scatterlist	*sg;
 #endif // ndef NO_SCATTER_LIST
 */
	int			nents;

	int			entries;
	struct urb		**urbs;

	int			count;
 #ifndef _ETCPIP
 	/*
    // in <linux/completion.h>
	struct completion	complete;
    */
 #endif // ndef _ETCPIP
};

/*
#ifndef NO_SCATTER_LIST
   int usb_sg_init (
	struct usb_sg_request	*io,
	struct usb_device	*dev,
	unsigned		pipe, 
	unsigned		period,
	
	#ifndef NO_SCATTER_LIST
		struct scatterlist	*sg,
	#endif // ndef NO_SCATTER_LIST

	int			nents,
	size_t			length,
	int			mem_flags
   );
#endif // ndef NO_SCATTER_LIST
*/
void usb_sg_cancel (struct usb_sg_request *io);
void usb_sg_wait (struct usb_sg_request *io);


/* -------------------------------------------------------------------------- */

/*
 * Calling this entity a "pipe" is glorifying it. A USB pipe
 * is something embarrassingly simple: it basically consists
 * of the following information:
 *  - device number (7 bits)
 *  - endpoint number (4 bits)
 *  - current Data0/1 state (1 bit) [Historical; now gone]
 *  - direction (1 bit)
 *  - speed (1 bit) [Historical and specific to USB 1.1; now gone.]
 *  - max packet size (2 bits: 8, 16, 32 or 64) [Historical; now gone.]
 *  - pipe type (2 bits: control, interrupt, bulk, isochronous)
 *
 * That's 18 bits. Really. Nothing more. And the USB people have
 * documented these eighteen bits as some kind of glorious
 * virtual data structure.
 *
 * Let's not fall in that trap. We'll just encode it as a simple
 * unsigned int. The encoding is:
 *
 *  - max size:		bits 0-1	[Historical; now gone.]
 *  - direction:	bit 7		(0 = Host-to-Device [Out],
 *					 1 = Device-to-Host [In] ...
 *					like endpoint bEndpointAddress)
 *  - device:		bits 8-14       ... bit positions known to uhci-hcd
 *  - endpoint:		bits 15-18      ... bit positions known to uhci-hcd
 *  - Data0/1:		bit 19		[Historical; now gone. ]
 *  - lowspeed:		bit 26		[Historical; now gone. ]
 *  - pipe type:	bits 30-31	(00 = isochronous, 01 = interrupt,
 *					 10 = control, 11 = bulk)
 *
 * Why? Because it's arbitrary, and whatever encoding we select is really
 * up to us. This one happens to share a lot of bit positions with the UHCI
 * specification, so that much of the uhci driver can just mask the bits
 * appropriately.
 */

/* NOTE:  these are not the standard USB_ENDPOINT_XFER_* values!! */
#define PIPE_ISOCHRONOUS		0
#define PIPE_INTERRUPT			1
#define PIPE_CONTROL			2
#define PIPE_BULK			3

#define usb_maxpacket(dev, pipe, out)	(out \
				? (dev)->epmaxpacketout[usb_pipeendpoint(pipe)] \
				: (dev)->epmaxpacketin [usb_pipeendpoint(pipe)] )

#define usb_pipein(pipe)	((pipe) & USB_DIR_IN)
#define usb_pipeout(pipe)	(!usb_pipein(pipe))
#define usb_pipedevice(pipe)	(((pipe) >> 8) & 0x7f)
#define usb_pipeendpoint(pipe)	(((pipe) >> 15) & 0xf)
#define usb_pipetype(pipe)	(((pipe) >> 30) & 3)
#define usb_pipeisoc(pipe)	(usb_pipetype((pipe)) == PIPE_ISOCHRONOUS)
#define usb_pipeint(pipe)	(usb_pipetype((pipe)) == PIPE_INTERRUPT)
#define usb_pipecontrol(pipe)	(usb_pipetype((pipe)) == PIPE_CONTROL)
#define usb_pipebulk(pipe)	(usb_pipetype((pipe)) == PIPE_BULK)

/* The D0/D1 toggle bits ... USE WITH CAUTION (they're almost hcd-internal) */
#define usb_gettoggle(dev, ep, out) (((dev)->toggle[out] >> (ep)) & 1)
#define	usb_dotoggle(dev, ep, out)  ((dev)->toggle[out] ^= (1 << (ep)))
#define usb_settoggle(dev, ep, out, bit) ((dev)->toggle[out] = ((dev)->toggle[out] & ~(1 << (ep))) | ((bit) << (ep)))

/* Endpoint halt control/status ... likewise USE WITH CAUTION */
#define usb_endpoint_running(dev, ep, out) ((dev)->halted[out] &= ~(1 << (ep)))
#define usb_endpoint_halted(dev, ep, out) ((dev)->halted[out] & (1 << (ep)))


static inline unsigned int __create_pipe(struct usb_device *dev, unsigned int endpoint)
{
	return (dev->devnum << 8) | (endpoint << 15);
}

/* Create various pipes... */
#define usb_sndctrlpipe(dev,endpoint)	((PIPE_CONTROL << 30) | __create_pipe(dev,endpoint))
#define usb_rcvctrlpipe(dev,endpoint)	((PIPE_CONTROL << 30) | __create_pipe(dev,endpoint) | USB_DIR_IN)
#define usb_sndisocpipe(dev,endpoint)	((PIPE_ISOCHRONOUS << 30) | __create_pipe(dev,endpoint))
#define usb_rcvisocpipe(dev,endpoint)	((PIPE_ISOCHRONOUS << 30) | __create_pipe(dev,endpoint) | USB_DIR_IN)
#define usb_sndbulkpipe(dev,endpoint)	((PIPE_BULK << 30) | __create_pipe(dev,endpoint))
#define usb_rcvbulkpipe(dev,endpoint)	((PIPE_BULK << 30) | __create_pipe(dev,endpoint) | USB_DIR_IN)
#define usb_sndintpipe(dev,endpoint)	((PIPE_INTERRUPT << 30) | __create_pipe(dev,endpoint))
#define usb_rcvintpipe(dev,endpoint)	((PIPE_INTERRUPT << 30) | __create_pipe(dev,endpoint) | USB_DIR_IN)

/* -------------------------------------------------------------------------- */

/*
 * Debugging and troubleshooting/diagnostic helpers.
 */
void usb_show_device_descriptor(struct usb_device_descriptor *);
void usb_show_config_descriptor(struct usb_config_descriptor *);
void usb_show_interface_descriptor(struct usb_interface_descriptor *);
void usb_show_endpoint_descriptor(struct usb_endpoint_descriptor *);
void usb_show_device(struct usb_device *);
void usb_show_string(struct usb_device *dev, char *id, int index);

#ifdef DEBUG
   #ifndef _ETCPIP
      #define dbg(format, arg...) printk(KERN_DEBUG __FILE__ ": " format "\n" , ## arg)
    #else
      #define dbg dprintf
   #endif
 #else
   #define dbg(format, arg...) do {} while (0)
#endif

#ifndef _ETCPIP
   #define err(format, arg...) printk(KERN_ERR __FILE__ ": " format "\n" , ## arg)
   #define info(format, arg...) printk(KERN_INFO __FILE__ ": " format "\n" , ## arg)
   #define warn(format, arg...) printk(KERN_WARNING __FILE__ ": " format "\n" , ## arg)
 #else
   #define err(format, arg...) dprintf(": " format "\n" , ## arg)
   #define info(format, arg...) dprintf(": " format "\n" , ## arg)
   #define warn(format, arg...) dprintf(": " format "\n" , ## arg)
#endif // ndef _ETCPIP


#endif  /* __KERNEL__ */

/*
  #ifdef _ETCPIP
     extern struct usb_api_data awd;
  #endif // def _ETCPIP
*/  
   
// ====================================================================

/* Functions local to drivers/usb/core/ */

extern void usb_create_driverfs_dev_files (struct usb_device *dev);
extern void usb_create_driverfs_intf_files (struct usb_interface *intf);



// #ifdef _ETCPIP
	extern int usb_start_wait_urb_nf(struct urb *urb, unsigned long timeout ,
    	// int need_longer_wait , 
		int* actual_length) ;
    
	extern int usb_start_wait_urb(struct urb *urb, unsigned long timeout,
    				int* actual_length) ;
// #endif // _ETCPIP

// #ifdef USB_NO_ABC // No usb_api_blocking_completion()
    extern void usb_urb_complete(struct urb *urb) ;
	extern int global_awd_done ;
// #endif // USB_NO_ABC

#ifdef USB_NO_ISR_CALLBACK
	extern void urb_task(struct urb *urb) ;
#endif // USB_NO_ISR_CALLBACK

// ====================================================================

#endif // ndef __LINUX_USB_H

// ====================================================================
// End of File : usb.h

