

// Name of file : UsbLptIo.h
// ====================================================================


// ====================================================================
/*
// #define USBLP_BUF_SIZE		8192
#define USBLP_BUF_SIZE			4096
// #define USBLP_BUF_SIZE		64 // 32 // 128
#define USBLP_DEVICE_ID_SIZE	1024
*/
// ====================================================================

/* ioctls: */
#define LPGETSTATUS		0x060b		/* same as in drivers/char/lp.c */
#define IOCNR_GET_DEVICE_ID	1
#define IOCNR_GET_PROTOCOLS		2
#define IOCNR_SET_PROTOCOL		3
#define IOCNR_HP_SET_CHANNEL		4
#define IOCNR_GET_BUS_ADDRESS		5
#define IOCNR_GET_VID_PID		6
/* Get device_id string: */
#define LPIOC_GET_DEVICE_ID(len) _IOC(_IOC_READ, 'P', IOCNR_GET_DEVICE_ID, len)
/* The following ioctls were added for http://hpoj.sourceforge.net: */
/* Get two-int array:
 * [0]=current protocol (1=7/1/1, 2=7/1/2, 3=7/1/3),
 * [1]=supported protocol mask (mask&(1<<n)!=0 means 7/1/n supported): */
#define LPIOC_GET_PROTOCOLS(len) _IOC(_IOC_READ, 'P', IOCNR_GET_PROTOCOLS, len)
/* Set protocol (arg: 1=7/1/1, 2=7/1/2, 3=7/1/3): */
#define LPIOC_SET_PROTOCOL _IOC(_IOC_WRITE, 'P', IOCNR_SET_PROTOCOL, 0)
/* Set channel number (HP Vendor-specific command): */
#define LPIOC_HP_SET_CHANNEL _IOC(_IOC_WRITE, 'P', IOCNR_HP_SET_CHANNEL, 0)
/* Get two-int array: [0]=bus number, [1]=device address: */
#define LPIOC_GET_BUS_ADDRESS(len) _IOC(_IOC_READ, 'P', IOCNR_GET_BUS_ADDRESS, len)
/* Get two-int array: [0]=vendor ID, [1]=product ID: */
#define LPIOC_GET_VID_PID(len) _IOC(_IOC_READ, 'P', IOCNR_GET_VID_PID, len)

/*
 * A DEVICE_ID string may include the printer's serial number.
 * It should end with a semi-colon (';').
 * An example from an HP 970C DeskJet printer is (this is one long string,
 * with the serial number changed):
MFG:HEWLETT-PACKARD;MDL:DESKJET 970C;CMD:MLC,PCL,PML;CLASS:PRINTER;DESCRIPTION:Hewlett-Packard DeskJet 970C;SERN:US970CSEPROF;VSTATUS:$HB0$NC0,ff,DN,IDLE,CUT,K1,C0,DP,NR,KP000,CP027;VP:0800,FL,B0;VJ:                    ;
 */

/*
 * USB Printer Requests
 */

#define USBLPT_REQ_GET_ID	0x00
#define USBLPT_REQ_GET_STATUS	0x01
#define USBLPT_REQ_RESET		0x02
#define USBLPT_REQ_HP_CHANNEL_CHANGE_REQUEST	0x00	/* HP Vendor-specific */

#ifdef CONFIG_USB_DYNAMIC_MINORS
#define USBLPT_MINORS		256
#else
#define USBLPT_MINORS		16
#endif
#define USBLPT_MINOR_BASE	0

// ====================================================================

// 2003/10/02 B. S. Liaw Move to UsbCfg.h
/*
#ifdef _ETCPIP
	// Not use long delay , so , value larger
	#define USBLP_CTLMSG_TIMEOUT   (300*1000) // (300000)	
#endif // _ETCPIP

//#ifndef _ETCPIP
//	
//	// #define USBLP_WRITE_TIMEOUT	   (5*HZ)	  // 5 seconds 
//    
// #else

	#define USBLP_WRITE_TIMEOUT	   (1000) // (100*1000) // (20000)

//#endif


// #ifdef _ETCPIP
	// #define USBLP_READ_TIMEOUT	 (2*HZ)	  // 2 seconds
	// #define USBLP_READ_TIMEOUT	 (6000)	
	#ifdef USBLPT_READ_BY_START_WAIT
		#define USBLP_READ_TIMEOUT  (1000)  // (3000) // (30*1000) // (3*10000)
	#else
		#define USBLP_READ_TIMEOUT	 (300)
    #endif
// endif // _ETCPIP
*/

// ====================================================================

#define USBLPT_FIRST_PROTOCOL	1
#define USBLPT_LAST_PROTOCOL	3
#define USBLPT_MAX_PROTOCOLS	(USBLPT_LAST_PROTOCOL+1)

/*
 * some arbitrary status buffer size;
 * need a status buffer that is allocated via kmalloc(), not on stack
 */
#define STATUS_BUF_SIZE		8

struct usblp
{
 struct usb_device 	*usb_dev;			/* USB device */
 #ifdef CONFIG_USB_DEVICEFS
	devfs_handle_t		devfs;			/* devfs device */
 #endif // CONFIG_USB_DEVICEFS
 #ifndef NO_SEMPHORE
	struct semaphore	sem;	
    			/* locks this struct, especially "dev" */
 #endif // ndef NO_SEMPHORE
 
 char			*writebuf;		/* write transfer_buffer */
 #ifdef USBLPT_BIDIR // 2003/10/13 B. S. Liaw
	char		*readbuf;		/* read transfer_buffer */
 #endif // USBLPT_BIDIR // 2003/10/13 B. S. Liaw
 char			*statusbuf;		/* status transfer_buffer */
 /*
 char			*buf;		// writeurb.transfer_buffer 
					// + USBLP_BUF_SIZE ==> readurb transfer_buffer
 */
 
 // #ifndef _ETCPIP
 #ifdef USBLPT_BIDIR // 2003/10/13 B. S. Liaw
	struct urb		*readurb ;	/* The urbs */
 #endif // USBLPT_BIDIR // 2003/10/13 B. S. Liaw

 struct urb		*writeurb ;	/* The urbs */
 // #else
 //	urb_t	*readurb, *writeurb;
 // #endif
 
 #ifndef NO_WAITQUEUE
	wait_queue_head_t	wait;			/* Zzzzz ... */
 #endif // ndef NO_WAITQUEUE
 #ifdef USBLPT_BIDIR // 2003/10/13 B. S. Liaw
	int		readcount;		/* Counter for reads */
 #endif // USBLPT_BIDIR // 2003/10/13 B. S. Liaw
 int		ifnum;			/* Interface number */
 /* Alternate-setting numbers and endpoints for each protocol
  * (7/1/{index=1,2,3}) that the device supports: */
 struct
   {
	int		alt_setting;
	struct  usb_endpoint_descriptor	*epwrite;
	#ifdef USBLPT_BIDIR // 2003/10/13 B. S. Liaw
		struct  usb_endpoint_descriptor	*epread;
	#endif // USBLPT_BIDIR
   } protocol[USBLPT_MAX_PROTOCOLS];
   
 int	current_protocol;
 
 int	minor;			/* minor number of device */
 int			wcomplete;		/* writing is completed */
 #ifdef USBLPT_BIDIR // 2003/10/13 B. S. Liaw
	int			rcomplete;		/* reading is completed */
 #endif // USBLPT_BIDIR // 2003/10/13 B. S. Liaw
 unsigned int	quirks;			/* quirks flags */
 // unsigned char	opened ; // used;			//  True if open 
 int opened ; // -1 : under open , 0 : open fail , 1 : open ok
 #ifdef USBLPT_BIDIR // 2003/10/13 B. S. Liaw
	unsigned char	bidir;			/* interface is bidirectional */
 #endif // USBLPT_BIDIR // 2003/10/13 B. S. Liaw
 
 unsigned char	*device_id_string;	/* IEEE 1284 DEVICE ID string (ptr) */
					/* first 2 bytes are (big-endian) length */
 #ifdef USBLPT_PRINTERS  /* Charles 20040706 */
 	int usblp_wr_done;
	int usb_lpt_released;
	int usb_lpt_access;
	int usblp_plug_out;
 #endif
 /*
 #ifdef USBLPT_RESET_CMD // 2003/10/14 B. S. Liaw
	int support_reset ;
 #endif // USBLPT_RESET_CMD
 */
};

#ifdef CONFIG_USB_DEVICEFS
   extern devfs_handle_t usb_devfs_handle;			/* /dev/usb dir. */
#endif // CONFIG_USB_DEVICEFS
/*
#ifndef _ETCPIP
	static
// #else
//	extern
//#endif
	struct usblp *usblp_table[USBLP_MINORS];
#endif // ndef _ETCPIP
*/
#ifdef _ETCPIP
	extern struct usblp *global_usblp ;
#endif // _ETCPIP

// ====================================================================

/* Quirks: various printer quirks are handled by this table 
   & its flags. */

struct quirk_printer_struct {
	__u16 vendorId;
	__u16 productId;
 unsigned int quirks; // total max 16 Bits
};

#define USBLPT_QUIRK_UNSUPPORT  0x0001 // Unsupported Printer
#define USBLPT_QUIRK_INTF_1	   0x0002	// needs use interface 1 
// #define USBLP_QUIRK_GET_ID  0x0004	// locks up on parallel GET_ID and bulk I/O 
#define USBLPT_QUIRK_NO_1284ID  0x0008	// No 1284 ID string
#define USBLPT_QUIRK_BIDIR	   0x0010	// reports bidir but requires 
									 // unidirectional mode
                                     // (no INs/reads) 
#define USBLPT_QUIRK_USB_INIT   0x0020	// needs vendor USB init string 
#define USBLPT_QUIRK_INIT_EPSON 0x0040	 // EPSON USB init string 
/*
#define USBLP_QUIRK_INIT_HP1000 0x0020 // HP Laser Jet 1000 init string
*/
#define USBLPT_QUIRK_NORESET    0x0080 // No Standard USBLPT Reset Command
#define USBLPT_QUIRK_RESET11    0x0100 // Version 1.1 :  0x21 
									  // USB_RECIP_INTERFACE 0x01

// ====================================================================

/*
extern int usblp_select_alts(struct usblp *usblp);
extern int usblp_set_protocol(struct usblp *usblp, int protocol);
extern int usblp_cache_device_id_string(struct usblp *usblp);
*/
/*
 * File op functions.
 */

#ifndef _ETCPIP
	static int usblp_open(struct inode *inode, struct file *file)
 #else
	extern int usblp_open(struct usblp *usblp) ;
	// static int usblp_open(struct inode *inode, struct usblp *usblp)
#endif

#ifndef _ETCPIP
    /*
	static ssize_t usblp_write( struct file *file, const char *buffer,
    							size_t count, loff_t *ppos) ;
    */
 #else
	// extern ssize_t usblp_write( struct usblp *usblp , 
	extern int usblp_write( struct usblp *usblp , 
    							unsigned char *buffer,
    							size_t count) ;
#endif
/*
#ifndef _ETCPIP
	static ssize_t usblp_read(struct file *file, char *buffer,
						  size_t count, loff_t *ppos) ;
 #else
*/
	extern ssize_t usblp_read(struct usblp *usblp , char *buffer,
						  size_t count) ;
/*
#endif
*/
// ====================================================================

#ifndef _ETCPIP
   static int usblp_ioctl( struct inode *inode, struct file *file,
    					    unsigned int cmd, unsigned long arg) ;
#endif // ndef _ETCPIP

#ifdef _ETCPIP
	extern int usblp_reset(struct usblp *usblp) ;
	extern int usblp_check_status(struct usblp *usblp, int err) ;
    extern unsigned char usb_init_string(struct usblp *usblp) ;
#endif

// ====================================================================


// ====================================================================

// extern int usblp_set_protocol(struct usblp *usblp, int protocol) ;


// ====================================================================
// End of file : UsbLptIo.h

