
// Name of File : UsbMemLib.h
// ====================================================================

#ifndef __USB_MEM_LIB_H__
#define __USB_MEM_LIB_H__

// ====================================================================
#ifdef USB_DBG_MEM_C_ON
	#warning: USB_DBG_MEM_C_ON !!
#endif // USB_DBG_MEM_C_ON

#ifdef USB_DBG_MEM_U_ON
	#warning: USB_DBG_MEM_U_ON !!
#endif // USB_DBG_MEM_C_ON

// fixed size memory pool ID

#define USB_MEM_C_S      1  // Cached Small
#define USB_MEM_C_M      2  // Cached Medium
#define USB_MEM_C_L      3  // Cached Large

#define USB_MEM_U_S      4 // Uncached Small
#define USB_MEM_U_M      5 // Uncached Medium
#define USB_MEM_U_L      6 // Uncached Large

// ====================================================================
#if defined(_S3C2510)
	#undef USB_MEM_STATIC_ARRAY
#elif defined(_ADM5120) || defined(_AR7300) || defined(_ATHEROS)
	#define USB_MEM_STATIC_ARRAY
#else
	#error: Please Determine what USB_MEM_STATIC_ARRAY ??
#endif

// #if defined(_S3C2510)
#ifndef USB_MEM_STATIC_ARRAY
	#include "buffer.h"
   // extern void NonCache_alloc_init(void) ;
   // extern void *NonCache_contigmalloc( unsigned long usize) ;
	extern void * NonCache_contigmalloc(unsigned long usize) ;
    
	#define UsbNCCntMalloc   NonCache_contigmalloc
 #else
	extern void UsbNCCntMalloc_init(void) ;
	extern void * UsbNCCntMalloc(unsigned long usize) ;
#endif // ndef _S3C2510


#ifndef USB_MEM_LIB
	#error : Please Define USB_MEM_LIB on UsbCfg.h and include it !!
#endif // USB_MEM_LIB

extern int UsbMem_init(void) ;


extern int initUsbPool(void);

#ifdef USB_DBG_MEM_U_ON
	#define UsbAllocMemU UsbAllocMemU_dbg
	extern void *UsbAllocMemU(unsigned int pID,unsigned long usize);
 #else
	extern void *UsbAllocMemU(unsigned int pID);
#endif

#ifdef USB_DBG_MEM_U_ON
	#define UsbFreeMemU UsbFreeMemU_dbg
	extern int UsbFreeMemU(unsigned int pID, unsigned char *point,
    						int size);
 #else
	extern int UsbFreeMemU(unsigned int pID, unsigned char *point) ;
#endif

#ifdef USB_CODE_TYPE_DEBUG 
	extern void showUsbMemU(void) ;
	extern void DumpUsbMemU(uint pID) ;
#endif // USB_CODE_TYPE_DEBUG 


// #if defined(_S3C2510)
// #if (_UPNP >= 1)
#ifndef USB_MEM_LIB
	#error: Please Define USB_MEM_LIB !!
	#define UsbAllocMemC  alloc_mem
	#define UsbFreeMemC   free
 #else
    /*
	extern void *UsbAllocMemC(int size);
    */
	#ifdef USB_DBG_MEM_C_ON
    	#define UsbAllocMemC UsbAllocMemC_dbg
		// extern void *reqUsbMem(unsigned int pID,unsigned long usize)
	   extern  void *UsbAllocMemC(unsigned int pID,unsigned long usize) ;
	 #else
		// extern void *reqUsbMem(unsigned int pID)
	   extern void *UsbAllocMemC(unsigned int pID) ;
	#endif
    /*
	#ifdef USB_DBG_MEM_U_ON
		extern void UsbFreeMemC(void *ptr1,int size) ;
    #else
		extern void UsbFreeMemC(void *ptr);
    #endif
    */
	#ifdef USB_DBG_MEM_C_ON
    	#define UsbFreeMemC UsbFreeMemC_dbg
		extern int UsbFreeMemC(uint pID, unsigned char *point,
        						int size) ;
		// void UsbFreeMemC(void *ptr1,int size)
	 #else
		// int relUsbMem(uint pID, unsigned char *point)
		extern int UsbFreeMemC(uint pID, unsigned char *point) ;
	#endif

#endif

#ifdef USB_CODE_TYPE_DEBUG 
	extern void showUsbMemC(void) ;
	extern void DumpUsbMemC(uint pID) ;
#endif // USB_CODE_TYPE_DEBUG 

#ifndef CONFIG_PCI
   static inline void
   mem_free_consistent(size_t size,
    		void *vaddr, dma_addr_t dma_handle)
   {
	/*
		#warning : No consistent_free() !!
		consistent_free(vaddr, size, dma_handle);
	*/
	/*
	#warning : No consistent_free() !!
	// NonCache_contigmalloc() cannot be free now !!
	*/
    #ifndef USB_NO_DMA_POOL
        UsbFreeMemU(USB_MEM_U_L, (void *)dma_handle
				#if defined(USB_DBG_MEM_U_ON)
					,(int) size
				#endif
				) ;
	 #else
        UsbFreeMemU(USB_MEM_U_M, (void *)dma_handle
				#if defined(USB_DBG_MEM_U_ON)
					,(int) size
				#endif
				) ;
	#endif
    }
#endif // ndef CONFIG_PCI


// ====================================================================

#endif // ndef __USB_MEM_LIB_H__

// ====================================================================
// End of File : UsbMemLib.h
