!include ..\etcpip.def
!include ..\makeutil.ref
!include $(LOCAL_VARS)

#MACROS = -DPASN_NOPRINTON -DPASN_NOBER -D_DEBUG -DNO_NAMESPACE -DEMBD -D_STATIC_PTR -D_N_CPP_CS\
#	 -D__PUT_STATIC_DATA_MEMBERS_HERE -D_STLP_WEAK_ATTRIBUTE=0

# for USB System and HOST controller
INCLUDE_DIRS = -IForOpus -Ios_port -Icore -IHostAdm -Idev

# Applications =============================================================

# for USB OS Port
OSPORT_OBJ_FILES = UsOsport.$(O)

# for USB Core System
CORE_OBJ_FILES1 = UsDmaPol.$(O)
# CORE_OBJ_FILES1 +=  SsPcibuf.$(O)
CORE_OBJ_FILES2 = UsConfig.$(O) UsMsg.$(O) UsFile.$(O) UsUrb.$(O)
CORE_OBJ_FILES3 = UsBuffer.$(O)
CORE_OBJ_FILES4 = usb.$(O) UsDebug.$(O)
CORE_OBJ_FILES5 = hcd.$(O)
CORE_OBJ_FILES5 += hcd-init.$(O)
CORE_OBJ_FILES6 = hub.$(O)
CORE_OBJ_FILES = $(CORE_OBJ_FILES1) $(CORE_OBJ_FILES2) $(CORE_OBJ_FILES3) $(CORE_OBJ_FILES4) $(CORE_OBJ_FILES5) $(CORE_OBJ_FILES6) 

# for USB Host
# HOST_OBJ_FILES1 = usb-ohci-s3c2510.$(O)
# HOST_OBJ_FILES2 = ohci-hcd.$(O)
HOST_OBJ_FILES1 = sota-hcd.$(O)
# HOST_OBJ_FILES2 = sota-hub.$(O)
HOST_OBJ_FILES2 =

# HOST_OBJ_FILES = 
HOST_OBJ_FILES = $(HOST_OBJ_FILES1) $(HOST_OBJ_FILES2)
# HOST_OBJ_FILES = 

# for USB Device Test
DEV_OBJ_FILES1 = UsMouse.$(O)

# USB LPT
DEV_OBJ_FILES2 =

#ifneq "$(strip $(_USB_LPT))" "0"
#  TARGET_C += UsbLptIo.c
# endif
!if "$(_USB_LPT)" == "1"
	DEV_OBJ_FILES2 += UsbLptIo.$(O)
!endif

!if "$(_USB_LPT)" == "1"
	DEV_OBJ_FILES3 = UsbLpt.$(O)
!endif
#ifneq "$(strip $(_USB_LPT))" "0"
#        TARGET_C += UsbLpt.c
#endif

# USB Mass Storage Class
#ifneq "$(strip $(_USB_MS))" "0"
#        MakeDIRS += storage
#endif




DEV_OBJ_FILES = $(DEV_OBJ_FILES1) $(DEV_OBJ_FILES2) $(DEV_OBJ_FILES3)

USB_OBJ_FILES  = $(OSPORT_OBJ_FILES) $(CORE_OBJ_FILES) $(HOST_OBJ_FILES) $(DEV_OBJ_FILES)


#specific programs =========================================================

TARGET = usb

all: $(TARGET).$(L)
	echo USB Driver OK!!

clean: clean_lib
	del *.o
	del *.mm
	del *.bak
	del *.org
	del UsOsport.c
	del UsDmaPol.c
	del SsPcibuf.c
	del UsConfig.c
	del UsMsg.c
	del UsFile.c
	del UsUrb.c
	del UsBuffer.c
	del usb.c
	del UsDebug.c
	del hcd.c
	del hcd-init.c
	del hub.c
	del usb-ohci-s3c2510.c
	del ohci-hcd.c
	del sota-hcd.c
	del UsMouse.c
	del UsbLptIo.c
	del os_port\*.o
	del os_port\*.mm
	del os_port\*.bak
	del os_port\*.org
	del core\*.o
	del core\*.mm
	del core\*.bak
	del core\*.org
	del HostAdm\*.o
	del HostAdm\*.mm
	del HostAdm\*.bak
	del HostAdm\*.org
	del dev\*.o
	del dev\*.mm
	del dev\*.bak
	del dev\*.org


#object dependencies ======================================================

$(TARGET).$(L): $(USB_OBJ_FILES)
    $(RM) $@
    $(ECHO) =====================
    $(ECHO) generate $@
    $(ECHO) ---------------------
!if "$(LIBER)" == "2" # SSI Library Utility
	$(ECHO) CREATE $@ > $(TMPLNK)
	$(ECHO) $(CGI_LIB1) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB2) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB3) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB4) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB5) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB6) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB7) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB8) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB9) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB10) >> $(TMPLNK)
	$(ECHO) $(CGI_LIB11) >> $(TMPLNK)
	$(ECHO) TO $@ >> $(TMPLNK)
	$(LIBR) @$(TMPLNK)
!else
!if "$(LIBER)" == "5" # Visual C Library Utility
		$(ECHO) /OUT:$@ > $(TMPLNK)
		$(ECHO) $(CGI_LIB1) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB2) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB3) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB4) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB5) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB6) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB7) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB8) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB9) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB10) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB11) >> $(TMPLNK)
		$(LIBR) @$(TMPLNK)
!else
!if "$(LIBER)" == "6" # ARM SDT 211
		$(ECHO) $(CGI_LIB1) > $(TMPLNK)
		$(ECHO) $(CGI_LIB2) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB3) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB4) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB5) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB6) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB7) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB8) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB9) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB10) >> $(TMPLNK)
		$(ECHO) $(CGI_LIB11) >> $(TMPLNK)
		$(LIBR) -c -o $@ -v $(TMPLNK)

!else
!if "$(CODE)" == "7"      # Arm7TDMI

    $(RM) $(TMPLNK)
    $(LIBR) $@ $(H323_OBJ_FILES1) > $(TMPLNK)
	$(LIBR) $@ $(H323_OBJ_FILES11) > $(TMPLNK)
    $(LIBR) $@ $(H323_OBJ_FILES2) > $(TMPLNK)
    $(LIBR) $@ $(H323_OBJ_FILES3) > $(TMPLNK)
    $(LIBR) $@ $(H323_OBJ_FILES4) > $(TMPLNK)
    $(LIBR) $@ $(RTCP_OBJ_FILES) >> $(TMPLNK)
    @type $(TMPLNK)
!else
    $(LIBR) $@ $(ADD)UsOsport.$(O) $(ADD)UsDmaPol.$(O)
#	$(LIBR) $@ $(ADD)SsPcibuf.$(O)
    $(LIBR) $@ $(ADD)UsConfig.$(O) $(ADD)UsMsg.$(O) $(ADD)UsFile.$(O) $(ADD)UsUrb.$(O)
    $(LIBR) $@ $(ADD)UsBuffer.$(O)
    $(LIBR) $@ $(ADD)usb.$(O) $(ADD)UsDebug.$(O)
    $(LIBR) $@ $(ADD)hcd.$(O)
    $(LIBR) $@ $(ADD)hcd-init.$(O)
    $(LIBR) $@ $(ADD)hub.$(O)
#    $(LIBR) $@ $(ADD)usb-ohci-s3c2510.$(O)
#    $(LIBR) $@ $(ADD)ohci-hcd.$(O)
    $(LIBR) $@ $(ADD)sota-hcd.$(O)
    $(LIBR) $@ $(ADD)UsMouse.$(O)
    $(LIBR) $@ $(ADD)UsbLptIo.$(O) $(ADD)UsbLpt.$(O)
    
!endif
!endif
!endif
!endif
    $(RM) $(TMPLNK)
    $(RM) $*.bak

#dependence=================================================================

INCS = ..\$(KERNPTH)\config.h

CORE_H = core\UsbHcd.H core\HUB.H core\USB.H core\USBCFG.H core\USBDBG.H core\USB_CH9.H core\UsDmaPol.h 
DEV_H  = dev\LP.H dev\UsbLptIo.h
OSPORT_H = os_port\BLKDEV.H os_port\KDEV_T.H os_port\KOBJECT.H os_port\PoDevTab.h os_port\PoList.h os_port\PoWait.h os_port\PoDevice.h os_port\PoErrno.h os_port\PoFs.h os_port\PoTimer.h os_port\UsMemLib.h os_port\UsbPoPci.h os_port\UsOsport.h

INCS = ..\$(KERNPTH)\config.h $(CORE_H) $(DEV_H) $(OSPORT_H)

# UsOsport.$(O) : $(INCS) os_port\UsOsport.mm os_port\UsMemLib.mm
UsOsport.$(O) : UsOsport.c $(INCS)
UsOsport.c : os_port\UsOsport.mm os_port\UsMemLib.mm
	copy os_port\UsOsport.c UsOsport.c
os_port\UsOsport.mm : os_port\UsOsport.c
	copy os_port\UsOsport.c UsOsport.c
	copy os_port\UsOsport.c os_port\UsOsport.mm
os_port\UsMemLib.mm : os_port\UsMemLib.c
	copy os_port\UsMemLib.c UsMemLib.c
	copy os_port\UsMemLib.c os_port\UsMemLib.mm


UsDmaPol.$(O) : UsDmaPol.c $(INCS)
UsDmaPol.c : core\UsDmaPol.mm
	copy core\UsDmaPol.c UsDmaPol.c
core\UsDmaPol.mm : core\UsDmaPol.c
	copy core\UsDmaPol.c UsDmaPol.c
	copy core\UsDmaPol.c  core\UsDmaPol.mm
    
SsPcibuf.$(O) : SsPcibuf.c $(INCS)
SsPcibuf.c : core\SsPcibuf.mm
	copy core\SsPcibuf.c SsPcibuf.c
core\SsPcibuf.mm : core\SsPcibuf.c
	copy core\SsPcibuf.c SsPcibuf.c
	copy core\SsPcibuf.c core\SsPcibuf.mm

UsConfig.$(O) : UsConfig.c $(INCS)
UsConfig.c : core\UsConfig.mm
	copy core\UsConfig.c UsConfig.c
core\UsConfig.mm : core\UsConfig.c
	copy core\UsConfig.c UsConfig.c
	copy core\UsConfig.c core\UsConfig.mm

UsMsg.$(O) : UsMsg.c $(INCS)
UsMsg.c : core\UsMsg.mm
	copy core\UsMsg.c UsMsg.c
core\UsMsg.mm : core\UsMsg.c
	copy core\UsMsg.c UsMsg.c
	copy core\UsMsg.c core\UsMsg.mm

UsFile.$(O) : UsFile.c $(INCS)
UsFile.c : core\UsFile.mm
	copy core\UsFile.c UsFile.c
core\UsFile.mm : core\UsFile.c
	copy core\UsFile.c UsFile.c
	copy core\UsFile.c core\UsFile.mm

UsUrb.$(O) : UsUrb.c $(INCS)
UsUrb.c : core\UsUrb.mm
	copy core\UsUrb.c UsUrb.c
core\UsUrb.mm : core\UsUrb.c
	copy core\UsUrb.c UsUrb.c
	copy core\UsUrb.c core\UsUrb.mm

UsBuffer.$(O) : UsBuffer.c $(INCS)
UsBuffer.c : core\UsBuffer.mm
	copy core\UsBuffer.c UsBuffer.c
core\UsBuffer.mm : core\UsBuffer.c
	copy core\UsBuffer.c UsBuffer.c
	copy core\UsBuffer.c core\UsBuffer.mm

usb.$(O) : usb.c $(INCS)
usb.c : core\usb.mm
	copy core\usb.c usb.c
core\usb.mm : core\usb.c
	copy core\usb.c usb.c
	copy core\usb.c core\usb.mm

UsDebug.$(O) : UsDebug.c $(INCS)
UsDebug.c : core\UsDebug.mm
	copy core\UsDebug.c UsDebug.c
core\UsDebug.mm : core\UsDebug.c
	copy core\UsDebug.c UsDebug.c
	copy core\UsDebug.c core\UsDebug.mm

hcd.$(O) : hcd.c $(INCS) core\hcd.mm
hcd.c : core\hcd.mm
	copy core\hcd.c hcd.c
core\hcd.mm : core\hcd.c
	copy core\hcd.c hcd.c
	copy core\hcd.c core\hcd.mm

hcd-init.$(O) : hcd-init.c $(INCS)
hcd-init.c : core\hcd-init.mm
	copy core\hcd-init.c hcd-init.c
core\hcd-init.mm : core\hcd-init.c
	copy core\hcd-init.c hcd-init.c
	copy core\hcd-init.c core\hcd-init.mm

hub.$(O) : hub.c $(INCS)
hub.c : core\hub.mm
	copy core\hub.c hub.c
core\hub.mm : core\hub.c
	copy core\hub.c hub.c
	copy core\hub.c core\hub.mm


usb-ohci-s3c2510.$(O) : $(INCS) usb-ohci-s3c2510.c

ohci-hcd.$(O) : $(INCS) ohci-hcd.c

# for USB Host

sota-hcd.$(O) : sota-hcd.c $(INCS)
sota-hcd.c : HostAdm\sota-hcd.mm
	copy HostAdm\sota-hcd.c sota-hcd.c
HostAdm\sota-hcd.mm : HostAdm\sota-hcd.c
	copy HostAdm\sota-hcd.c sota-hcd.c
	copy HostAdm\sota-hcd.c HostAdm\sota-hcd.mm

sota-hub.$(O) : sota-hub.c $(INCS)
sota-hub.c : HostAdm\sota-hub.mm
	copy HostAdm\sota-hub.c sota-hub.c
HostAdm\sota-hub.mm : HostAdm\sota-hub.c
	copy HostAdm\sota-hub.c sota-hub.c
	copy HostAdm\sota-hub.c HostAdm\sota-hub.mm

# for USB Device Test

UsMouse.$(O) : UsMouse.c $(INCS)
UsMouse.c : dev\UsMouse.mm
	copy dev\UsMouse.c UsMouse.c
dev\UsMouse.mm : dev\UsMouse.c
	copy dev\UsMouse.c UsMouse.c
	copy dev\UsMouse.c dev\UsMouse.mm

UsbLptIo.$(O) : UsbLptIo.c $(INCS)
UsbLptIo.c : dev\UsbLptIo.mm
	copy dev\UsbLptIo.c UsbLptIo.c
dev\UsbLptIo.mm : dev\UsbLptIo.c
	copy dev\UsbLptIo.c UsbLptIo.c
	copy dev\UsbLptIo.c dev\UsbLptIo.mm


UsbLpt.$(O) : $(INCS) UsbLpt.c

#===========================================================================
!include ..\routine.mak