#ifndef _ARM_ERRNO_H
#define _ARM_ERRNO_H

#define	EPERM		 1	/* Operation not permitted */

#ifndef _ETCPIP
	#define	ENOENT		 2	/* No such file or directory */
#endif // ndef _ETCPIP

#ifndef _ETCPIP
	#define	ESRCH		 3	/* No such process */
#endif // ndef _ETCPIP

#ifndef	EINTR		
#define	EINTR		 4	/* Interrupted system call */
#endif
#define	EIO	         5	/* I/O error */
#define	ENXIO		 6	/* No such device or address */
#define	E2BIG		 7	/* Arg list too long */
#define	ENOEXEC		 8	/* Exec format error */
#ifndef EBADF
#define	EBADF		 9	/* Bad file number */
#endif
#define	ECHILD		10	/* No child processes */
#define	EAGAIN		11	/* Try again */
/*
#ifndef _ETCPIP
	#define	ENOMEM		12	// Out of memory 
#endif // ndef _ETCPIP
*/
#define	EACCES		13	/* Permission denied */
#define	EFAULT		14	/* Bad address */
#define	ENOTBLK		15	/* Block device required */
#define	EBUSY		16	/* Device or resource busy */

#ifndef _ETCPIP
	#define	EEXIST		17	/* File exists */
#endif // ndef _ETCPIP

#define	EXDEV		18	/* Cross-device link */
#define	ENODEV		19	/* No such device */

#ifndef _ETCPIP
	#define	ENOTDIR		20	/* Not a directory */
#endif // ndef _ETCPIP

#define	EISDIR		21	/* Is a directory */
#ifndef EINVAL
#define	EINVAL		22	/* Invalid argument */
#endif
#define	ENFILE		23	/* File table overflow */
#define	EMFILE		24	/* Too many open files */
#define	ENOTTY		25	/* Not a typewriter */
#define	ETXTBSY		26	/* Text file busy */
#define	EFBIG		27	/* File too large */
#define	ENOSPC		28	/* No space left on device */
#define	ESPIPE		29	/* Illegal seek */
#define	EROFS		30	/* Read-only file system */
#define	EMLINK		31	/* Too many links */
#define	EPIPE		32	/* Broken pipe */
#define	EDOM		33	/* Math argument out of domain of func */
#define	ERANGE		34	/* Math result not representable */
#define	EDEADLK		35	/* Resource deadlock would occur */
#ifndef ENAMETOOLONG
#define	ENAMETOOLONG	36	/* File name too long */
#endif
#define	ENOLCK		37	/* No record locks available */
#define	ENOSYS		38	/* Function not implemented */
#ifndef ENOTEMPTY
#define	ENOTEMPTY	39	/* Directory not empty */
#endif
#ifndef ELOOP
#define	ELOOP		40	/* Too many symbolic links encountered */
#endif
#ifndef EWOULDBLOCK
#define	EWOULDBLOCK	EAGAIN	/* Operation would block */
#endif
#define	ENOMSG		42	/* No message of desired type */
#define	EIDRM		43	/* Identifier removed */
#define	ECHRNG		44	/* Channel number out of range */
#define	EL2NSYNC	45	/* Level 2 not synchronized */
#define	EL3HLT		46	/* Level 3 halted */
#define	EL3RST		47	/* Level 3 reset */
#define	ELNRNG		48	/* Link number out of range */
#define	EUNATCH		49	/* Protocol driver not attached */
#define	ENOCSI		50	/* No CSI structure available */
#define	EL2HLT		51	/* Level 2 halted */
#define	EBADE		52	/* Invalid exchange */
#define	EBADR		53	/* Invalid request descriptor */
#define	EXFULL		54	/* Exchange full */
#define	ENOANO		55	/* No anode */
#define	EBADRQC		56	/* Invalid request code */
#define	EBADSLT		57	/* Invalid slot */

#define	EDEADLOCK	EDEADLK

#define	EBFONT		59	/* Bad font file format */
#define	ENOSTR		60	/* Device not a stream */
#define	ENODATA		61	/* No data available */
#define	ETIME		62	/* Timer expired */
#define	ENOSR		63	/* Out of streams resources */
#define	ENONET		64	/* Machine is not on the network */
#define	ENOPKG		65	/* Package not installed */
#ifndef EREMOTE
#define	EREMOTE		66	/* Object is remote */
#endif
#define	ENOLINK		67	/* Link has been severed */
#define	EADV		68	/* Advertise error */
#define	ESRMNT		69	/* Srmount error */
#define	ECOMM		70	/* Communication error on send */
#define	EPROTO		71	/* Protocol error */
#define	EMULTIHOP	72	/* Multihop attempted */
#define	EDOTDOT		73	/* RFS specific error */
#define	EBADMSG		74	/* Not a data message */
#define	EOVERFLOW	75	/* Value too large for defined data type */
#define	ENOTUNIQ	76	/* Name not unique on network */
#define	EBADFD		77	/* File descriptor in bad state */
#define	EREMCHG		78	/* Remote address changed */
#define	ELIBACC		79	/* Can not access a needed shared library */
#define	ELIBBAD		80	/* Accessing a corrupted shared library */
#define	ELIBSCN		81	/* .lib section in a.out corrupted */
#define	ELIBMAX		82	/* Attempting to link in too many shared libraries */
#define	ELIBEXEC	83	/* Cannot exec a shared library directly */
#define	EILSEQ		84	/* Illegal byte sequence */
#define	ERESTART	85	/* Interrupted system call should be restarted */
#define	ESTRPIPE	86	/* Streams pipe error */
#ifndef EUSERS
#define	EUSERS		87	/* Too many users */
#endif
#ifndef ENOTSOCK
#define	ENOTSOCK	88	/* Socket operation on non-socket */
#endif
#ifndef EDESTADDRREQ
#define	EDESTADDRREQ	89	/* Destination address required */
#endif
#ifndef EMSGSIZE
#define	EMSGSIZE	90	/* Message too long */
#endif
#ifndef EPROTOTYPE
#define	EPROTOTYPE	91	/* Protocol wrong type for socket */
#endif
#ifndef ENOPROTOOPT
#define	ENOPROTOOPT	92	/* Protocol not available */
#endif
#ifndef EPROTONOSUPPORT
#define	EPROTONOSUPPORT	93	/* Protocol not supported */
#endif
#ifndef ESOCKTNOSUPPORT
#define	ESOCKTNOSUPPORT	94	/* Socket type not supported */
#endif
#ifndef EOPNOTSUPP
#define	EOPNOTSUPP	95	/* Operation not supported on transport endpoint */
#endif
#ifndef EPFNOSUPPORT
#define	EPFNOSUPPORT	96	/* Protocol family not supported */
#endif
#ifndef EAFNOSUPPORT
#define	EAFNOSUPPORT	97	/* Address family not supported by protocol */
#endif
#ifndef EADDRINUSE
#define	EADDRINUSE	98	/* Address already in use */
#endif
#ifndef EADDRNOTAVAIL
#define	EADDRNOTAVAIL	99	/* Cannot assign requested address */
#endif
#ifndef ENETDOWN
#define	ENETDOWN	100	/* Network is down */
#endif
#ifndef ENETUNREACH
#define	ENETUNREACH	101	/* Network is unreachable */
#endif
#ifndef ENETRESET
#define	ENETRESET	102	/* Network dropped connection because of reset */
#endif
#ifndef ECONNABORTED
#define	ECONNABORTED	103	/* Software caused connection abort */
#endif
#ifndef ECONNRESET
#define	ECONNRESET	104	/* Connection reset by peer */
#endif
#ifndef ENOBUFS
#define	ENOBUFS		105	/* No buffer space available */
#endif
#ifndef EISCONN
#define	EISCONN		106	/* Transport endpoint is already connected */
#endif
#ifndef ENOTCONN
#define	ENOTCONN	107	/* Transport endpoint is not connected */
#endif
#ifndef ESHUTDOWN
#define	ESHUTDOWN	108	/* Cannot send after transport endpoint shutdown */
#endif
#ifndef ETOOMANYREFS
#define	ETOOMANYREFS	109	/* Too many references: cannot splice */
#endif
#ifndef ETIMEDOUT
#define	ETIMEDOUT	110	/* Connection timed out */
#endif
#ifndef ECONNREFUSED
#define	ECONNREFUSED	111	/* Connection refused */
#endif
#ifndef EHOSTDOWN
#define	EHOSTDOWN	112	/* Host is down */
#endif
#ifndef EHOSTUNREACH
#define	EHOSTUNREACH	113	/* No route to host */
#endif
#ifndef EALREADY
#define	EALREADY	114	/* Operation already in progress */
#endif
#ifndef EINPROGRESS
#define	EINPROGRESS	115	/* Operation now in progress */
#endif
#ifndef ESTALE
#define	ESTALE		116	/* Stale NFS file handle */
#endif
#define	EUCLEAN		117	/* Structure needs cleaning */
#define	ENOTNAM		118	/* Not a XENIX named type file */
#define	ENAVAIL		119	/* No XENIX semaphores available */
#define	EISNAM		120	/* Is a named type file */
#define	EREMOTEIO	121	/* Remote I/O error */
#ifndef EDQUOT
#define	EDQUOT		122	/* Quota exceeded */
#endif

#define	ENOMEDIUM	123	/* No medium found */
#define	EMEDIUMTYPE	124	/* Wrong medium type */
#define	EHASHCOLLISION	125	/* Number of hash collisions exceeds maximum generation counter value. */
#endif
