
// Name of File : usb_osport.c
// ====================================================================

#define __KERNEL__

#ifdef _NEWLIB
	#include "sys_type.h"
	#include "string.h"
#endif
#include "EtcpipDbg.h" // 2002/10/25 B. S. Liaw
          // for deciding whether to compile
          //  Debug Version or Release Version
#include "etcpip.h"
#include "UsbDbg.h"
#include "PoList.h" // osport_list.h
#include "UsbCfg.h" // Config and Setting
#include "UsOsport.h" // "usb_osport.h"
	#ifndef NO_TIMER
		#include "PoTimer.h" // osport_timer.h
	#endif // ndef NO_TIMER
#ifndef NO_WAITQUEUE
	#include  "PoWait.h" // osport_wait.h
#endif // ndef NO_WAITQUEUE
#include "kobject.h"
#include "PoDevice.h" // osport_device.h

#ifdef CONFIG_PCI
	#include "UsbPoPci.h" // usb_osport_pci.h
#endif	// CONFIG_PCI

#ifdef USB_MEM_LIB
	#include "UsMemLib.h" // UsbMemLib.h
#endif // USB_MEM_LIB

#include "UsbSysInit.h"

// ====================================================================

int volatile in_isr = 0 ;

// ====================================================================

int find_next_zero_bit (void * addr, int size, int offset)
{
 unsigned long *p = ((unsigned long *) addr) + (offset >> 5);
 unsigned long result = offset & ~31UL;
 unsigned long tmp;

 if (offset >= size)
         return size;
 size -= result;
 offset &= 31UL;
 if (offset) {
         tmp = cpu_to_le32(*(p++));
         tmp |= ~0UL >> (32-offset);
         if (size < 32)
                 goto found_first;
         if (~tmp)
                 goto found_middle;
         size -= 32;
         result += 32;
 }
 while (size & ~31UL) {
         if (~(tmp = cpu_to_le32(*(p++))))
                 goto found_middle;
         result += 32;
         size -= 32;
 }
 if (!size)
         return result;
 tmp = cpu_to_le32(*p);

 found_first:
        tmp |= ~0UL >> size;
 found_middle:
        return result + ffz(tmp);
}

/*
 * ffz = Find First Zero in word. Undefined if no zero exists,
 * so code should check against ~0UL first..
 */
unsigned long ffz(unsigned long word_d)
{
        int k;

        word_d = ~word_d;
        k = 31;
        if (word_d & 0x0000ffff) { k -= 16; word_d <<= 16; }
        if (word_d & 0x00ff0000) { k -= 8;  word_d <<= 8;  }
        if (word_d & 0x0f000000) { k -= 4;  word_d <<= 4;  }
        if (word_d & 0x30000000) { k -= 2;  word_d <<= 2;  }
        if (word_d & 0x40000000) { k -= 1; }
        return k;
}

// dma_free_consistent() / pci_free_consistent()

#ifdef CONFIG_PCI
	void *pci_alloc_consistent(struct pci_dev *hwdev, size_t size,
          dma_addr_t *handle)
 #else
	void *mem_alloc_consistent(size_t size,
          dma_addr_t *handle)
#endif
{
 void *__ret;
 

 USB_DBG_MEM(iprintf(
    "[USB MEM] pci_alloc_consistent() : size = %d (%04XH) \n",
    size , size ));
 /*    
 #ifndef _ETCPIP
    int __gfp = GFP_KERNEL;
 
    #ifdef CONFIG_PCI
     if ((hwdev) == NULL ||
         (hwdev)->dma_mask != 0xffffffff)
    #endif
                __gfp |= GFP_DMA;
    // ryc++ must allocate at non-cache region 
    #ifdef CONFIG_BOARD_SMDK2510
        __gfp |= GFP_DMA;
    #endif
 #endif // ndef _ETCPIP
 */
 /*
 #ifndef _ETCPIP
    __ret = consistent_alloc(__gfp, (size),
                                 (handle));
  #else
 */
	/*
	#ifndef USB_MEM_LIB
		__ret = NonCache_contigmalloc(size) ;
		// NonCache_contigmalloc() cannot be free now !!
     #else
	*/
   	// __ret = alloc_mem(size) ;
	// __ret |= 0x4000000 ; // B. S. Liaw : Donot Attemp to Do this !!
	USB_DBG_MEM_U(iprintf(
	    "[USB MEM_U] pci_alloc_consistent() Call UsbAllocMemU ..\n"
    	));
    __ret = (void *)
    #ifndef USB_NO_DMA_POOL
        	UsbAllocMemU(USB_MEM_U_L
				#ifdef USB_DBG_MEM_U_ON
    		        ,size
	            #endif
    	        );

	 #else
        	UsbAllocMemU(USB_MEM_U_M
				#ifdef USB_DBG_MEM_U_ON
    		        ,size
	            #endif
    	        );
        
	#endif   
	/*
    #endif
	*/
 /*
 #endif
 */

 *handle = (dma_addr_t) __ret ;
 
 USB_DBG_MEM(iprintf(
    "[USB MEM] pci_alloc_consistent() : __ret = %08XH \n",__ret));
 USB_DBG_MEM(iprintf(
    "[USB MEM] pci_alloc_consistent() : handle = %08XH \n",handle));
 USB_DBG_MEM(iprintf(
    "[USB MEM] pci_alloc_consistent() : *handle = %08XH \n",*handle));
 if ( __ret == NULL )  {
	USB_DBG_INFO(iprintf(
		"[USB INFO] pci_alloc_consistent() : Error : couldn't allocate memory !! \n"));
	dprintf("[USB] Error : Out of Memory !! \n");
	}
 return __ret;
}

/*
 *  Registration of PCI drivers and handling of hot-pluggable devices.
 */

#ifdef CONFIG_PCI
	LIST_HEAD(pci_devices);

	static LIST_HEAD(pci_drivers);

#endif // CONFIG_PCI



/**
 * pci_dev_driver - get the pci_driver of a device
 * @dev: the device to query
 *
 * Returns the appropriate pci_driver structure or %NULL if there is no 
 * registered driver for the device.
 */
#ifdef CONFIG_PCI

struct pci_driver *
pci_dev_driver(const struct pci_dev *dev)
{
 USB_DBG_FLOW(iprintf("[USB FLOW] pci_dev_driver() Begin ..\n"));
 if (dev->driver)
    {
     USB_DBG_FLOW(iprintf("[USB FLOW] pci_dev_driver() End. \n"));
     return dev->driver;
    }    
 #ifndef _ETCPIP
        else {
                int i;
                for(i=0; i<=PCI_ROM_RESOURCE; i++)
                        if (dev->resource[i].flags & IORESOURCE_BUSY)
                                return &pci_compat_driver;
        }
 #endif // ndef _ETCPIP
 
 USB_DBG_FLOW(iprintf(
    "[USB FLOW] pci_dev_driver() End with NULL !! \n"));
 return NULL;
}
#endif // CONFIG_PCI


#ifndef _ETCPIP
/*
static int
pci_announce_device(struct pci_driver *drv, struct pci_dev *dev)
{
 const struct pci_device_id *id;
 int ret = 0;
 USB_DBG_FLOW(iprintf("[USB FLOW] pci_announce_device() Begin ..\n"));

 #ifndef _ETCPIP
        
        if (drv->id_table) {
                id = pci_match_device(drv->id_table, dev);
                if (!id) {
                        ret = 0;
                        goto out;
                }
        } else
                id = NULL;

        dev_probe_lock();
        
 #endif // ndef _ETCPIP
 
 if (drv->probe(dev, id) >= 0) 
    {
     USB_DBG_INIT(iprintf(
        "[USB INIT] pci_announce_device() : find driver \n"));
     dev->driver = drv;
     ret = 1;
    }
    
 #ifndef _ETCPIP
        dev_probe_unlock();
 #endif // ndef _ETCPIP
 
 out:
   USB_DBG_FLOW(iprintf("[USB FLOW] pci_announce_device() End. \n"));
   return ret;
}
*/
#endif // ndef _ETCPIP


/**
 * pci_register_driver - register a new pci driver
 * @drv: the driver structure to register
 * 
 * Adds the driver structure to the list of registered drivers
 * Returns the number of pci devices which were claimed by the driver
 * during registration.  The driver remains registered even if the
 * return value is zero.
 */
#ifndef _ETCPIP
/*
int
pci_register_driver(struct pci_driver *drv)
{
 struct pci_dev *dev;
 int count = 0;
 
 USB_DBG_FLOW(iprintf("[USB FLOW] pci_register_driver() Begin ..\n"));
 list_add_tail(&drv->node, &pci_drivers);
 
 pci_for_each_dev(dev)
    {
     USB_DBG_INIT(iprintf(
        "[USB INIT] pci_register_driver() : find dev \n"));
        
     if (!pci_dev_driver(dev))
        {
         USB_DBG_INIT(iprintf(
            "[USB INIT] pci_register_driver() : find driver \n"));
         count += pci_announce_device(drv, dev);
        }
    }
    
 USB_DBG_INIT(iprintf(
    "[USB INIT] pci_register_driver() driver count = %d \n",
    count
    ));

 USB_DBG_FLOW(iprintf("[USB FLOW] pci_register_driver() End.\n"));
 return count;
}
*/
#endif // ndef _ETCPIP



// ====================================================================
// /kernel/timer.c
// ====================================================================

#ifndef NO_TIMER
// ====================================================================

unsigned long volatile jiffies;


/*
 * Event timer code
 */
#define TVN_BITS 6
#define TVR_BITS 8
#define TVN_SIZE (1 << TVN_BITS)
#define TVR_SIZE (1 << TVR_BITS)
#define TVN_MASK (TVN_SIZE - 1)
#define TVR_MASK (TVR_SIZE - 1)

struct timer_vec {
        int index;
        struct list_head vec[TVN_SIZE];
};

struct timer_vec_root {
        int index;
        struct list_head vec[TVR_SIZE];
};

static struct timer_vec tv5;
static struct timer_vec tv4;
static struct timer_vec tv3;
static struct timer_vec tv2;
static struct timer_vec_root tv1;

static struct timer_vec * const tvecs[] = {
        (struct timer_vec *)&tv1, &tv2, &tv3, &tv4, &tv5
};

#define NOOF_TVECS (sizeof(tvecs) / sizeof(tvecs[0]))

void init_timervecs (void)
{
 int i;

 USB_DBG_FLOW(iprintf("[USB FLOW] init_timervecs() Begin ..\n"));
 for (i = 0; i < TVN_SIZE; i++) {
         INIT_LIST_HEAD(tv5.vec + i);
         INIT_LIST_HEAD(tv4.vec + i);
         INIT_LIST_HEAD(tv3.vec + i);
         INIT_LIST_HEAD(tv2.vec + i);
     }
 for (i = 0; i < TVR_SIZE; i++)
         INIT_LIST_HEAD(tv1.vec + i);
 USB_DBG_FLOW(iprintf("[USB FLOW] init_timervecs() End.\n"));
}

	static unsigned long timer_jiffies;
static inline void internal_add_timer(struct timer_list *timer)
{
 /*
  * must be cli-ed when calling this
  */
 unsigned long expires = timer->expires;
 unsigned long idx = expires - timer_jiffies;
 struct list_head * vec;

 USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() Begin ..\n"));
 
 if (idx < TVR_SIZE)
    {
     int i = expires & TVR_MASK;
     USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() tv1 (root)\n"));
     vec = tv1.vec + i;
     USB_DBG_TIMER(iprintf("[USB TIMER]  i = %04XH , vec = %08XH \n",
         i, vec ));
    }
 else if (idx < 1 << (TVR_BITS + TVN_BITS))
    {
             int i = (expires >> TVR_BITS) & TVN_MASK;
 USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() Case 2 \n"));
             vec = tv2.vec + i;
     }
 else if (idx < 1 << (TVR_BITS + 2 * TVN_BITS)) {
             int i = (expires >> (TVR_BITS + TVN_BITS)) & TVN_MASK;
 USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() Case 3 \n"));
             vec =  tv3.vec + i;
     }
 else if (idx < 1 << (TVR_BITS + 3 * TVN_BITS)) {
             int i = (expires >> (TVR_BITS + 2 * TVN_BITS)) & TVN_MASK;
 USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() Case 4 \n"));
             vec = tv4.vec + i;
     }
 else if ((signed long) idx < 0)
     {
             /* can happen if you add a timer with expires == jiffies,
              * or you set a timer to go off in the past
              */
      USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() Case 5 \n"));
             vec = tv1.vec + tv1.index;
     }
 else if (idx <= 0xffffffffUL)
     {
             int i = (expires >> (TVR_BITS + 3 * TVN_BITS)) & TVN_MASK;
 USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() Case 6 \n"));
             vec = tv5.vec + i;
     }
 else 
     {
             /* Can only get here on architectures with 64-bit jiffies */
      USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() Case 7 \n"));
             INIT_LIST_HEAD(&timer->list);
             return;
     }
 /*
  * Timers are FIFO!
  */
 USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() add to list .. \n"));
 USB_DBG_TIMER(iprintf("[USB TIMER]  &timer->list = %08XH , vec->prev = %08XH \n",
     &timer->list,vec->prev));
     
 #ifdef USB_BS_ASSERT
    if  ( !( vec->prev > 0
        )  )
        {
         iprintf("[ASSERT][USB] internal_add_timer() : " ) ;
         iprintf("Error : vec->prev !!\n" ) ;
         iprintf("[ASSERT][USB] Continue ....\n") ;
        }
 #endif
 // Insert a new entry after the specified head.
 // list_add(struct list_head *new, struct list_head *head)
 list_add(&timer->list, vec->prev);
 
 USB_DBG_TIMER(iprintf("[USB TIMER]  internal_add_timer() End.\n"));
}

#define timer_enter(t)          do { } while (0)
#define timer_exit()            do { } while (0)

void add_timer(struct timer_list *timer)
{
 	unsigned long flags;

    USB_DBG_TIMER(iprintf("[USB TIMER]  add_timer() Begin ..\n"));
 	#ifndef NO_SPINLOCK
       spin_lock_irqsave(&timerlist_lock, flags);
     #else
       // BLOCK_PREEMPTION;
 	#endif // ndef NO_SPINLOCK
    if (timer_pending(timer))
       {
        dprintf("[USB] timer pending !!.\n") ;
        goto bug;
       }
    internal_add_timer(timer);
    
 	#ifndef NO_SPINLOCK
        spin_unlock_irqrestore(&timerlist_lock, flags);
     #else
       // UNBLOCK_PREEMPTION;
 	#endif // ndef NO_SPINLOCK
    USB_DBG_TIMER(iprintf("[USB TIMER]  add_timer() End.\n"));
    return;
 bug:
    #ifndef NO_SPINLOCK
        spin_unlock_irqrestore(&timerlist_lock, flags);
     #else
       // UNBLOCK_PREEMPTION;
    #endif // ndef NO_SPINLOCK
    #ifdef _ETCPIP
        printk("bug: kernel timer added twice at %p.\n",
                        __builtin_return_address(0));
     #else
        dprintf("[USB] bug: kernel timer added twice !!.\n") ;
                        
    #endif
    USB_DBG_TIMER(iprintf("[USB TIMER]  add_timer() End With Fail !!\n"));
}


static inline int detach_timer (struct timer_list *timer)
{
        if (!timer_pending(timer))
                return 0;
        list_del(&timer->list);
        return 1;
}
/*
int mod_timer(struct timer_list *timer, unsigned long expires)
{
        int ret;
        unsigned long flags;

        spin_lock_irqsave(&timerlist_lock, flags);
        timer->expires = expires;
        ret = detach_timer(timer);
        internal_add_timer(timer);
        spin_unlock_irqrestore(&timerlist_lock, flags);
        return ret;
}
*/
int del_timer(struct timer_list * timer)
{
        int ret;
        unsigned long flags;

 #ifndef NO_SPINLOCK
        spin_lock_irqsave(&timerlist_lock, flags);
 #endif // ndef NO_SPINLOCK
       ret = detach_timer(timer);
        timer->list.next = timer->list.prev = NULL;
 #ifndef NO_SPINLOCK
        spin_unlock_irqrestore(&timerlist_lock, flags);
 #endif // ndef NO_SPINLOCK
        return ret;
}

static inline void cascade_timers(struct timer_vec *tv)
{
        /* cascade all the timers from tv up one level */
        struct list_head *head, *curr, *next;

        head = tv->vec + tv->index;
        curr = head->next;
        /*
         * We are removing _all_ timers from the list, so we don't  have to
         * detach them individually, just clear the list afterwards.
         */
        while (curr != head) {
                struct timer_list *tmp;

                tmp = list_entry(curr, struct timer_list, list);
                next = curr->next;
                list_del(curr); // not needed
                internal_add_timer(tmp);
                curr = next;
        }
        INIT_LIST_HEAD(head);
        tv->index = (tv->index + 1) & TVN_MASK;
}


static inline void run_timer_list(void)
{
 #ifndef NO_SPINLOCK
        spin_lock_irq(&timerlist_lock);
     #else
       // BLOCK_PREEMPTION;
 #endif // ndef NO_SPINLOCK
 while ((long)(jiffies - timer_jiffies) >= 0)
   {
    struct list_head *head, *curr;
    
	#ifndef NO_TIMER
         ++ jiffies; 
	#endif // ndef NO_TIMER
    if (!tv1.index)
       {
		int n = 1;
        do {
        	cascade_timers(tvecs[n]);
           } while (tvecs[n]->index == 1 && ++n < NOOF_TVECS);
       }
       
 repeat:
 
    // BLOCK_PREEMPTION;
    head = tv1.vec + tv1.index;
    curr = head->next;
    // UNBLOCK_PREEMPTION;
    
    if (curr != head)
       {
    	struct timer_list *timer;
        void (*fn)(unsigned long);
        unsigned long data;

	    // BLOCK_PREEMPTION;
        timer = list_entry(curr, struct timer_list, list);
    	// UNBLOCK_PREEMPTION;
        fn = timer->function;
        data= timer->data;

        detach_timer(timer);
        timer->list.next = timer->list.prev = NULL;
        
        // dprintf("[USB] timer_enter() ..\n") ;
        timer_enter(timer);
        #ifndef NO_SPINLOCK
            spin_unlock_irq(&timerlist_lock);
         #else
       		// UNBLOCK_PREEMPTION;
        #endif // ndef NO_SPINLOCK
        
        USB_DBG_TIMER(iprintf(
            "[USB TIMER] timer call .....\n")) ;
        fn(data);
        #ifndef NO_SPINLOCK
            spin_lock_irq(&timerlist_lock);
     	 #else
       		// BLOCK_PREEMPTION;
        #endif // ndef NO_SPINLOCK
        
        timer_exit();
        
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
		#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
			// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
			dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
	     #else
	        #error : Please Make Sure !!
	        // YIELD();
		#endif
        goto repeat;
       }
    ++timer_jiffies; 
    tv1.index = (tv1.index + 1) & TVR_MASK;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
	#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
		// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
		dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
     #else
        #error : Please Make Sure !!
        // YIELD();
	#endif
   } // while
 #ifndef NO_SPINLOCK
	spin_unlock_irq(&timerlist_lock);
  #else
    // UNBLOCK_PREEMPTION;
 #endif // ndef NO_SPINLOCK
}


/**
 * schedule_timeout - sleep until timeout
 * @timeout: timeout value in jiffies
 *
 * Make the current task sleep until @timeout jiffies have
 * elapsed. The routine will return immediately unless
 * the current task state has been set (see set_current_state()).
 *
 * You can set the task state as follows -
 *
 * %TASK_UNINTERRUPTIBLE - at least @timeout jiffies are guaranteed to
 * pass before the routine returns. The routine will return 0
 *
 * %TASK_INTERRUPTIBLE - the routine may return early if a signal is
 * delivered to the current task. In this case the remaining time
 * in jiffies will be returned, or 0 if the timer expired in time
 *
 * The current task state is guaranteed to be TASK_RUNNING when this 
 * routine returns.
 *
 * Specifying a @timeout value of %MAX_SCHEDULE_TIMEOUT will schedule
 * the CPU away without a bound on the timeout. In this case the return
 * value will be %MAX_SCHEDULE_TIMEOUT.
 *
 * In all cases the return value is guaranteed to be non-negative.
 */


#ifndef _ETCPIP
	signed long schedule_timeout(signed long timeout)
 #else
	signed long usb_schedule_timeout(signed long timeout)
#endif
{
 #ifndef _ETCPIP
	struct timer_list timer;
 #endif // ndef _ETCPIP
 unsigned long expire;


 #ifndef _ETCPIP
	switch (timeout)
        {
        case MAX_SCHEDULE_TIMEOUT:
                /*
                 * These two special cases are useful to be comfortable
                 * in the caller. Nothing more. We could take
                 * MAX_SCHEDULE_TIMEOUT from one of the negative value
                 * but I' d like to return a valid offset (>=0) to allow
                 * the caller to do everything it want with the retval.
                 */
                schedule();
                goto out;
        default:
                /*
                 * Another bit of PARANOID. Note that the retval will be
                 * 0 since no piece of kernel is supposed to do a check
                 * for a negative retval of schedule_timeout() (since it
                 * should never happens anyway). You just have the printk()
                 * that will tell you if something is gone wrong and where.
                 */
                if (timeout < 0)
                {
                        printk(KERN_ERR "usb_schedule_timeout : wrong timeout "
                               "value %lx from %p\n", timeout,
                               __builtin_return_address(0));
                        current->state = TASK_RUNNING;
                        goto out;
                }
        }
   #endif // ndef _ETCPIP

   #ifndef _ETCPIP
        expire = timeout + jiffies;
    #else
      // dlytsk(cur_task, DLY_SECS, sec);
      // dlytsk(cur_task, DLY_TICKS, timeout);
      
      DELAYTK(timeout) ;
      
      /*    
       while (expire > jiffies)
          {
           jiffies ++ ;
           // dprintf("[WAIT] GetTime() = %08XH\n",GetTime()) ;
           YIELD();
          }
      */
   #endif
      
   #ifndef _ETCPIP
   		/*
        init_timer(&timer);
        timer.expires = expire;
        timer.data = (unsigned long) current;
        timer.function = process_timeout;

        add_timer(&timer);
        schedule();
        del_timer_sync(&timer);

        timeout = expire - jiffies;
        */
   #endif // ndef _ETCPIP

 out:
   #ifndef _ETCPIP
        return timeout < 0 ? 0 : timeout;
    #else
        return 0 ;
   #endif
}




// #ifdef _ETCPIP
void usb_timer_task(void)
{
 #ifdef _ETCPIP
      jiffies = 1 ; 
 #endif

 /*
  * We have to do a little magic to get the first
  * process right in SMP mode.
  */
 /* 
 int cpu = smp_processor_id();
 int nr;

 init_task.processor = cpu;

 for(nr = 0; nr < PIDHASH_SZ; nr++)
         pidhash[nr] = NULL;
 */
 /*
 B. S. Liaw : move to usb.c
 init_timervecs();
 */
 /*
 init_bh(TIMER_BH, timer_bh);
 init_bh(TQUEUE_BH, tqueue_bh);
 
 init_bh(IMMEDIATE_BH, immediate_bh);
 */
 /*
  * The boot idle thread does lazy MMU switching as well:
  */
 /*
 atomic_inc(&init_mm.mm_count);
 enter_lazy_tlb(&init_mm, current, cpu);
 */
 for (;;)
   {
 #ifdef USB_DBG_MEM_AREA_VERIFY_ON
	USB_DBG_AREA_MSG(iprintf("[USB AREA] usb_timer_task() : Verify Memory Area ..\n")) ;
		if (! VerifyMemArea() ) {
			iprintf("[USB] usb_timer_task() Verify Memory Area Error !\n") ;
	       }
 #endif // USB_DBG_MEM_AREA_VERIFY_ON
    // BLOCK_PREEMPTION;
    ++ jiffies; 
    run_timer_list() ;
      // UNBLOCK_PREEMPTION;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
	#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
		// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
		dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
     #else
        #error : Please Make Sure !!
        // YIELD();
    #endif
    #ifdef USB_DBG_ABORT   
        // vvv for debug Prefetch Error !!
        dprintf("[TEST] GetTime() = %08XH\n",GetTime()) ;
		#ifdef USB_BS_SYSCAL_ASSERT
			if (!(  mt_busy == 0
		         )
			   )
			   {
				iprintf("[ASSERT][USB] wait_ms() : " ) ;
    		    iprintf("Error : mt_busy not zero !! %d \n",mt_busy) ;
			    iprintf("[ASSERT][USB] Continue ..\n") ;
    		   }
		#endif // USB_BS_ASSERT
			#ifdef USB_WAIT_DLY_TSK // use dlytsk() to replace YIELD()
				// dlytsk(cur_task, DLY_TICKS, 1+TIME_PLUS) ;
				dlytsk(cur_task, DLY_TICKS, USB_DLY_TSK_TICK) ;
             #else
            	YIELD();
            #endif
		#ifndef NO_TIMER
    	    dprintf("[TEST] jiffies = %08XH\n",jiffies) ;
		#endif // ndef NO_TIMER
        // ^^^ for debug Prefetch   
    #endif   
   }
}
// #endif // _ETCPIP


// ====================================================================
#endif // ndef NO_TIMER

// ====================================================================
// /kernel/fork.c
// ====================================================================

#ifndef NO_WAITQUEUE
	
  void add_wait_queue(wait_queue_head_t *q, wait_queue_t * wait)
  {
        unsigned long flags;

        wait->flags &= ~WQ_FLAG_EXCLUSIVE;
   #ifndef NO_SPINLOCK
        wq_write_lock_irqsave(&q->lock, flags);
   #endif // ndef NO_SPINLOCK
   
   __add_wait_queue(q, wait); // q : head , wait : new
   
   #ifndef NO_SPINLOCK
        wq_write_unlock_irqrestore(&q->lock, flags);
   #endif // ndef NO_SPINLOCK
  }
  
void remove_wait_queue(wait_queue_head_t *q, wait_queue_t * wait)
{
        unsigned long flags;

  #ifndef NO_SPINLOCK
        wq_write_lock_irqsave(&q->lock, flags);
  #endif // ndef NO_SPINLOCK
        __remove_wait_queue(q, wait);
  #ifndef NO_SPINLOCK
        wq_write_unlock_irqrestore(&q->lock, flags);
  #endif // ndef NO_SPINLOCK
}


/*
 * The core wakeup function.  Non-exclusive wakeups (nr_exclusive == 0) just wake everything
 * up.  If it's an exclusive wakeup (nr_exclusive == small +ve number) then we wake all the
 * non-exclusive tasks and one exclusive task.
 *
 * There are circumstances in which we can try to wake a task which has already
 * started to run but is not in state TASK_RUNNING.  try_to_wake_up() returns zero
 * in this (rare) case, and we handle it by contonuing to scan the queue.
 */
 
#ifndef _ETCPIP
   static inline void __wake_up_common (wait_queue_head_t *q, unsigned int mode,
                                     int nr_exclusive, const int sync)
   {
        struct list_head *tmp;
	#ifndef _ETCPIP
        struct task_struct *p;
    #endif
        CHECK_MAGIC_WQHEAD(q);
        WQ_CHECK_LIST_HEAD(&q->task_list);
        
        list_for_each(tmp,&q->task_list) {
                unsigned int state;
                wait_queue_t *curr = list_entry(tmp, wait_queue_t, task_list);

                CHECK_MAGIC(curr->__magic);
             #ifndef _ETCPIP
                p = curr->task;
                state = p->state;
                if (state & mode) {
                        WQ_NOTE_WAKER(curr);
                        if (try_to_wake_up(p, sync) && (curr->flags&WQ_FLAG_EXCLUSIVE) && !--nr_exclusive)
                                break;
                }
             #endif // ndef _ETCPIP
        }
    }
 #else
   static inline void __wake_up_common (wait_queue_head_t *q,
                                     int nr_exclusive, const int sync)
   {
	struct list_head *tmp;
	#ifndef _ETCPIP
    	struct task_struct *p;
    #endif

    CHECK_MAGIC_WQHEAD(q);
    WQ_CHECK_LIST_HEAD(&q->task_list);
    
    list_for_each(tmp,&q->task_list)
	   {
        unsigned int state;
        wait_queue_t *curr = list_entry(tmp, wait_queue_t, task_list);

        CHECK_MAGIC(curr->__magic);
        #ifndef _ETCPIP
            p = curr->task;
            state = p->state;
            if (state & mode) {
                    WQ_NOTE_WAKER(curr);
                    if (try_to_wake_up(p, sync) && (curr->flags&WQ_FLAG_EXCLUSIVE) && !--nr_exclusive)
                            break;
            }
         #else
           curr->task_ok = 1 ;
        #endif // ndef _ETCPIP
       }
   }

#endif


#ifndef _ETCPIP
  void __wake_up(wait_queue_head_t *q, unsigned int mode, int nr)
  {
        if (q) {
                unsigned long flags;
  #ifndef NO_SPINLOCK
                wq_read_lock_irqsave(&q->lock, flags);
  #endif // ndef NO_SPINLOCK
                __wake_up_common(q, mode, nr, 0);
  #ifndef NO_SPINLOCK
                wq_read_unlock_irqrestore(&q->lock, flags);
  #endif // ndef NO_SPINLOCK
        }
 }
#else
  void __wake_up(wait_queue_head_t *q, int nr)
  {
        if (q) {
                unsigned long flags;
  #ifndef NO_SPINLOCK
                wq_read_lock_irqsave(&q->lock, flags);
  #endif // ndef NO_SPINLOCK
                __wake_up_common(q, nr, 0);
  #ifndef NO_SPINLOCK
                wq_read_unlock_irqrestore(&q->lock, flags);
  #endif // ndef NO_SPINLOCK
        }
 }
#endif

  
#endif // ndef NO_WAITQUEUE



// ====================================================================
// in fs/sysfs/inode.c
// ====================================================================

#ifndef _ETCPIP
   struct dentry * sysfs_get_dentry(struct dentry * parent, const char * name)
   {
	struct qstr qstr;

	#ifdef USB_DBGSTRING_ON
		qstr.name = name;
	#endif // USB_DBGSTRING_ON
	qstr.len = strlen(name);
	#ifndef _ETCPIP
		qstr.hash = full_name_hash(name,qstr.len);
	#endif // ndef _ETCPIP
	return lookup_hash(&qstr,parent);
   }
#endif // ndef _ETCPIP

// ====================================================================
// in fs/sysfs/symlink.c
// ====================================================================

#define PATH_MAX        4096    /* # chars in a path name including nul */

/*
static int sysfs_symlink(struct inode * dir, struct dentry *dentry, const char * symname)
{
        int error;

        error = sysfs_create(dentry, S_IFLNK|S_IRWXUGO, init_symlink);
        if (!error) {
                int l = strlen(symname)+1;
                error = page_symlink(dentry->d_inode, symname, l);
                if (error)
                        iput(dentry->d_inode);
        }
        return error;
}
*/

/**
 *      sysfs_create_link - create symlink between two objects.
 *      @kobj:  object whose directory we're creating the link in.
 *      @target:        object we're pointing to.
 *      @name:          name of the symlink.
 */

#ifndef _ETCPIP
/*
int sysfs_create_link(struct kobject * kobj, struct kobject * target, char * name)
{
 struct dentry * dentry = kobj->dentry;
 struct dentry * d;
 int error = 0;
 int size;
 int depth = 0;
 char * path;
 char * s;


 #ifndef _ETCPIP
 depth = object_depth(kobj);
 #endif // ndef _ETCPIP
 size = object_path_length(target) + depth * 3 - 1;
 if (size > PATH_MAX)
         return -ENAMETOOLONG;
 dprintf("[USB] %s: depth = %d, size = %d\n",__FUNCTION__,depth,size);

 #ifndef _ETCPIP
 	path = kmalloc(size,GFP_KERNEL);
  #else
	// buf = mouse_buf_array ;
	// buf = NonCache_contigmalloc(63) ;
    
    // B. S. Liaw : alloc_mem is on mt_??/USFSup1.c
    //              But now on ap/upnp/upnpport.c
    //              void *alloc_mem(int size) 
    //              this will fill all 0s

    // BLOCK_PREEMPTION;

			path = ( char * )
		#ifdef USB_DBG_MEM_U_ON
				UsbAllocMemC(USB_MEM_C_L, size ) ;
         #else
			    UsbAllocMemC( size ) ;
        #endif
                 
    // UNBLOCK_PREEMPTION;

    USB_DBG_MEM(iprintf("[USB MEM] path = %08XH \n",path));

    if ( path == NULL )
       {
		dprintf("out of memory\n");
	   }
 #endif

 if (!path)
         return -ENOMEM;
 #ifndef _ETCPIP
	memset(path,0,size);
 #endif

 for (s = path; depth--; s += 3)
         strcpy(s,"../");

 fill_object_path(target,path,size);
 dprintf("[USB] %s: path = '%s'\n",__FUNCTION__,path);

 #ifndef NO_SEMPHORE
        down(&dentry->d_inode->i_sem);
 #endif // ndef NO_SEMPHORE
 #ifndef _ETCPIP
        d = sysfs_get_dentry(dentry,name);
 #endif // ndef _ETCPIP
        if (!IS_ERR(d))
           {
 #ifndef _ETCPIP
                error = sysfs_symlink(dentry->d_inode,d,path);
 #endif
           }
        else
          {
 #ifndef _ETCPIP
           error = PTR_ERR(d);
 #endif
          }
                
 #ifndef NO_SEMPHORE
        up(&dentry->d_inode->i_sem);
 #endif // ndef NO_SEMPHORE
 #ifndef _ETCPIP
		kfree(path);
	#elif defined(USB_DBG_MEM_U_ON)
		UsbFreeMemC(USB_MEM_C_L,path,sizeof(*path));
	#else
		UsbFreeMemC(USB_MEM_C_L,path);
	#endif
 return error;
}
*/
#endif // ndef _ETCPIP




/*
// ====================================================================
// in lib/kobject.c
// ====================================================================

//
//      kobject_init - initialize object.
//      @kobj:  object in question.


void kobject_init(struct kobject * kobj)
{
 // #ifndef _ETCPIP
        atomic_set(&kobj->refcount,1);
 // #endif // ndef _ETCPIP
 INIT_LIST_HEAD(&kobj->entry);
 kobj->kset = kset_get(kobj->kset);
}

//
//      kobject_get - increment refcount for object.
//      @kobj:  object.


struct kobject * kobject_get(struct kobject * kobj)
{
 struct kobject * ret = kobj;
 
 #ifndef NO_SPINLOCK
        spin_lock(&kobj_lock);
 #endif // ndef NO_SPINLOCK
 
 if (kobj && atomic_read(&kobj->refcount) > 0)
   {
	atomic_inc(&kobj->refcount);
   }
  else
   {
	ret = NULL;
   }
                
 #ifndef NO_SPINLOCK
        spin_unlock(&kobj_lock);
 #endif // ndef NO_SPINLOCK
        return ret;
}
//
//      kobject_add - add an object to the hierarchy.
//      @kobj:  object.
//

int kobject_add(struct kobject * kobj)
{
 int error = 0;
 #ifndef NO_KSET
 struct kobject * parent;
 #endif // ndef NO_KSET

 if (!(kobj = kobject_get(kobj)))
                return -ENOENT;

 #ifndef NO_KSET
 parent = kobject_get(kobj->parent);
 #endif // ndef NO_KSET

 #ifdef USB_DBGSTRING_ON
        dprintf("[USB] kobject [%s] registering. parent: [%s], set: [%s] \n",
                 kobj->name, parent ? parent->name : "<NULL>", 
                 kobj->kset ? kobj->kset->kobj.name : "<NULL>" );
  #else
        dprintf("[USB] kobject registering ..\n") ;
 #endif

 if (kobj->kset) {
	#ifndef NO_SEMPHORE
                down_write(&kobj->kset->subsys->rwsem);
	#endif // ndef NO_SEMPHORE

 #ifndef NO_KSET
    if (parent) 
        list_add_tail(&kobj->entry,&parent->entry);
      else {
		list_add_tail(&kobj->entry,&kobj->kset->list);
                        kobj->parent = kobject_get(&kobj->kset->kobj);
       }
 #endif // ndef NO_KSET

	#ifndef NO_SEMPHORE
                up_write(&kobj->kset->subsys->rwsem);
	#endif // ndef NO_SEMPHORE
   }

 #ifndef _ETCPIP
        error = create_dir(kobj);
        if (error)
                unlink(kobj);
 #endif

 return error;
}

//
//      kobject_register - initialize and add an object.
//      @kobj:  object in question.




int kobject_register(struct kobject * kobj)
{
        int error = 0;
        if (kobj) {
                kobject_init(kobj);
                error = kobject_add(kobj);
 #ifndef _ETCPIP
                WARN_ON(error);
 #endif // ndef _ETCPIP
        } else
                error = -EINVAL;
        return error;
}
*/

/**
 *      interface_add_dev - add device to interfaces.
 *      @dev:   device.
 *
 *      This is a helper for the class driver core. When a 
 *      device is being added to a class, this is called to add
 *      the device to all the interfaces in the class.
 *
 *      The operation is simple enough: loop over the interfaces
 *      and call add() [above] for each. The class rwsem is assumed
 *      to be held.
 */

// ====================================================================
// in drivers/base/intf.c
// ====================================================================

/**
 *      intf_dev_link - create sysfs symlink for interface.
 *      @intf:  interface.
 *      @dev:   device.
 *
 *      Create a symlink 'phys' in the interface's directory to 
 */

#ifndef _ETCPIP
static int intf_dev_link(struct device_interface * intf, struct device * dev)
{
        return sysfs_create_link(&intf->kset.kobj,&dev->kobj,dev->bus_id);
}
#endif // ndef _ETCPIP


/**
 *      add - attach device to interface
 *      @intf:  interface.
 *      @dev:   device.
 *
 *      This is just a simple helper. Check the interface's interface
 *      helper and call it. This is called when adding an interface
 *      the class's devices, or a device to the class's interfaces.
 */

static int add(struct device_interface * intf, struct device * dev)
{
 int error = 0;

 if (intf->add_device) {
         if (!(error = intf->add_device(dev)))
         {
 #ifndef _ETCPIP
          intf_dev_link(intf,dev);
 #endif // ndef _ETCPIP
         }
 }
 dprintf(" -> %s (%d)\n",dev->bus_id,error);
 return error;
}


int interface_add_dev(struct device * dev)
{
 struct device_class * cls = dev->driver->devclass;
 struct list_head * node;

 #ifdef USB_DBGSTRING_ON
	dprintf("[USB] interfaces: adding device %s\n",dev->name);
  #else
	dprintf("[USB] interfaces adding device ..\n");
 #endif

 list_for_each(node,&cls->subsys.kset.list) {
         struct device_interface * intf = to_intf(node);
         add(intf,dev);
 }
 return 0;
}


// ====================================================================
// in drivers/base/bus.c
// ====================================================================
/*
struct subsystem bus_subsys ;

static void driver_release(struct kobject * kobj)
{
 #ifndef _ETCPIP
 struct device_driver * drv = to_driver(kobj);
 #endif
 #ifndef NO_SEMPHORE
        up(&drv->unload_sem);
 #endif // ndef NO_SEMPHORE
}

static struct kobj_type ktype_driver = {
 #ifdef CONFIG_USB_DEVICEFS
        .sysfs_ops      = &driver_sysfs_ops,
 #endif // CONFIG_USB_DEVICEFS
        .release        = driver_release,
};
*/

/**
 *      bus_register - register a bus with the system.
 *      @bus:   bus.
 *
 *      Once we have that, we registered the bus with the kobject
 *      infrastructure, then register the children subsystems it has:
 *      the devices and drivers that belong to the bus. 
 */

/*
int bus_register(struct bus_type * bus)
{
 #ifdef USB_DBGSTRING_ON
        strncpy(bus->subsys.kset.kobj.name,bus->name,KOBJ_NAME_LEN);
 #endif

 subsys_set_kset(bus,bus_subsys);

 #ifndef _ETCPIP
        subsystem_register(&bus->subsys);
 #endif // ndef _ETCPIP

 #ifdef USB_DBGSTRING_ON
	#ifndef USB_NO_LIB
        snprintf(bus->devices.kobj.name,KOBJ_NAME_LEN,"devices");
	#endif // ndef USB_NO_LIB
 #endif
 
 bus->devices.subsys = &bus->subsys;
 
 #ifndef _ETCPIP
        kset_register(&bus->devices);
 #endif // ndef _ETCPIP

 #ifdef USB_DBGSTRING_ON
	#ifndef USB_NO_LIB
        snprintf(bus->drivers.kobj.name,KOBJ_NAME_LEN,"drivers");
	#endif // ndef USB_NO_LIB
 #endif
        bus->drivers.subsys = &bus->subsys;
        bus->drivers.ktype = &ktype_driver;
 #ifndef _ETCPIP
        kset_register(&bus->drivers);
 #endif // ndef _ETCPIP

 #ifdef USB_DBGSTRING_ON
	USB_DBG_INFO(iprintf("[USB INFO] bus type [%s] registered \n",
		bus->name
	    ));
  #else
	USB_DBG_INFO(iprintf("[USB INFO] bus type registered\n"));
 #endif
 return 0;
}
*/
/**
 *      bus_match - check compatibility between device & driver.
 *      @dev:   device.
 *      @drv:   driver.
 *
 *      First, we call the bus's match function, which should compare
 *      the device IDs the driver supports with the device IDs of the 
 *      device. Note we don't do this ourselves because we don't know 
 *      the format of the ID structures, nor what is to be considered
 *      a match and what is not.
 *      
 *      If we find a match, we call @drv->probe(@dev) if it exists, and 
 *      call attach() above.
 */
/*
#ifndef _ETCPIP
static 
#endif // ndef _ETCPIP
*/
/*
int bus_match(struct device * dev, struct device_driver * drv)
{
 int error = -ENODEV;
 if (dev->bus->match(dev,drv))
   {
	dev->driver = drv;
    if (drv->probe)
       {
        if ((error = drv->probe(dev)))
           {
            dev->driver = NULL;
            return error;
           }
       }
	#ifndef _ETCPIP
                device_bind_driver(dev);
	#endif // ndef _ETCPIP
                error = 0;
        }
        return error;
}
*/

/**
 *      device_attach - try to attach device to a driver.
 *      @dev:   device.
 *
 *      Walk the list of drivers that the bus has and call bus_match() 
 *      for each pair. If a compatible pair is found, break out and return.
 */
#ifndef _ETCPIP
	/*
	static int device_attach(struct device * dev)
	{
	 struct bus_type * bus = dev->bus;
	 struct list_head * entry;

	 if (dev->driver)
	   {
		#ifndef _ETCPIP
	        device_bind_driver(dev);
		#endif // ndef _ETCPIP
	    return 1;
	   }

	 if (bus->match)
	   {
		list_for_each(entry,&bus->drivers.list)
	       {
			struct device_driver * drv ;
        
	        drv = (struct device_driver *) to_drv(entry);
             
	        if (!bus_match(dev,drv))
	       	   {
				return 1;
	           }
	       }
	   }
	
	 return 0;
	}
    */
#endif // ndef _ETCPIP


/**
 *      driver_attach - try to bind driver to devices.
 *      @drv:   driver.
 *
 *      Walk the list of devices that the bus has on it and try to match
 *      the driver with each one.
 *      If bus_match() returns 0 and the @dev->driver is set, we've found
 *      a compatible pair, so we call devclass_add_device() to add the 
 *      device to the class. 
 *
 *      Note that we ignore the error from bus_match(), since it's perfectly
 *      valid for a driver not to bind to any devices.
 */

/* 
static void driver_attach(struct device_driver * drv)
{
 struct bus_type * bus = drv->bus;
 struct list_head * entry;

 if (!bus->match)
         return;

 #ifndef NO_KSET
  list_for_each(entry,&bus->devices.list)
 #else
  list_for_each(entry,bus->devices_list)
 #endif
   {
	struct device * dev = container_of(entry,struct device,bus_list);

    if (!dev->driver)
       {
		if (!bus_match(dev,drv))
        	devclass_add_device(dev);
       }
   }
}
*/
/**
 *      bus_add_driver - Add a driver to the bus.
 *      @drv:   driver.
 *
 */
/*
int bus_add_driver(struct device_driver * drv)
{
 struct bus_type * bus = get_bus(drv->bus);
 int error = 0;

 if (bus) {
	#ifdef USB_DBGSTRING_ON
		dprintf("[USB] bus [%s] add driver [%s] \n",bus->name,drv->name);
	 #else
		dprintf("[USB] bus add driver ..\n");
	#endif

	#ifdef USB_DBGSTRING_ON
		strncpy(drv->kobj.name,drv->name,KOBJ_NAME_LEN);
	#endif
    drv->kobj.kset = &bus->drivers;

	if ((error = kobject_register(&drv->kobj))) {
		#ifndef _ETCPIP
                        put_bus(bus);
		#endif // ndef _ETCPIP
		return error;
       }

	#ifndef NO_SEMPHORE
		down_write(&bus->subsys.rwsem);
	#endif // ndef NO_SEMPHORE
	if (!(error = devclass_add_driver(drv)))
                        driver_attach(drv);
	#ifndef NO_SEMPHORE
                up_write(&bus->subsys.rwsem);
	#endif // ndef NO_SEMPHORE

	if (error) {
		#ifndef _ETCPIP
                        kobject_unregister(&drv->kobj);
                        put_bus(bus);
		#endif // ndef _ETCPIP
       }
   }
 return error;
}
*/
/*
struct bus_type * get_bus(struct bus_type * bus)
{
 return bus ? (struct bus_type *)container_of(subsys_get(&bus->subsys),struct bus_type,subsys) : (struct bus_type *)NULL;
}
*/
// ====================================================================
// in drivers/base/class.c
// ====================================================================

static void enum_device(struct device_class * cls, struct device * dev)
{
        u32 val;
        val = cls->devnum++;
        dev->class_num = val;
 #ifndef NO_SYS_FS
        devclass_dev_link(cls,dev);
 #endif // ndef NO_SYS_FS
}

/**
 *      devclass_add_device - register device with device class
 *      @dev:   device to be registered 
 *
 *      This is called when a device is either registered with the 
 *      core, or after the a driver module is loaded and bound to
 *      the device. 
 *      The class is determined by looking at @dev's driver, so one
 *      way or another, it must be bound to something. Once the 
 *      class is determined, it's set to prevent against concurrent
 *      calls for the same device stomping on each other. 
 *
 *      /sbin/hotplug should be called once the device is added to 
 *      class and all the interfaces. 
 */
int devclass_add_device(struct device * dev)
{
 struct device_class * cls;
 int error = 0;

 #ifndef NO_SEMPHORE
        down(&devclass_sem);
 #endif // ndef NO_SEMPHORE
 if (dev->driver)
   {
	cls = get_devclass(dev->driver->devclass);

    if (!cls)
       {
        goto Done;
       }

	#ifdef USB_DBGSTRING_ON
		dprintf("[USB] device class %s: adding device %s\n",
                         cls->name,dev->name);
	 #else
		dprintf("[USB] device class adding device ..\n") ;
	#endif
    if (cls->add_device) 
       {
        error = cls->add_device(dev);
       }
    if (error)
       {
		#ifndef _ETCPIP
        	put_devclass(cls);
		#endif // ndef _ETCPIP
        goto Done;
       }

	#ifndef NO_SEMPHORE
                down_write(&cls->subsys.rwsem);
	#endif // ndef NO_SEMPHORE
    
    enum_device(cls,dev);
    list_add_tail(&dev->class_list,&cls->devices.list);
    
    /* notify userspace (call /sbin/hotplug) */
	#ifndef _ETCPIP
		class_hotplug (dev, "add");
	#endif // ndef _ETCPIP

	#ifndef NO_SEMPHORE
        up_write(&cls->subsys.rwsem);
	#endif // ndef NO_SEMPHORE

    interface_add_dev(dev);
   }
   
 // -----------
 Done:
 // -----------
 
 #ifndef NO_SEMPHORE
	up(&devclass_sem);
 #endif // ndef NO_SEMPHORE
 
 return error;
}


int devclass_add_driver(struct device_driver * drv)
{
 struct device_class * cls = get_devclass(drv->devclass);
 int error = 0;

 if (cls)
   {
	#ifndef NO_SEMPHORE
		down_write(&cls->subsys.rwsem);
	#endif // ndef NO_SEMPHORE
	#ifdef USB_DBGSTRING_ON
		dprintf("[USB] device class %s: adding driver %s:%s\n",
        		cls->name,drv->bus->name,drv->name);
	 #else
		dprintf("[USB] device class adding driver ..\n") ;
	#endif
    
	#ifndef NO_SYS_FS
        error = devclass_drv_link(drv);
	#endif // ndef NO_SYS_FS
    
    if (!error)
       {
		list_add_tail(&drv->class_list,&cls->drivers.list);
       }
       
	#ifndef NO_SEMPHORE
		up_write(&cls->subsys.rwsem);
	#endif // ndef NO_SEMPHORE
   }
 return error;
}

struct device_class * get_devclass(struct device_class * cls)
{
  return cls ? container_of(subsys_get(&cls->subsys),
  							struct device_class,subsys) : NULL;
}


// ====================================================================
// in drivers/base/core.c
// ====================================================================

/**
 *      device_initialize - init device structure.
 *      @dev:   device.
 *
 *      This prepares the device for use by other layers,
 *      including adding it to the device hierarchy. 
 *      It is the first half of device_register(), if called by
 *      that, though it can also be called separately, so one
 *      may use @dev's fields (e.g. the refcount).
 */

/*
void device_initialize(struct device *dev)
{
 kobject_init(&dev->kobj);
 INIT_LIST_HEAD(&dev->node);
 INIT_LIST_HEAD(&dev->children);
 INIT_LIST_HEAD(&dev->driver_list);
 INIT_LIST_HEAD(&dev->bus_list);
 INIT_LIST_HEAD(&dev->class_list);
}
*/

/**
 *      get_device - increment reference count for device.
 *      @dev:   device.
 *
 *      This simply forwards the call to kobject_get(), though
 *      we do take care to provide for the case that we get a NULL
 *      pointer passed in.
 */
/*
struct device * get_device(struct device * dev)
{
 
 #ifndef _ETCPIP
 
        return dev ? (struct device *) to_dev(kobject_get(&dev->kobj)) : NULL;
 
  #else
        return dev ? (struct device *) kobject_get(&dev->kobj) : NULL;
 #endif
 
}
*/

// ====================================================================
// in drivers/base/driver.c
// ====================================================================

/**
 *      get_driver - increment driver reference count.
 *      @drv:   driver.
 */
struct device_driver * get_driver(struct device_driver * drv)
{
 /*
 #ifndef _ETCPIP
        return drv ? (struct device_driver *)to_drv(kobject_get(&drv->kobj)) : NULL;
  #else
 */
        return drv ? (struct device_driver *)kobject_get(&drv->kobj) : NULL;
 /*
 #endif
 */
}


/**
 *      put_driver - decrement driver's refcount.
 *      @drv:   driver.
 */
/*
#ifndef _ETCPIP
void put_driver(struct device_driver * drv)
{
 kobject_put(&drv->kobj);
}
#endif // ndef _ETCPIP
*/

/**
 *      driver_register - register driver with bus
 *      @drv:   driver to register
 *
 *      We pass off most of the work to the bus_add_driver() call,
 *      since most of the things we have to do deal with the bus 
 *      structures.
 *
 *      The one interesting aspect is that we initialize @drv->unload_sem
 *      to a locked state here. It will be unlocked when the driver
 *      reference count reaches 0.
 */
/*
#ifndef NO_SYS_FS
int driver_register(struct device_driver * drv)
{
 INIT_LIST_HEAD(&drv->devices);
 INIT_LIST_HEAD(&drv->class_list);
 #ifndef NO_SEMPHORE
        init_MUTEX_LOCKED(&drv->unload_sem);
 #endif // ndef NO_SEMPHORE
 return bus_add_driver(drv);
}
#endif // ndef NO_SYS_FS
*/

/**
 *      driver_unregister - remove driver from system.
 *      @drv:   driver.
 *
 *      Again, we pass off most of the work to the bus-level call.
 *
 *      Though, once that is done, we attempt to take @drv->unload_sem.
 *      This will block until the driver refcount reaches 0, and it is
 *      released. Only modular drivers will call this function, and we 
 *      have to guarantee that it won't complete, letting the driver 
 *      unload until all references are gone.
 */

#ifndef _ETCPIP
void driver_unregister(struct device_driver * drv)
{
 bus_remove_driver(drv);
 #ifndef NO_SEMPHORE
        down(&drv->unload_sem);
        up(&drv->unload_sem);
 #endif // ndef NO_SEMPHORE
}
#endif // ndef _ETCPIP


// ====================================================================
/*
#ifdef USB_MEM_LIB
	#include "UsMemLib.c" // UsbMemLib.c
#endif // USB_MEM_LIB
*/
// ====================================================================
// End of File : usb_osport.c

