
// Name of File : usb_osport.h
// ====================================================================

#ifndef __USB_OS_PORT_H__
#define __USB_OS_PORT_H__

// ====================================================================

// #define _ETCPIP

// ====================================================================

#define __KERNEL__
#include "PoErrno.h" // osport_errno.h

// #define USB_CHANGE_PIPE

// ====================================================================

// #define WAIT_BY_LOOP // need by usb.h

#define __u8  unsigned char
#define __u16 unsigned short
#define __u32 unsigned int
/*
typedef long long  loff_t; // from include/asm-armnommu/poxsix_types.h
                           // Not Needed By printer.c
                           // Bus Needed By Mass Storage Codes
*/
typedef long  loff_t; // B. S. Liaw : Need to be long for _ETCPIP

typedef long  off_t;

#define NULL_VALUE (0)  // B. S. Liaw : I donot trust on complier's NULL
						//    It seems that NULL is pointer , not value
#define NO_SEMPHORE

#ifdef NO_SEMPHORE
	#define	up(a) {NULL;}
	#define	down_interruptible(a) {NULL;}
	#define down_read(a) {NULL;}
	#define up_read(a) {NULL;}
	#define down_write(a) {NULL;}
	#define up_write(a) {NULL;}
#endif // ndef NO_SEMPHORE

#define NO_SPINLOCK

#ifndef NO_SPINLOCK
	#define spinlock_t int
 #else
	#define spin_unlock_irqrestore(a,b) {NULL;}
    #define spin_lock_irqsave(a,b) {NULL;}
	#define spin_unlock(a) {NULL;}
	#define spin_lock(a) {NULL;}
#endif // ndef NO_SPINLOCK

/* Move to UsbCfg.h
#define NO_WORKQUEUE
#define NO_WAITQUEUE

#define NO_TIMER

#define NO_SYS_FS
#define NO_SCATTER_LIST
*/

/*
#ifndef _ETCPIP
	typedef struct { volatile int counter; } atomic_t;
#else
*/
typedef int atomic_t;
/*
#endif
*/

// typedef unsigned int            size_t;
// typedef int                     ssize_t;
// on firmware/ap/miscAP/time.h

#define __devinit
#define __devexit
#define __init
#define __exit
#define __devinitdata
#define __devexit_p(a) a

/*
#if defined(_S3C2510)
	#define HZ (3*CLOCKHZ)
 #else
	// #define HZ 100
	#define HZ CLOCKHZ
	// #define   rt_osSecs2Ticks(t)               (t*100)
#endif

#define TIME_FACTOR 3 // for delay wait_ms() MSECTOTICKS()
#define TIME_PLUS   50 // for delay wait_ms() MSECTOTICKS()
*/

#ifndef NO_TIMER
   extern unsigned long volatile jiffies;
#endif // ndef NO_TIMER
/*
#define atomic_read(v)  ((v)->counter)
#define atomic_set(v,i) (((v)->counter) = (i))

// #define atomic_set(a,b) {}
#define atomic_sub(i) {}
#define atomic_inc(i) {}
#define atomic_dec_and_test(i) 1
*/
// #define kfree(i) {NULL;}
// #define kfree(i) free(i)
#ifdef USB_DBG_MEM_C_ON
	// #define kfree(i,size) UsbFreeMemC(i,size)
	#define kfree(i) UsbFreeMemC(USB_MEM_C_L,(unsigned char *)i,sizeof(*i))
 #else
	#define kfree(i) UsbFreeMemC(USB_MEM_C_L,(unsigned char *)i)
#endif
// ====================================================================

#define ext2_find_first_zero_bit(addr, size) \
        ext2_find_next_zero_bit((addr), (size), 0)

extern int find_next_zero_bit (void * addr, int size, int offset) ;

extern unsigned long ffz(unsigned long word_d) ;

// extern void set_bit(int nr, volatile void * addr);

static inline void set_bit(int nr, volatile void *addr)
{
 ((unsigned char *) addr)[nr >> 3] |= (1U << (nr & 7));
}

static inline void clear_bit(int nr, volatile void *addr)
{
 ((unsigned char *) addr)[nr >> 3] &= ~(1U << (nr & 7));
}


#define	printk dprintf
// #define dbg    dprintf


#ifdef BIG_ENDIAN
#include "byteorder\swab.h"

#define cpu_to_le16(x)				__swab16((x))
#define cpu_to_le16p(x)				__swab16p((x))
#define cpu_to_le32(x)				__swab32((x))
#define cpu_to_le32p(x)				__swab32p((x))

#define le16_to_cpus(x)				{ \
	__u16 __x; \
	memcpy(&__x, x, sizeof(__u16)); \
	__swab16s(&__x); \
	memcpy(x, &__x, sizeof(__u16)); }	// usb_hub_descriptor.wHubCharacteristics will cross the 4-bytes boundary
#define le16_to_cpu(x)  			__swab16((x))
#define le32_to_cpu(x)				__swab32((x))
#define le16_to_cpup(x)				__swab16p((x))
#define le32_to_cpup(x)				__swab32p((x))

#define __constant_cpu_to_le32(x)	___constant_swab32((x))

#elif defined (LITTLE_ENDIAN)

#define cpu_to_le16(x)  ((__u16)(x))
#define cpu_to_le16p(x) (*(__u16*)(x))
#define cpu_to_le32(x)  ((__u32)(x))
#define cpu_to_le32p(x) (*(__u32*)(x))

// #define le16_to_cpus(x) do {} while (0)
#define le16_to_cpus(x) {}
#define le16_to_cpu(x)  ((__u16)(x))
#define le32_to_cpu(x)  ((__u32)(x))
#define le16_to_cpup(x) (*(__u16*)(x))
#define le32_to_cpup(x) (*(__u32*)(x))

#define __constant_cpu_to_le32(x)  ((__u32)(x))

#endif


#define CONFIG_PAGESIZE_8
// #define CONFIG_PAGESIZE_16

/* PAGE_SHIFT determines the page size.  This is configurable. */
#if defined(CONFIG_PAGESIZE_8)
	#define PAGE_SHIFT      13              /* 8K */
 #if !defined(USB_NO_DMA_POOL)
    #define PAGE_UNIT_SIZE  8192
 #endif
#elif defined(CONFIG_PAGESIZE_16)
	#define PAGE_SHIFT      14              /* 16K */
#else           /* default */
	#define PAGE_SHIFT      15              /* 32K */
#endif


#define PAGE_SIZE       (1UL << PAGE_SHIFT)
#define PAGE_MASK       (~(PAGE_SIZE-1))


#define readb(a)          (*(volatile unsigned char *)(a))
#define readw(a)          (*(volatile unsigned short *)(a))
#define readl(a)          (*(volatile unsigned int  *)(a))
#define writel(v,addr)    (*(volatile unsigned int *)(addr) = (v))
/* #define writel(v,addr)		TNVWrite(v,addr) */



// static inline void BUG(void) {NULL;}
static inline void BUG(void) { iprintf("\n[USB] !!! BUG !!!\n");}

// extern void udelay(unsigned long usecs); // in usb.h, so comment out


static inline void consistent_sync(void *vaddr, size_t size, int rw) {NULL ;} 
/*
 * Virtual, bus and physical addresses are all the same when there's no MMU.
 * --gmcnutt
 */
#define virt_to_bus(x) ((unsigned long) (x))
#define bus_to_virt(x) ((void *) (x))
#define virt_to_phys(x) ((unsigned long) (x))
#define phys_to_virt(x) ((void *) (x))
extern int volatile in_isr ;

// #define in_interrupt() ({ const int __cpu = smp_processor_id(); \
//         (local_irq_count(__cpu) + local_bh_count(__cpu) != 0); })
// #define in_interrupt() ( 0 ) 
static inline int in_interrupt() { return (in_isr == 1) ; }

/* 2003/6/18 B. S. LIaw , Move to UsbCfg.h
#define CONFIG_PCI
*/
/*
#define to_drv(obj) container_of(obj,struct device_driver,kobj)
*/
#define to_intf(node) container_of(node,struct device_interface,kset.kobj.entry)

static inline long IS_ERR(const void *ptr)
{
  return (unsigned long)ptr > (unsigned long)-1000L;
}




// ====================================================================
// include/linux/dma-mapping.h
// ====================================================================
/* These definitions mirror those in pci.h, so they can be used
 * interchangeably with their PCI_ counterparts */
enum dma_data_direction {
        DMA_BIDIRECTIONAL = 0,
        DMA_TO_DEVICE = 1,
        DMA_FROM_DEVICE = 2,
        DMA_NONE = 3,
};


// ====================================================================
// include/asm-armnommu/poll.h
// ====================================================================
// Needed By printer.c

/* These are specified by iBCS2 */
#define POLLIN          0x0001
#define POLLPRI         0x0002
#define POLLOUT         0x0004
#define POLLERR         0x0008
#define POLLHUP         0x0010
#define POLLNVAL        0x0020

/* The rest seem to be more-or-less nonstandard. Check them! */
#define POLLRDNORM      0x0040
#define POLLRDBAND      0x0080
#define POLLWRNORM      0x0100
#define POLLWRBAND      0x0200
#define POLLMSG         0x0400


// ====================================================================
// include/asm-armnommu/type.h
// ====================================================================
typedef signed char s8;
typedef unsigned char u8;

typedef signed short s16;
typedef unsigned short u16;

typedef signed int s32;
typedef unsigned int u32;

typedef signed long long s64;
typedef unsigned long long u64;

#define BITS_PER_LONG 32

/* Dma addresses are 32-bits wide.  */

// typedef u32 dma_addr_t;
typedef unsigned long dma_addr_t ;


// ====================================================================
// include/linux/stddef.h
// ====================================================================

#undef NULL
#if defined(__cplusplus)
#define NULL 0
#else
#define NULL ((void *)0)
#endif

#undef offsetof
#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)

// ====================================================================
// include/linux/mm.h
// ====================================================================

/*
 * GFP bitmasks..
 */
/* Zone modifiers in GFP_ZONEMASK (see linux/mmzone.h - low four bits) */
#define __GFP_DMA       0x01
#define __GFP_HIGHMEM   0x02

/* Action modifiers - doesn't change the zoning */
#define __GFP_WAIT      0x10    /* Can wait and reschedule? */
#define __GFP_HIGH      0x20    /* Should access emergency pools? */
#define __GFP_IO        0x40    /* Can start low memory physical IO? */
#define __GFP_HIGHIO    0x80    /* Can start high mem physical IO? */
#define __GFP_FS        0x100   /* Can call down to low-level FS? */

#define GFP_NOHIGHIO    (__GFP_HIGH | __GFP_WAIT | __GFP_IO)
#define GFP_NOIO        (__GFP_HIGH | __GFP_WAIT)
#define GFP_NOFS        (__GFP_HIGH | __GFP_WAIT | __GFP_IO | __GFP_HIGHIO)
#define GFP_ATOMIC      (__GFP_HIGH)
#define GFP_USER        (             __GFP_WAIT | __GFP_IO | __GFP_HIGHIO | __GFP_FS)
#define GFP_HIGHUSER    (             __GFP_WAIT | __GFP_IO | __GFP_HIGHIO | __GFP_FS | __GFP_HIGHMEM)
#define GFP_KERNEL      (__GFP_HIGH | __GFP_WAIT | __GFP_IO | __GFP_HIGHIO | __GFP_FS)
#define GFP_NFS         (__GFP_HIGH | __GFP_WAIT | __GFP_IO | __GFP_HIGHIO | __GFP_FS)
#define GFP_KSWAPD      (             __GFP_WAIT | __GFP_IO | __GFP_HIGHIO | __GFP_FS)

/* Flag - indicates that the buffer will be suitable for DMA.  Ignored on some
   platforms, used as appropriate on others */

#define GFP_DMA         __GFP_DMA





// ====================================================================
// include/linux/slab.h
// ====================================================================
/* flags for kmem_cache_alloc() */
#define SLAB_NOFS               GFP_NOFS
#define SLAB_NOIO               GFP_NOIO
#define SLAB_NOHIGHIO           GFP_NOHIGHIO
#define SLAB_ATOMIC             GFP_ATOMIC
#define SLAB_USER               GFP_USER
#define SLAB_KERNEL             GFP_KERNEL
#define SLAB_NFS                GFP_NFS
#define SLAB_DMA                GFP_DMA

#define SLAB_LEVEL_MASK         (__GFP_WAIT|__GFP_HIGH|__GFP_IO|__GFP_HIGHIO|__GFP_FS)
#define SLAB_NO_GROW            0x00001000UL    /* don't grow a cache */



// ====================================================================
// include/linux/kernel.h
// ====================================================================
/*
 * min()/max() macros that also do
 * strict type-checking.. See the
 * "unnecessary" pointer comparison.
 */
#define min(x,y) ({ \
        const typeof(x) _x = (x);       \
        const typeof(y) _y = (y);       \
        (void) (&_x == &_y);            \
        _x < _y ? _x : _y; })

#define max(x,y) ({ \
        const typeof(x) _x = (x);       \
        const typeof(y) _y = (y);       \
        (void) (&_x == &_y);            \
        _x > _y ? _x : _y; })

/*
 * ..and if you can't take the strict
 * types, you can specify one yourself.
 *
 * Or not use min/max at all, of course.
 */
#define min_t(type,x,y) \
        ({ type __x = (x); type __y = (y); __x < __y ? __x: __y; })
        
#define max_t(type,x,y) \
        ({ type __x = (x); type __y = (y); __x > __y ? __x: __y; })

/**
 * container_of - cast a member of a structure out to the containing structure
 *
 * @ptr:        the pointer to the member.
 * @type:       the type of the container struct this is embedded in.
 * @member:     the name of the member within the struct.
 *
 */
#define container_of(ptr, type, member) ({                      \
        const typeof( ((type *)0)->member ) *__mptr = (ptr);    \
        (type *)( (char *)__mptr - offsetof(type,member) );})


// ====================================================================
// include/asm-armnommu/signal.h
// ====================================================================
/*
 * These values of sa_flags are used only by the kernel as part of the
 * irq handling routines.
 *
 * SA_INTERRUPT is also used by the irq handling routines.
 * SA_SHIRQ is for shared interrupt support on PCI and EISA.
 */
#define SA_PROBE                0x80000000
#define SA_SAMPLE_RANDOM        0x10000000
#define SA_IRQNOMASK            0x08000000
#define SA_SHIRQ                0x04000000


#define SIG_BLOCK          0    /* for blocking signals */
#define SIG_UNBLOCK        1    /* for unblocking signals */
#define SIG_SETMASK        2    /* for setting the signal mask */



// ====================================================================
// include/linux/slab.h
// ====================================================================
/* flags to pass to kmem_cache_create().
 * The first 3 are only valid when the allocator as been build
 * SLAB_DEBUG_SUPPORT.
 */
#define SLAB_DEBUG_FREE         0x00000100UL    /* Peform (expensive) checks on free */
#define SLAB_DEBUG_INITIAL      0x00000200UL    /* Call constructor (as verifier) */
#define SLAB_RED_ZONE           0x00000400UL    /* Red zone objs in a cache */
#define SLAB_POISON             0x00000800UL    /* Poison objects */
#define SLAB_NO_REAP            0x00001000UL    /* never reap from the cache */
#define SLAB_HWCACHE_ALIGN      0x00002000UL    /* align objs on a h/w cache lines */
#define SLAB_CACHE_DMA          0x00004000UL    /* use GFP_DMA memory */
#define SLAB_MUST_HWCACHE_ALIGN 0x00008000UL    /* force alignment */

/* flags passed to a constructor func */
#define SLAB_CTOR_CONSTRUCTOR   0x001UL         /* if not set, then deconstructor */
#define SLAB_CTOR_ATOMIC        0x002UL         /* tell constructor it can't sleep */
#define SLAB_CTOR_VERIFY        0x004UL         /* tell constructor it's a verify call */


// ====================================================================
// include/linux/sched.h
// ====================================================================
#ifndef _ETCPIP
  #define wake_up(x)  __wake_up((x),TASK_UNINTERRUPTIBLE | TASK_INTERRUPTIBLE, 1)
 #else
  #define wake_up(x)  __wake_up((x) , 1)
#endif


// ====================================================================
// include/asm-arm/atomic.h
// ====================================================================
/*
#ifndef _ETCPIP
	#define atomic_read(v)  ((v)->counter)
	#define atomic_set(v,i) (((v)->counter) = (i))
 #else
*/
	#define atomic_read(v)  (*v)
	#define atomic_set(v,i) (*(v) = (i))
/*
#endif
*/
/*
#ifndef _ETCPIP
*/
	static inline void atomic_sub(int i, volatile atomic_t *v)
/*
#else
	static inline void atomic_sub(int i, int *v)
#endif
*/
{
 #ifndef _ETCPIP
        unsigned long flags;

        local_irq_save(flags);
 #endif
 #ifndef _ETCPIP
        v->counter -= i;
 #else
        *v -= i;
 #endif
 #ifndef _ETCPIP
        local_irq_restore(flags);
 #endif
}
/*
#ifndef _ETCPIP
*/
	static inline void atomic_inc(volatile atomic_t *v)
/*
#else
	static inline void atomic_inc(int *v)
#endif
*/
{
 #ifndef _ETCPIP
        unsigned long flags;

        local_irq_save(flags);
 #endif
 #ifndef _ETCPIP
        v->counter += 1;
 #else
        *v += 1;
 #endif
 #ifndef _ETCPIP
        local_irq_restore(flags);
 #endif
}
/*
#ifndef _ETCPIP
*/
	static inline void atomic_dec(volatile atomic_t *v)
/*
#else
	static inline void atomic_dec(int *v)
#endif
*/
{
 #ifndef _ETCPIP
        unsigned long flags;

        local_irq_save(flags);
 #endif
 #ifndef _ETCPIP
        v->counter -= 1;
  #else
        *v -= 1;
 #endif
 #ifndef _ETCPIP
        local_irq_restore(flags);
 #endif
}
/*
#ifndef _ETCPIP
*/
	static inline int atomic_dec_and_test(volatile atomic_t *v)
/*
 #else

	static inline int atomic_dec_and_test(int *v)
#endif
*/
{
 #ifndef _ETCPIP
        unsigned long flags;
 #endif
        int val;

 #ifndef _ETCPIP
        local_irq_save(flags);
 #endif
 #ifndef _ETCPIP
        val = v->counter;
        v->counter = val -= 1;
  #else
        val = *v;
        *v = val -= 1;
 #endif
 #ifndef _ETCPIP
        local_irq_restore(flags);
 #endif

 return val == 0;
}

// ====================================================================
// include/linux/module.h
// ====================================================================

#define MODULE_NAME_LEN (64 - sizeof(unsigned long))

enum module_state
{
 MODULE_STATE_LIVE,
 MODULE_STATE_COMING,
 MODULE_STATE_GOING,
};

struct module
{
 enum module_state state;

 /* Member of list of modules */
 struct list_head list;

 /* Unique handle for this module */
 #ifdef USB_DBGSTRING_ON
	char name[MODULE_NAME_LEN];
 #endif // USB_DBGSTRING_ON

 #ifndef _ETCPIP
	/* Exported symbols */
    const struct kernel_symbol *syms;
    unsigned int num_syms;
    const unsigned long *crcs;

    /* GPL-only exported symbols. */
    const struct kernel_symbol *gpl_syms;
    unsigned int num_gpl_syms;
    const unsigned long *gpl_crcs;

    /* Exception table */
    unsigned int num_exentries;
    const struct exception_table_entry *extable;

 #endif // ndef _ETCPIP
 
        /* Startup function. */
        int (*init)(void);

        /* If this is non-NULL, vfree after init() returns */
        void *module_init;

        /* Here is the actual code + data, vfree'd on unload. */
        void *module_core;

 #ifndef _ETCPIP
        /* Here are the sizes of the init and core sections */
        unsigned long init_size, core_size;

        /* Arch-specific module values */
        struct mod_arch_specific arch;

        /* Am I unsafe to unload? */
        int unsafe;

        /* Am I GPL-compatible */
        int license_gplok;
 #endif // ndef _ETCPIP

 #ifdef CONFIG_MODULE_UNLOAD
        /* Reference counts */
        struct module_ref ref[NR_CPUS];

        /* What modules depend on me? */
        struct list_head modules_which_use_me;

        /* Who is waiting for us to be unloaded */
        struct task_struct *waiter;

        /* Destruction function. */
        void (*exit)(void);
 #endif

 #ifdef CONFIG_KALLSYMS
        /* We keep the symbol and string tables for kallsyms. */
        Elf_Sym *symtab;
        unsigned long num_symtab;
        char *strtab;
 #endif

 #ifndef _ETCPIP
        /* The command line arguments (may be mangled).  People like
           keeping pointers to this stuff */
        char *args;
 #endif // ndef _ETCPIP
};

/* FIXME: It'd be nice to isolate modules during init, too, so they
   aren't used before they (may) fail.  But presently too much code
   (IDE & SCSI) require entry into the module during init.*/
static inline int module_is_live(struct module *mod)
{
        return mod->state != MODULE_STATE_GOING;
}


static inline int try_module_get(struct module *module)
{
        return !module || module_is_live(module);
}
static inline void module_put(struct module *module)
{
}



// ====================================================================
// buffer.c
// ====================================================================

// #ifndef USB_MEM_LIB
	extern void * UsbNCCntMalloc(unsigned long usize) ;
// #endif // ndef USB_MEM_LIB

// ====================================================================
// Called by printer.c
// ====================================================================
/* Prototype: unsigned long __arch_copy_from_user(void *to,
                         const void *from,unsigned long n);
 * Purpose  : copy a block from user memory to kernel memory
 * Params   : to   - kernel memory
 *          : from - user memory
 *          : n    - number of bytes to copy
 * Returns  : Number of bytes NOT copied.
 */

static inline unsigned long copy_from_user(void *to,
         const void *from,unsigned long n)
{

 #ifdef USB_BS_ASSERT
	#warning: USB_BS_ASSERT : ON !!
    if ( to == 0 )
       {
        iprintf(
           "[ASSERT][USB] copy_from_user() : "
           "Error : Destination Null !!\n");
       }
  #else
	// #warning: USB_BS_ASSERT : OFF !!
 #endif

 // 2003/10/06 B. S. Liaw BugFix
 if ( !to ) {
	return n ; // Fail , All NOT copied.
   }

 #ifdef USB_BS_ASSERT
    if ( from == 0 )
       {
        iprintf(
           "[ASSERT][USB] copy_from_user() : "
           "Error : Source Null !!\n");
       }
 #endif

 // 2003/10/06 B. S. Liaw BugFix
 if ( !from ) {
	return n ; // Fail , All NOT copied.
   }

 memmove(to, from, n); // on lib/iiilib.c
 /*
 register char *t1 = (char *)to + n - 1;
 register char *t2 = (char *)from + n - 1;
 
 while (n--)
   {
	*t1-- = *t2--;
   }
 */
   
 /*
  unsigned int i;

  for (i = 0; i < len; i++)
      output[i] = input[i];
 */
 
 // Now assume All bytes copied
 return 0 ;
}

/* Prototype: int __arch_copy_to_user(void *to, const char *from,
                                      size_t n)
 * Purpose  : copy a block to user memory from kernel memory
 * Params   : to   - user memory
 *          : from - kernel memory
 *          : n    - number of bytes to copy
 * Returns  : Number of bytes NOT copied.
 */

/*
static inline int copy_to_user(void *to, const char *from,
                                       size_t n)
{
 
}
*/

#define copy_to_user copy_from_user

// ====================================================================

struct device ;

// #ifndef _ETCPIP
#ifndef USB_NO_VMM // no vitrtul memory management
	// #define dma_map_single s3c2510_map_single 
	// #define dma_map_single pci_map_single 
	static inline dma_addr_t
	dma_map_single(struct device *controller, void *ptr, size_t size,
    			   int direction)
	{
	 consistent_sync(ptr, size, direction);
	 return virt_to_bus(ptr);
	}
#endif // ndef USB_NO_VMM

#ifndef USB_NO_VMM
	#ifdef CONFIG_PCI
		// #define dma_unmap_single s3c2510_unmap_single 
		#define dma_unmap_single pci_unmap_single 
	 #else
		static inline void
		dma_unmap_single(struct device	* controller, dma_addr_t dma_addr,
    				 size_t size, int direction)
		{
		 /* nothing to do */
		}
	#endif
#endif // ndef USB_NO_VMM

#ifndef USB_NO_VMM
	#define dma_sync_single(a,b,c,d) {NULL;}
#endif // ndef USB_NO_VMM

static inline void * ioremap(unsigned long phys_addr, size_t size, unsigned long flags)
{
 return (void *)phys_addr;
}

static inline void iounmap(void *addr)
{
}


static inline void prefetch(const void *x) {;}


// ====================================================================
// in usb_osport.c

extern void init_timervecs (void) ;
extern void usb_timer_task(void) ;
extern signed long usb_schedule_timeout(signed long timeout) ;

// extern void device_initialize(struct device *dev) ;

// extern int driver_register(struct device_driver * drv);
// extern void driver_unregister(struct device_driver * drv);
extern struct device_driver * get_driver(struct device_driver * drv) ;
extern void put_driver(struct device_driver * drv) ;


// ====================================================================

typedef unsigned short umode_t ;
#ifndef _NEWLIB
typedef unsigned short uid_t ;
typedef unsigned short gid_t ;
#endif

// include/linux/types.h
// #define NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
// #define NO_BACKDEV  // backing_dev_info , 2003/11/21 move to stoarge/UsbMsCfg.h
// typedef unsigned long long sector_t; // include/linux/types.h
typedef unsigned long sector_t; // include/linux/types.h
// #define NO_INODE  // struct inode , 2003/11/21 move to stoarge/UsbMsCfg.h


#ifndef CONFIG_PCI
	// in usb_osport.c
	extern void *mem_alloc_consistent(size_t size,
          dma_addr_t *handle) ;
    /*      
	static inline void
	mem_free_consistent(size_t size,
    		void *vaddr, dma_addr_t dma_handle)
	{
	 #ifndef _ETCPIP
		#warning : No consistent_free() !!
		consistent_free(vaddr, size, dma_handle);
	  #else
		#ifndef USB_MEM_LIB
			#warning : No consistent_free() !!
			// NonCache_contigmalloc() cannot be free now !!
		 #else
	        relUsbMem(USB_MEM_U_L, dma_handle) ;
		#endif
	 #endif
    }
    */
#endif


// ====================================================================

// include/linux/linkage.h

#ifndef FASTCALL
#define FASTCALL(x)     x
#endif

// ====================================================================

// include/linux/coda.h line # 80
typedef u_long ino_t;
// include/linux/coda.h line # 81
typedef u_long dev_t;


typedef unsigned short mode_t ;

// ====================================================================
// in include/linux/dcache.h
// ====================================================================

/*
 * "quick string" -- eases parameter passing, but more importantly
 * saves "metadata" about the string (ie length and the hash).
 */
struct qstr {
 #ifdef USB_DBGSTRING_ON
        const unsigned char * name;
 #endif
 unsigned int len;
 unsigned int hash;
 char name_str[0];
};


// ====================================================================
// in include/linux/threads.h
// ====================================================================
/*
 * Maximum supported processors that can run under SMP.  This value is
 * set via configure setting.  The maximum is equal to the size of the
 * bitmasks used on that platform, i.e. 32 or 64.  Setting this smaller
 * saves quite a bit of memory.
 */
/*
#ifdef CONFIG_SMP
#define NR_CPUS         CONFIG_NR_CPUS
#else
*/
#define NR_CPUS         1
/*
#endif
*/

// ====================================================================
// in include/asm-mips/uaccess.h
// ====================================================================
#define VERIFY_READ    0
#define VERIFY_WRITE   1


#define IS_VALID_ADDR(a)             \
		(  (unsigned long)  a        \
   	     > (unsigned long) 0x20000L  \
		)

#if defined(_S3C2510)

	#define USB_TO_UN_CACHED(a)                \
		     (   (unsigned long) a             \
		     )
    	   

#elif defined(_AR7300)

	#define USB_TO_UN_CACHED(a)                 \
		     (   (unsigned long) a              \
			   | (unsigned long) 0x20000000L    \
		     )

#elif defined(_ADM5120)

	#define USB_TO_UN_CACHED(a)                 \
		     (   (unsigned long) a              \
			   | (unsigned long) 0x20000000L    \
		     )

#elif defined(_ATHEROS)

	#define USB_TO_UN_CACHED(a)                 \
		     (   (unsigned long) a              \
			   | (unsigned long) 0x20000000L    \
		     )

#endif

#if defined(_S3C2510)

	#define USB_TO_CACHED(a)                \
		     (   (unsigned long) a          \
		     )
    	   

#elif defined(_AR7300)

	#define USB_TO_CACHED(a)                    \
		     (   (unsigned long) a              \
			   & ~((unsigned long) 0x20000000L) \
		     )

#elif defined(_ADM5120)

	#define USB_TO_CACHED(a)                    \
		     (   (unsigned long) a              \
			   & ~((unsigned long) 0x20000000L) \
		     )

#elif defined(_ATHEROS)

	#define USB_TO_CACHED(a)                    \
		     (   (unsigned long) a              \
			   & ~((unsigned long) 0x20000000L) \
		     )

#endif

// #ifdef USB_BS_ASSERT_CACHE
#if defined(_S3C2510)

	#define USB_IS_UN_CACHED(a)                \
		     (  (unsigned long)  a             \
   	          > (unsigned long) 0x00800000L    \
		     )
    	   

#elif defined(_AR7300)
	#define USB_IS_UN_CACHED(a)                   \
		     (  (   (unsigned long)  a            \
				  & (unsigned long)  0x20000000L  \
				)								  \
        	  ==(   (unsigned long)  0x20000000L  \
		    	)								  \
	    	 )
#elif defined(_ADM5120)

	#define USB_IS_UN_CACHED(a)                   \
		     (  (   (unsigned long)  a            \
				  & (unsigned long)  0x20000000L  \
				)								  \
        	  ==(   (unsigned long)  0x20000000L  \
		    	)								  \
	    	 )

#elif defined(_ATHEROS)

	#define USB_IS_UN_CACHED(a)                   \
		     (  (   (unsigned long)  a            \
				  & (unsigned long)  0x20000000L  \
				)								  \
        	  ==(   (unsigned long)  0x20000000L  \
		    	)								  \
	    	 )

#endif
// #endif // USB_BS_ASSERT_CACHE

// ====================================================================

#endif // ndef __USB_OS_PORT_H__

// ====================================================================
// End of File : usb_osport.h

