
// Name of File : FatBlockIo.c
// ==================================================================== 

/**************************************************************************
 * FreeDOS 32 FAT Driver                                                  *
 * by Salvo Isaja                                                         *
 *                                                                        *
 * Copyright (C) 2001-2003, Salvatore Isaja                               *
 *                                                                        *
 * This is "blockio.c" - Services to access the hosting block device      *
 *                                                                        *
 *                                                                        *
 * This file is part of the FreeDOS 32 FAT Driver.                        *
 *                                                                        *
 * The FreeDOS 32 FAT Driver is free software; you can redistribute it    *
 * and/or modify it under the terms of the GNU General Public License     *
 * as published by the Free Software Foundation; either version 2 of the  *
 * License, or (at your option) any later version.                        *
 *                                                                        *
 * The FreeDOS 32 FAT Driver is distributed in the hope that it will be   *
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 * GNU General Public License for more details.                           *
 *                                                                        *
 * You should have received a copy of the GNU General Public License      *
 * along with the FreeDOS 32 FAT Driver; see the file COPYING;            *
 * if not, write to the Free Software Foundation, Inc.,                   *
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                *
 **************************************************************************/

#if (_USB_MS >= 1) // 2003/12/17 B. S. Liaw
// ==================================================================== 
/*
#define __KERNEL__
#ifdef _NEWLIB
	#include "string.h"
#endif
#include "EtcpipDbg.h" // 2002/10/25 B. S. Liaw
       // for deciding whether to compile
       //  Debug Version or Release Version
#include "etcpip.h"
#include "UsbDbg.h"
#include "PoList.h" // osport_list.h
#include "UsbCfg.h" // Config and Setting
#include "UsbMsCfg.h" // Config and Setting for Mass Storage Class
#include "UsbMsDbg.h"
#include "UsbMsInit.h"

#include "UsOsport.h" // "usb_osport.h"

#ifndef NO_WAITQUEUE
	#include  "PoWait.h" // osport_wait.h
#endif // ndef NO_WAITQUEUE
#include "UsMemLib.h" // UsbMemLib.h
*/

#ifdef _USB_SYSLOG
	#include "syslog.h"
	#include "logStr.h"
	#include "config.h"
	extern struct III_Config_t gSetting;
 #else
	// #error: Please Make Sure : Not _USB_SYSLOG !!
	// #warning: Not _USB_SYSLOG !!
#endif // _USB_SYSLOG


// ====================================================================


//#include <sys/types.h>
//#include <sockapi.h>

#include "nglobal.h"

#include "fat.h"
#include "fatfs_global.h"

// ====================================================================

// 2003/12/17 B. S. Liaw : 
// block_read() and block_write() may be replaced by functions 
// on hardware/usb/storage/FatBlockIo.c
// so , need include blockio.h
// on /kernel/fatfs/blockio.h :
// int block_read(unsigned long VolumeID, unsigned long SectorNo, void *Buffer);
// int block_write(unsigned long VolumeID, unsigned long SectorNo, void *Buffer);
#include "blockio.h"      // on /kernel/fatfs

// #include "blkdev.h"

// #define BLOCKIO_READ_DEBUG		0
// #define BLOCKIO_WRITE_DEBUG		0

/* Buffer flags */

#define FATBUF_USED		0x00000001		// Buffer has been used at least once
#define FATBUF_DIRTY	0x00000002		// Buffer contains data to be written
#define FATBUF_SORT		0x00000004		// Buffer is current in sorting mode
/*
typedef struct NetDisk_struct {
	unsigned long PktLength;
	unsigned long PktType;
	unsigned long OpCode;
	unsigned long Volume;
	unsigned long SectorNo;
	long RetCode;
	char Data[512];
} NetDisk_struct;
*/
/*
int NetDisk_connected = FALSE;
int sockID = -1;
*/

// 2003/12/19 B. S. Liaw Add ..
struct DiskParamS DiskParam = {
 // 2003/12/24 B. S. Liaw Add ..
 .TotalBlocks = 2880 ,
} ;

// ====================================================================
/*
int ConnectNetDisk(void)
{
	struct sockaddr_in serv_addr;
	int E;

	iprintf("ConnectNetDisk(): sockID = %d\n", sockID);
	if (NetDisk_connected) return 0;

	if (sockID <= 0)
	{
		sockID = socket(AF_INET, SOCK_STREAM, 0);
		iprintf("ConnectNetDisk(): sockID = %d\n", sockID);
		if (sockID <= 0) return -1;
	}

	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_port = htons(40002);
	* (char *)&serv_addr.sin_addr.s_addr      = gSetting.nbServ.spoolServ[2][0];
	*((char *)&serv_addr.sin_addr.s_addr + 1) = gSetting.nbServ.spoolServ[2][1];
	*((char *)&serv_addr.sin_addr.s_addr + 2) = gSetting.nbServ.spoolServ[2][2];
	*((char *)&serv_addr.sin_addr.s_addr + 3) = gSetting.nbServ.spoolServ[2][3];
	E = connect(sockID, (struct sockaddr *) &serv_addr, sizeof(serv_addr));
	iprintf("ConnectNetDisk(): connect() returns %d, sockID = %d\n", E, sockID);
	if (E == 0)
	{
		NetDisk_connected = TRUE;
		return 0;
	}
	else
	{
		iprintf("ConnectNetDisk(): LastError = %d\n", GetLastError());
		E = closesocket(sockID);
		iprintf("ConnectNetDisk((): closesocket() returns %d, sockID = %d\n", E, sockID);
		sockID = -1;
		return -2;
	}
}
*/
int DisconnectNetDisk(void)
{
 /*
 iprintf("DisconnectNetDisk(): NetDisk_connected = %d, sockID = %d\n", NetDisk_connected, sockID);
 */
 // USBMS_DBG_INFO(iprintf("[USBMS INFO] DisconnectNetDisk() .. \n"));
 dprintf("[USBMS] DisconnectNetDisk() .. \n");
 /*
 dprintf("[USBMS] DisconnectNetDisk(): NetDisk_connected = %d \n", NetDisk_connected);
 dprintf("DisconnectNetDisk(): NetDisk_connected = %d, sockID = %d\n", NetDisk_connected, sockID);
 */
 
 dprintf("[USBMS] FixMe : CloseUsbDisk() Not Called !! \n");
 /*
 if( !CloseUsbDisk(VolumeID+1) ) {
	// USBMS_DBG_INFO(iprintf("[USBMS INFO] DisconnectNetDisk() : Error : Close Usb Disk Failed !! \n"));
	dprintf("[USBMS] Error : Close Usb Disk Failed !! \n");
	return -1;
   }
 */

 /*
 if (! NetDisk_connected) return 0;
 if (sockID <= 0) return 0;

 closesocket(sockID);
 sockID = -1;
 NetDisk_connected = FALSE;
 */
 return 0;
}

// ==================================================================== 


/* Searches for a volume's buffer contaning the specified sector. */
/* Returns the buffer number on success, or -1 on failure.        */
/* Called by fat_readbuf.                                         */

static int search_for_buffer(tVolume *V, DWORD Sector) {
	int k;

	for (k = 0 ; k < V->NumBuffers ; k++) {
		if (V->Buffers[k].Flags & FATBUF_USED) {
			if (Sector == V->Buffers[k].StartingSector) return k;
		}
	}

	return -1;
}


/* Returns the number of the least recently used volume's buffer. */
/* Called by fat_readbuf.                                         */
#if 1
static int find_least_recently_used(tVolume *V) {
	int   k, Lru = 0;
	DWORD MinAccess = V->BufferAccess;
	// when reading large file. prevent always search the same entry
	static int stFlag = 0;

//dprintf("find_least_recently_used(");
	for (k = stFlag ; ; k++) {
//dprintf("%d ", k);
		
		// Never used buffers have LastAccess == 0, so it works 
		if (V->Buffers[k].LastAccess < MinAccess) {
			MinAccess = V->Buffers[k].LastAccess;
			Lru       = k;
		}
		
		// need ring search
		if ((k + 1) >= V->NumBuffers) k = -1;
		if ((k + 1) == stFlag) break;
	}
//dprintf(") Lru:%d\n", Lru);

	if (++stFlag >= V->NumBuffers) stFlag = 0;

	return Lru;
}
#else
static int find_least_recently_used(tVolume *V)
{
  int   k, Lru = 0;
  DWORD MinAccess = V->BufferAccess;
  for (k = 0; k < V->NumBuffers; k++)
	// Never used buffers have LastAccess == 0, so it works 
    if (V->Buffers[k].LastAccess < MinAccess)
    {
      MinAccess = V->Buffers[k].LastAccess;
      Lru       = k;
    }
  return Lru;
}
#endif // 1


#ifdef FATWRITE
/* Writes the content of the specified buffer in the hosting block */
/* device, marking the buffer as not dirty.                        */
/* Returns 0 on success, or a negative error code on failure.      */
/* Called by fat_flushall and fat_readbuf.                         */

static int flush_buffer(tVolume *V, int NumBuf) {
  int               Res;

	if (V->Buffers[NumBuf].Flags & FATBUF_DIRTY) {
    Res = block_write(V->VolumeID, V->Buffers[NumBuf].StartingSector, V->Buffers[NumBuf].Data);
    if (Res < 0) return FD32_EGENERAL;
    V->Buffers[NumBuf].Flags &= ~FATBUF_DIRTY;
  }

  return 0;
}


/* Flushes all buffers of the specified volume, calling flush_buffer. */
/* Returns 0 on success, or a negative error code on failure.         */
/* Called by fat_fflush (open.c) and fat_write (readwrit.c).          */

int fat_flushall(tVolume *V) {
  int k, Res;
	int resID = volResID[V->VolumeID];

	fatfsIO_enter(resID);

  // Update FSI_Free_Count and FSI_Nxt_Free in the FAT32 FSInfo sector 
	if (V->FatType == FAT32) {
		if ((Res = fat_readbuf(V, 1)) < 0) fatfsIO_return(resID, Res);
    ((struct tFSInfo_s *) V->Buffers[Res].Data)->Free_Count = V->FSI_Free_Count;
    ((struct tFSInfo_s *) V->Buffers[Res].Data)->Nxt_Free   = V->FSI_Nxt_Free;
    //((tFSInfo *) V->Buffers[Res].Data)->Free_Count = V->FSI_Free_Count;
    //((tFSInfo *) V->Buffers[Res].Data)->Nxt_Free   = V->FSI_Nxt_Free;
		if ((Res = fat_writebuf(V, Res)) < 0) fatfsIO_return(resID, Res);
  }

  // Flush all volume's buffers 
	for (k = 0; k < V->NumBuffers; k++) {
    Res = flush_buffer(V, k);
		if (Res) fatfsIO_return(resID, Res);
  }

	fatfsIO_return(resID, 0);
}


/* If buffers are enabled, it just marks a buffer as dirty.              */
/* If buffers are disabled, writes a buffer to the hosting block device. */
/* Returns 0 on success, or a negative error code on failure.            */

int fat_writebuf(tVolume *V, int NumBuf) {
  #ifdef FATBUFFERS
	int resID = volResID[V->VolumeID];

	fatfsIO_enter(resID);
  V->Buffers[NumBuf].Flags |= FATBUF_DIRTY;
	fatfsIO_return(resID, 0);
  #else
  int               Res;
	int resID = volResID[V->VolumeID];

	fatfsIO_enter(resID);
  Res = block_write(V->VolumeID, V->Buffers[NumBuf].StartingSector, V->Buffers[NumBuf].Data);
	if (Res < 0) fatfsIO_return(resID, FD32_EGENERAL);
	fatfsIO_return(resID, 0);
  #endif
}

#endif // FATWRITE


/* Performs a buffered read from the hosting block device.       */
/* If the required sector is not already buffered, flushes the   */
/* least recently used buffer and uses it to load in the sector. */
/* Puts the buffer number in NumBuf.                             */
/* Returns zero on success, or a negative error code on failure. */
/* Called by fat??_read_entry and fat??_write_entry in fat??.c,  */
/* fat_read and fat_write in readwrit.c.                         */
#define FD32_BUF_ACCESS_MAX		0xffffffff
int fat_readbuf(tVolume *V, DWORD Sector) {
	int Res, i, j, minSlot;
	int NumBuf;
	int resID = volResID[V->VolumeID];
	DWORD difAcc, baseAcc, minAcc;

	fatfsIO_enter(resID);

	if ((NumBuf = search_for_buffer(V, Sector)) == -1) {
		V->BufferMiss++;
		NumBuf = find_least_recently_used(V);
//dprintf("fat_readbuf(1) NumBuf:%d\n", NumBuf);
#ifdef FATWRITE
		Res = flush_buffer(V, NumBuf);
		if (Res < 0) fatfsIO_return(resID, Res);
#endif // FATWRITE
//dprintf("fat_readbuf(2) Res:%d\n", Res);
		Res = block_read(V->VolumeID, Sector, V->Buffers[NumBuf].Data);
//dprintf("fat_readbuf(3) Res:%d\n", Res);
		if (Res < 0) fatfsIO_return(resID, FD32_EGENERAL);
		V->Buffers[NumBuf].StartingSector = Sector;
		V->Buffers[NumBuf].Flags |= FATBUF_USED;
	}
	else V->BufferHit++;

	V->Buffers[NumBuf].LastAccess = ++(V->BufferAccess);

	// BufferAccess may overflow, need take care (re-sorting)
	if (V->BufferAccess >= FD32_BUF_ACCESS_MAX) {

		// print before
		//dprintf("Before sorting...\n");
		//for (i = 0 ; i < FAT_MAX_BUFFERS ; i++)
		//	dprintf("buf[%d].Acce:%lu\n", i, V->Buffers[i].LastAccess);

		// start sorting
		baseAcc = 0L;
		for (i = 0 ; i < FAT_MAX_BUFFERS ; i++) {
			minAcc = 0xffffffff;
			for (j = 0 ; j < FAT_MAX_BUFFERS ; j++) {
				if (V->Buffers[j].Flags & FATBUF_SORT) continue;
				
				difAcc = V->Buffers[j].LastAccess - baseAcc;
				if (difAcc < minAcc) {
					minSlot = j;
					minAcc = difAcc;
				}
			}
			
			// setting new access times & mark sorting flag
			baseAcc = V->Buffers[minSlot].LastAccess;
			V->Buffers[minSlot].LastAccess = i;
			V->Buffers[minSlot].Flags |= FATBUF_SORT;
		}
		
		// reset sorting flag
		//dprintf("After sorting...\n");
		for (i = 0 ; i < FAT_MAX_BUFFERS ; i++) {
			V->Buffers[i].Flags &= (~FATBUF_SORT);
			//dprintf("buf[%d].Acce:%lu\n", i, V->Buffers[i].LastAccess);
		}
	}

	fatfsIO_return(resID, NumBuf);
}

// ==================================================================== 

#endif // _USB_MS >= 1

// ==================================================================== 
// End of File : FatBlockIo.c
