
// Name of File : UsbMsCfg.h
// ====================================================================

// ====================================================================
// ========== for USB Mass Storag =====================================
// ====================================================================

// Major Change List : 
// 2003/11/19 : Create this file

// unwork : kset , subsystem (driver,bus,class)

// ====================================================================

#if (_USB_MS >= 1)
#ifndef __USB_MS_CFG_H__
#define __USB_MS_CFG_H__
// ====================================================================
// === for Reduce the memory allocate =================================
// ====================================================================

#define USBMS_REDUCE_RESOURCE

// ====================================================================

#define USBMS_NO_IOCTL

// ====================================================================
// Disk Layer
// ====================================================================

#define USBMS_ONLY_ONE_DISK  // only one Physical Disk
					// Note : One Physical Disk may has multi Partition

#define USBMS_SD_NO_CACHE  // for sd_read_cache_type()


#ifdef USBMS_REDUCE_RESOURCE
	// #define USBMS_MAX_PARTITION_8
	#define USBMS_MAX_PARTITION_16


	#define USBMS_BIT_SHIFT_FOR_1  (0) // 1:0 2:1 4:2 8:3 16:4
	#define USBMS_BIT_SHIFT_FOR_8  (3)
	#define USBMS_BIT_SHIFT_FOR_16 (4)


	#if   defined(USBMS_MAX_PARTITION_8)
		#define USBMS_PART_BIT_SHIFT  USBMS_BIT_SHIFT_FOR_8
	#elif defined(USBMS_MAX_PARTITION_16)
		#define USBMS_PART_BIT_SHIFT  USBMS_BIT_SHIFT_FOR_16
	#endif

	#define USBMS_MAX_MINORS (0x01 << USBMS_PART_BIT_SHIFT)   // for gd->minors
 #else
	#define USBMS_MAX_MINORS (16)
#endif

// ====================================================================
// VFS Layer
// ====================================================================

#define NO_VFS  // struct vfsmount

#define USBMS_NO_REMOVAL // for not call check_disk_change()

// ====================================================================
// FS Lyaer
// ====================================================================

#define CONFIG_MSDOS_PARTITION

#ifdef USBMS_REDUCE_RESOURCE
	#define USBMS_MAX_PARTITIONS USBMS_MAX_MINORS
 #else
	#define USBMS_MAX_PARTITIONS (256)
#endif

#define USBMS_SECTOR_SIZE (512)  // for unsigned char *Sector_buf

// ====================================================================

#undef NO_INODE  // has struct inode
// #define NO_INODE  // no struct inode

#ifndef NO_INODE
	#define INODE_REDUCED // reduced version of struct inode
 #else
	#error: Please Donot define NO_INODE !!
	#undef INODE_REDUCED // reduced version of struct inode
#endif // ndef NO_INODE

#define NO_BACKDEV  // struct backing_dev_info

// ====================================================================
// Block I/O Lyaer
// ====================================================================

#define BLOCK_IO_REDUCED // reduced version of block I/O model

#if (USB_MEM_U_L_SIZE > 4096)
	// #error: USBMS_RW_MAX_SECTORS 16 : Host Controller Bug Not Fix Yet !!
	//#define USBMS_RW_MAX_SECTORS (8)
	#define USBMS_RW_MAX_SECTORS (16)
	//#define USBMS_RW_MAX_SECTORS (32)
	//#define USBMS_RW_MAX_SECTORS (64)
 #else
	#define USBMS_RW_MAX_SECTORS (8)
	// #define USBMS_RW_MAX_SECTORS (1)
#endif // USB_MEM_U_L_SIZE

	// #define USBMS_RD_SECTORS (USBMS_RW_MAX_SECTORS) // for test read speed
	#define USBMS_RD_SECTORS (1) // for normal use


// ====================================================================

#define NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 

#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	#define CONFIG_IOSCHED_NOOP
        // No-op I/O scheduler
        //  The no-op I/O scheduler is a minimal scheduler that does
		//  basic merging
        //  and sorting. Its main uses include non-disk based block
		//  devices like memory devices, and specialised software or
		//  hardware environments that do their own scheduling and
		//  require only minimal assistance from
        //  the kernel.
	// obj-y   := elevator.o ll_rw_blk.o ioctl.o genhd.o scsi_ioctl.o

	// obj-$(CONFIG_IOSCHED_NOOP)      += noop-iosched.o

	// NOTE that ll_rw_blk.c must come early in linkage order - it starts the
	// kblockd threads
#endif // ndef NO_ELEVATOR

#define BLK_NO_QUEUE 

// ====================================================================
// SCSI Layer
// ====================================================================

#define USBMS_NO_SG      // SCSI Generic Support
#define USBMS_NO_DBGHOST // SCSI Host for debug

#ifdef USBMS_REDUCE_RESOURCE
	#define USBMS_SCSI_MAX_ID  (1) 
	#define USBMS_SCSI_MAX_LUM (1)
#else
	#define USBMS_SCSI_MAX_ID  (8)  // for shost->max_id = 8;
	#define USBMS_SCSI_MAX_LUM (8)  // for shost->max_lun = 8;
#endif

#define USBMS_TIMEOUT        (15) // unit : second 
#define USBMS_RESET_TIMEOUT  (20) // unit : second

#define USBMS_MAXLUN_TIMEOUT (1)  // unit : second
// #define USBMS_MAXLUN_TIMEOUT (3)  // unit : second

#define USBMS_CLEAR_TIMEOUT  (3)  // unit : second
#define USBMS_EUSCSI_TIMEOUT (10)  // unit : second
/*
#ifdef DEBUG
#define SCSI_TIMEOUT (5*HZ)
#else
#define SCSI_TIMEOUT (2*HZ)
#endif
*/
#define SCSI_TIMEOUT (2) // unit : second

/*
#define MAX_REPORT_LUNS (128)  // max_scsi_report_luns on scsi_scan.c
*/
#define MAX_REPORT_LUNS (4)    // max_scsi_report_luns

#define USBMS_SCSI_LOOSER_CHECK
// #define SG_MAX_DEVS_MASK (256 - 1)
// #define SG_MAX_DEVS_MASK (8 - 1)
#define SG_MAX_DEVS_MASK (4 - 1)

// ====================================================================
// SCSI Glue Layer
// ====================================================================

#define USBMS_NO_PROBE_MAXLUN  // Donot Call usb_stor_Bulk_max_lun()

// #define USBMS_SCSIGLUE_MS_6
// #define USBMS_SCSIGLUE_RW_6


#define USBMS_EH_WAIT_BY_EVENT     // 2004/1/2 B. S. Liaw
#define USBMS_USB_WAIT_BY_EVENT    // 2004/1/2 B. S. Liaw

#define USBMS_NO_USB_TASK	/* Charles 20040520 */
//#define USBMS_SCSI_SHORTCUT	/* Charles 20040526 */

// ====================================================================
#endif // ndef __USB_MS_CFG_H__
#endif // _USB_MS

// ====================================================================
// End of File : UsbMsCfg.h

