
// include/linux/blkdev.h

#ifndef _LINUX_BLKDEV_H
#define _LINUX_BLKDEV_H

// 2003/11/12 B. S. Liaw for ISA_DMA_THRESHOLD
#if defined(_S3C2510)
	// from include/asm-arm/scatterlist.h
	#define ISA_DMA_THRESHOLD (0xffffffff)
#elif defined(_AR7300)
	// from include/asm-mips/scatterlist.h
	#define ISA_DMA_THRESHOLD (0x00ffffffUL)
#elif defined(_ADM5120)
	// from include/asm-mips/scatterlist.h
	#define ISA_DMA_THRESHOLD (0x00ffffffUL)
#elif defined(_ATHEROS)
	// from include/asm-mips/scatterlist.h
	#define ISA_DMA_THRESHOLD (0x00ffffffUL)
#else
	#error : Please Define the value of ISA_DMA_THRESHOLD !!
#endif

/*
#include <linux/config.h>
*/
/*
#include <linux/major.h>
*/
#ifndef USBMS_ONLY_ONE_DISK
	#include "major.h"
#endif // ndef USBMS_ONLY_ONE_DISK
/*
#include <linux/genhd.h>
*/
#include "block/genhd.h"
/*
#include <linux/list.h>
*/
#include "PoList.h" // osport_list.h <linux/list.h>
/*
#include <linux/timer.h>
*/
#ifndef NO_TIMER
	#include "PoTimer.h" // osport_timer.h
#endif // ndef NO_TIMER
/*
#include <linux/workqueue.h>
#include <linux/pagemap.h>
*/
/*
#include <linux/backing-dev.h>
*/
#include "backing-dev.h"

/*
#include <linux/wait.h>
*/
#ifndef NO_WAITQUEUE
	#include  "PoWait.h" // linux/wait.h , osport_wait.h
#endif
/*
#include <linux/mempool.h>
#include <linux/bio.h>
*/
#include "bio.h"
/*
#include <linux/module.h>
#include <linux/stringify.h>
*/
#ifdef USB_DBGSTRING_ON
	#include "stringify.h"
#endif // USB_DBGSTRING_ON

/*
#include <asm/scatterlist.h>
*/

// #ifdef _ETCPIP
#include "PoFile.h" // include/linux/file.h
#include "radix-tree.h" // include/linux/radix-tree.h
#include "PoFs.h" // osport_fs.h 
// #endif // _ETCPIP

struct request_queue;
typedef struct request_queue request_queue_t;
#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	struct elevator_s;
	typedef struct elevator_s elevator_t;
#endif // ndef NO_ELEVATOR 
struct request_pm_state;

#define BLKDEV_MIN_RQ	4
#define BLKDEV_MAX_RQ	128	/* Default maximum */

/*
 * This is the per-process anticipatory I/O scheduler state.
 */
struct as_io_context {
 /*
 #ifndef NO_SPINLOCK
	spinlock_t lock;
 #endif // ndef NO_SPINLOCK
 */
 void (*dtor)(struct as_io_context *aic); /* destructor */
 void (*exit)(struct as_io_context *aic); /* called on task exit */

 unsigned long state;
 atomic_t nr_queued; /* queued reads & sync writes */
 atomic_t nr_dispatched; /* number of requests gone to the drivers */

 /* IO History tracking */
 /* Thinktime */
 unsigned long last_end_request;
 unsigned long ttime_total;
 unsigned long ttime_samples;
 unsigned long ttime_mean;
 /* Layout pattern */
 unsigned int seek_samples;
 sector_t last_request_pos;
 u64 seek_total;
 sector_t seek_mean;
};

/*
 * This is the per-process I/O subsystem state.  It is refcounted and
 * kmalloc'ed. Currently all fields are modified in process io context
 * (apart from the atomic refcount), so require no locking.
 */
/*
#ifndef _ETCPIP
struct io_context {
	atomic_t refcount;
	pid_t pid;

	
	// For request batching
	 
	unsigned long last_waited; // Time last woken after wait for request 
	int nr_batch_requests;     // Number of requests left in the batch 

	struct as_io_context *aic;
};

void put_io_context(struct io_context *ioc);
void exit_io_context(void);
struct io_context *get_io_context(int gfp_flags);
void copy_io_context(struct io_context **pdst, struct io_context **psrc);
void swap_io_context(struct io_context **ioc1, struct io_context **ioc2);
#endif // ndef _ETCPIP
*/

/*
#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
struct request_list {
	int count[2];
 // mempool_t is on include/linux/mempool.h
 //	mempool_t *rq_pool;
 //	void *rq_pool_data;
 #ifndef NO_WAITQUEUE
	wait_queue_head_t wait[2];
 #endif // ndef NO_WAITQUEUE
};
#endif // ndef NO_ELEVATOR
*/

/*
 * try to put the fields that are referenced together in the same cacheline
 */
struct request {
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	/*
	#ifndef _ETCPIP
	*/
	struct list_head queuelist; /* looking for ->queue? you must _not_
				     * access it directly, use
				     * blkdev_dequeue_request! */
	/*
	 #else
		struct list_head *queuelist;
	#endif
	*/
 #endif // ndef NO_ELEVATOR
 unsigned long flags;		/* see REQ_ bits below */

 /* Maintain bio traversal state for part by part I/O submission.
  * hard_* are block layer internals, no driver should touch them!
  */

 sector_t sector;		/* next sector to submit */
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	unsigned long nr_sectors;	/* no. of sectors left to submit */
	/* no. of sectors left to submit in the current segment */
	unsigned int current_nr_sectors;
 #endif // ndef NO_ELEVATOR

 sector_t hard_sector;		/* next sector to complete */
 unsigned long hard_nr_sectors;	/* no. of sectors left to complete */
 /* no. of sectors left to complete in the current segment */
 unsigned int hard_cur_sectors;

 /* no. of segments left to submit in the current bio */
 unsigned short nr_cbio_segments;
 /* no. of sectors left to submit in the current bio */
 unsigned long nr_cbio_sectors;

 struct bio *cbio;		/* next bio to submit */
 struct bio *bio;		/* next unfinished bio to complete */
 /*
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	struct bio *biotail;
	void *elevator_private;
 #endif // ndef NO_ELEVATOR
 */
 int rq_status;	/* should split this into a few status bits */
 struct gendisk *rq_disk;
 int errors;
 unsigned long start_time;

 /* Number of scatter-gather DMA addr+len pairs after
  * physical address coalescing is performed.
  */
 #ifndef NO_SCATTER_LIST
	unsigned short nr_phys_segments;
 #endif // ndef NO_SCATTER_LIST

 /* Number of scatter-gather addr+len pairs after
  * physical and DMA remapping hardware coalescing is performed.
  * This is the number of scatter-gather entries the driver
  * will actually have to deal with after DMA mapping is done.
  */
 /*
 #ifndef NO_SCATTER_LIST
	unsigned short nr_hw_segments;
 #endif // ndef NO_SCATTER_LIST
 */
 int tag;
 char *buffer;

 int ref_count;
 request_queue_t *q;
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	struct request_list *rl;
 #endif // ndef NO_ELEVATOR
 /*
 #ifndef _ETCPIP
    // struct completion is in <linux/completion.h>
	struct completion *waiting;
  #else
 */
 // 2003/12/02 B. S. Liaw :
 // req->waiting replaced by MT_EVT_USBMS_RQ/MT_EVT_USBMS_RQBI on kernel/local.h
 volatile uint waiting_evt ;
 #ifndef USBMS_USB_WAIT_BY_EVENT     // 2004/1/2 B. S. Liaw
	volatile int evt_blk_rq ;
	#ifndef USBMS_NO_IOCTL
		volatile int evt_blk_rq_bi ;
	#endif // ndef USBMS_NO_IOCTL
 #endif // ndef USBMS_USB_WAIT_BY_EVENT
 /*
 #endif
 */
 void *special;

 /*
  * when request is used as a packet command carrier
  */
 unsigned int cmd_len;
 unsigned char cmd[16];

 unsigned int data_len;
 void *data;

 unsigned int sense_len;
 void *sense;

 unsigned int timeout;

 /*
  * For Power Management requests
  */
 struct request_pm_state *pm;
};

/*
 * first three bits match BIO_RW* bits, important
 */
enum rq_flag_bits {
	__REQ_RW,	/* not set, read. set, write */
	__REQ_FAILFAST,		/* no low level driver retries */
	__REQ_SOFTBARRIER,	/* may not be passed by ioscheduler */
	__REQ_HARDBARRIER,	/* may not be passed by drive either */
	__REQ_CMD,	/* is a regular fs rw request */
	__REQ_NOMERGE,	/* don't touch this for merging */
	__REQ_STARTED,	/* drive already may have started this one */
	__REQ_DONTPREP,	/* don't call prep for this one */
	__REQ_QUEUED,	/* uses queueing */
	/*
	 * for ATA/ATAPI devices
	 */
	__REQ_PC,	/* packet command (special) */
	__REQ_BLOCK_PC,	/* queued down pc from block layer */
	__REQ_SENSE,	/* sense retrival */

	__REQ_FAILED,	/* set if the request failed */
	__REQ_QUIET,	/* don't worry about errors */
	__REQ_SPECIAL,	/* driver suplied command */
	__REQ_DRIVE_CMD,
	__REQ_DRIVE_TASK,
	__REQ_DRIVE_TASKFILE,
	__REQ_PREEMPT,		/* set for "ide_preempt" requests */
	__REQ_PM_SUSPEND,	/* suspend request */
	__REQ_PM_RESUME,	/* resume request */
	__REQ_PM_SHUTDOWN,	/* shutdown request */
	__REQ_NR_BITS,	/* stops here */
};

#define REQ_RW		(1 << __REQ_RW)
#define REQ_FAILFAST	(1 << __REQ_FAILFAST)
#define REQ_SOFTBARRIER	(1 << __REQ_SOFTBARRIER)
#define REQ_HARDBARRIER	(1 << __REQ_HARDBARRIER)
#define REQ_CMD		(1 << __REQ_CMD)
#define REQ_NOMERGE	(1 << __REQ_NOMERGE)
#define REQ_STARTED	(1 << __REQ_STARTED)
#define REQ_DONTPREP	(1 << __REQ_DONTPREP)
#define REQ_QUEUED	(1 << __REQ_QUEUED)
#define REQ_PC		(1 << __REQ_PC)
#define REQ_BLOCK_PC	(1 << __REQ_BLOCK_PC)
#define REQ_SENSE	(1 << __REQ_SENSE)
#define REQ_FAILED	(1 << __REQ_FAILED)
#define REQ_QUIET	(1 << __REQ_QUIET)
#define REQ_SPECIAL	(1 << __REQ_SPECIAL)
#define REQ_DRIVE_CMD	(1 << __REQ_DRIVE_CMD)
#define REQ_DRIVE_TASK	(1 << __REQ_DRIVE_TASK)
#define REQ_DRIVE_TASKFILE	(1 << __REQ_DRIVE_TASKFILE)
#define REQ_PREEMPT	(1 << __REQ_PREEMPT)
#define REQ_PM_SUSPEND	(1 << __REQ_PM_SUSPEND)
#define REQ_PM_RESUME	(1 << __REQ_PM_RESUME)
#define REQ_PM_SHUTDOWN	(1 << __REQ_PM_SHUTDOWN)

/*
 * State information carried for REQ_PM_SUSPEND and REQ_PM_RESUME
 * requests. Some step values could eventually be made generic.
 */
struct request_pm_state
{
	/* PM state machine step value, currently driver specific */
	int	pm_step;
	/* requested PM state value (S1, S2, S3, S4, ...) */
	u32	pm_state;
	void*	data;		/* for driver use */
};
/*
#include <linux/elevator.h>
*/
#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	#include "elevator.h"
#endif //ndef NO_ELEVATOR 


#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	typedef int (merge_request_fn) (request_queue_t *, struct request *,
				struct bio *);
	typedef int (merge_requests_fn) (request_queue_t *, struct request *,
				 struct request *);
#endif // ndef NO_ELEVATOR 
/*
typedef void (request_fn_proc) (request_queue_t *q);
*/
typedef int (request_fn_proc) (request_queue_t *q);

// #ifndef USB_NO_VMM // vitrtul memory management
	typedef int (make_request_fn) (request_queue_t *q, struct bio *bio);
// #endif // ndef USB_NO_VMM

typedef int (prep_rq_fn) (request_queue_t *, struct request *);

#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	typedef void (unplug_fn) (void *q);
#endif // ndef NO_ELEVATOR

/// #ifndef USB_NO_VMM // vitrtul memory management
	struct bio_vec;
	typedef int (merge_bvec_fn) (request_queue_t *, struct bio *, struct bio_vec *);
// #endif // ndef USB_NO_VMM

typedef void (activity_fn) (void *data, int rw);

enum blk_queue_state {
	Queue_down,
	Queue_up,
};

#define BLK_TAGS_PER_LONG	(sizeof(unsigned long) * 8)
#define BLK_TAGS_MASK		(BLK_TAGS_PER_LONG - 1)

struct blk_queue_tag {
 struct request **tag_index;	/* map of busy tags */
 unsigned long *tag_map;		/* bit map of free/busy tags */
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	#ifndef _ETCPIP
		struct list_head busy_list;	/* fifo list of busy tags */
	 #else
		struct list_head *busy_list;
	#endif
 #endif // ndef NO_ELEVATOR
 int busy;			/* current depth */
 int max_depth;			/* what we will send to device */
 int real_max_depth;		/* what the array can hold */
 atomic_t refcnt;		/* map can be shared */
};

struct request_queue {
 /*
  * Together with queue_head for cacheline sharing
  */
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	struct list_head  queue_head;
  #else
	struct request    *req;  // B. S. Liaw add this
 #endif
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	struct request  *last_merge;
	elevator_t		elevator;
 #endif // ndef NO_ELEVATOR 

 /*
  * the queue request freelist, one for reads and one for writes
  */
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	struct request_list	rq;
 #endif // ndef NO_ELEVATOR

 request_fn_proc		*request_fn;

 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	merge_request_fn	*back_merge_fn;
	merge_request_fn	*front_merge_fn;

	merge_requests_fn	*merge_requests_fn;
 #endif // ndef NO_ELEVATOR 

 // #ifndef USB_NO_VMM // vitrtul memory management
	make_request_fn		*make_request_fn;
 // #endif // ndef USB_NO_VMM
 prep_rq_fn		*prep_rq_fn;
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	unplug_fn		*unplug_fn;
 #endif // ndef NO_ELEVATOR
 #ifndef USB_NO_VMM // vitrtul memory management
	merge_bvec_fn		*merge_bvec_fn;
 #endif // ndef USB_NO_VMM
 activity_fn		*activity_fn;

	/*
	 * Auto-unplugging state
	 */
 #ifndef NO_TIMER
	struct timer_list	unplug_timer;
 #endif // ndef NO_TIMER
	int			unplug_thresh;	/* After this many requests */
 #ifndef NO_TIMER
	unsigned long		unplug_delay;	/* After this many jiffies */
 #endif // ndef NO_TIMER
 #ifndef NO_WORKQUEUE
	struct work_struct	unplug_work;
 #endif // ndef NO_WORKQUEUE

 #ifndef NO_BACKDEV 
	struct backing_dev_info	backing_dev_info;
 #endif // ndef NO_BACKDEV 

 /*
  * The queue owner gets to use this for whatever they like.
  * ll_rw_blk doesn't touch it.
  */
 void			*queuedata;

 void			*activity_data;

 /*
  * queue needs bounce pages for pages above this limit
  */
 #ifdef CONFIG_HIGHMEM
	unsigned long		bounce_pfn;
	int			bounce_gfp;
 #endif // CONFIG_HIGHMEM

 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	 // #ifndef _ETCPIP
		struct list_head  plug_list;
	 // #else
	 //	struct list_head  *plug_list;
	 // #endif
 #endif // ndef NO_ELEVATOR

 /*
  * various queue flags, see QUEUE_* below
  */
 unsigned long		queue_flags;

 /*
  * protects queue structures from reentrancy
  */
 /*
 #ifndef NO_SPINLOCK
	spinlock_t		*queue_lock;
 #endif // ndef NO_SPINLOCK
 */
 /*
  * queue kobject
  */
 struct kobject kobj;

 /*
  * queue settings
  */
 unsigned long		nr_requests;	/* Max # of requests */

 unsigned short		max_sectors;
 unsigned short		max_phys_segments;
 unsigned short		max_hw_segments;
 unsigned short		hardsect_size;
 unsigned int		max_segment_size;

 unsigned long		seg_boundary_mask;
 unsigned int		dma_alignment;

 struct blk_queue_tag	*queue_tags;

 atomic_t		refcnt;

 /*
  * sg stuff
  */
 unsigned int		sg_timeout;
 unsigned int		sg_reserved_size;
};

#define RQ_INACTIVE		(-1)
#define RQ_ACTIVE		1
#define RQ_SCSI_BUSY		0xffff
#define RQ_SCSI_DONE		0xfffe
#define RQ_SCSI_DISCONNECTING	0xffe0

#define QUEUE_FLAG_CLUSTER	0	/* cluster several segments into 1 */
#define QUEUE_FLAG_QUEUED	1	/* uses generic tag queueing */
#define QUEUE_FLAG_STOPPED	2	/* queue is stopped */
#define	QUEUE_FLAG_READFULL	3	/* write queue has been filled */
#define QUEUE_FLAG_WRITEFULL	4	/* read queue has been filled */
#define QUEUE_FLAG_DEAD		5	/* queue being torn down */
/*
#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	#define blk_queue_plugged(q)	!list_empty(&(q)->plug_list)
#endif // ndef NO_ELEVATOR
*/
#define blk_queue_tagged(q)	test_bit(QUEUE_FLAG_QUEUED, &(q)->queue_flags)
#define blk_fs_request(rq)	((rq)->flags & REQ_CMD)
#define blk_pc_request(rq)	((rq)->flags & REQ_BLOCK_PC)
#define blk_noretry_request(rq)	((rq)->flags & REQ_FAILFAST)

#define blk_pm_suspend_request(rq)	((rq)->flags & REQ_PM_SUSPEND)
#define blk_pm_resume_request(rq)	((rq)->flags & REQ_PM_RESUME)
#define blk_pm_request(rq)	\
	((rq)->flags & (REQ_PM_SUSPEND | REQ_PM_RESUME))

#define list_entry_rq(ptr)	list_entry((ptr), struct request, queuelist)

#define rq_data_dir(rq)		((rq)->flags & 1)
/*
#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
static inline int blk_queue_full(struct request_queue *q, int rw)
{
	if (rw == READ)
		return test_bit(QUEUE_FLAG_READFULL, &q->queue_flags);
	return test_bit(QUEUE_FLAG_WRITEFULL, &q->queue_flags);
}
static inline void blk_set_queue_full(struct request_queue *q, int rw)
{
	if (rw == READ)
		set_bit(QUEUE_FLAG_READFULL, &q->queue_flags);
	else
		set_bit(QUEUE_FLAG_WRITEFULL, &q->queue_flags);
}

static inline void blk_clear_queue_full(struct request_queue *q, int rw)
{
	if (rw == READ)
		clear_bit(QUEUE_FLAG_READFULL, &q->queue_flags);
	else
		clear_bit(QUEUE_FLAG_WRITEFULL, &q->queue_flags);
}
#endif // ndef NO_ELEVATOR
*/


/*
 * mergeable request must not have _NOMERGE or _BARRIER bit set, nor may
 * it already be started by driver.
 */
#define RQ_NOMERGE_FLAGS	\
	(REQ_NOMERGE | REQ_STARTED | REQ_HARDBARRIER | REQ_SOFTBARRIER)
#define rq_mergeable(rq)	\
	(!((rq)->flags & RQ_NOMERGE_FLAGS) && blk_fs_request((rq)))

/*
 * noop, requests are automagically marked as active/inactive by I/O
 * scheduler -- see elv_next_request
 */
#define blk_queue_headactive(q, head_active)

/* current index into bio being processed for submission */
#define blk_rq_idx(rq)	((rq)->cbio->bi_vcnt - (rq)->nr_cbio_segments)

/* current bio vector being processed */
#define blk_rq_vec(rq)	(bio_iovec_idx((rq)->cbio, blk_rq_idx(rq)))

/* current offset with respect to start of the segment being submitted */
#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	#define blk_rq_offset(rq) \
		(((rq)->hard_cur_sectors - (rq)->current_nr_sectors) * (rq)->q->hardsect_size)
#endif // ndef NO_ELEVATOR

/*
 * temporarily mapping a (possible) highmem bio (typically for PIO transfer)
 */

/* Assumes rq->cbio != NULL */
/*
static inline char * rq_map_buffer(struct request *rq, unsigned long *flags)
{
 
 return (__bio_kmap_irq(rq->cbio, blk_rq_idx(rq), flags)
		+ blk_rq_offset(rq));
 
}
*/

static inline void rq_unmap_buffer(char *buffer, unsigned long *flags)
{
	__bio_kunmap_irq(buffer, flags);
}

/*
 * q->prep_rq_fn return values
 */
#define BLKPREP_OK		0	/* serve it */
#define BLKPREP_KILL		1	/* fatal error, kill */
#define BLKPREP_DEFER		2	/* leave on queue */

extern unsigned long blk_max_low_pfn, blk_max_pfn;

/*
 * standard bounce addresses:
 *
 * BLK_BOUNCE_HIGH	: bounce all highmem pages
 * BLK_BOUNCE_ANY	: don't bounce anything
 * BLK_BOUNCE_ISA	: bounce pages above ISA DMA boundary
 */
#define BLK_BOUNCE_HIGH		((u64)blk_max_low_pfn << PAGE_SHIFT)
#define BLK_BOUNCE_ANY		((u64)blk_max_pfn << PAGE_SHIFT)
#define BLK_BOUNCE_ISA		(ISA_DMA_THRESHOLD)

#ifdef CONFIG_MMU
extern int init_emergency_isa_pool(void);
extern void blk_queue_bounce(request_queue_t *q, struct bio **bio);
#else
   static inline int init_emergency_isa_pool(void)
   {
	return 0;
   }

  // #ifdef CONFIG_HIGHMEM
	static inline void blk_queue_bounce(request_queue_t *q, struct bio **bio)
	{
	}
 // #endif // CONFIG_HIGHMEM

#endif /* CONFIG_MMU */

 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	#define rq_for_each_bio(bio, rq)	\
		if ((rq->bio))			\
			for (bio = (rq)->bio; bio; bio = bio->bi_next)

 #endif // ndef NO_ELEVATOR 

struct sec_size {
	unsigned block_size;
	unsigned block_size_bits;
};

extern int blk_register_queue(struct gendisk *disk);
extern void blk_unregister_queue(struct gendisk *disk);
// register_disk() on fs/partitions/check.c
// extern void register_disk(struct gendisk *dev);
extern int register_disk(struct gendisk *dev);
/*
extern void generic_make_request(struct bio *bio);
*/
extern int generic_make_request(struct bio *bio);

extern void blk_put_request(struct request *);
extern void blk_attempt_remerge(request_queue_t *, struct request *);
extern void __blk_attempt_remerge(request_queue_t *, struct request *);
extern struct request *blk_get_request(request_queue_t *, int, int);
extern void blk_put_request(struct request *);

/*
extern void blk_insert_request(request_queue_t *, struct request *, int, void *, int);
*/
extern int blk_insert_request(request_queue_t *, struct request *, int, void *, int);

extern void blk_requeue_request(request_queue_t *, struct request *);
extern void blk_plug_device(request_queue_t *);
extern int blk_remove_plug(request_queue_t *);

// #ifndef USB_NO_VMM // vitrtul memory management
	extern void blk_recount_segments(request_queue_t *, struct bio *);
	extern inline int blk_phys_contig_segment(request_queue_t *q, struct bio *, struct bio *);
	extern inline int blk_hw_contig_segment(request_queue_t *q, struct bio *, struct bio *);
// #endif // ndef USB_NO_VMM

extern int scsi_cmd_ioctl(struct block_device *, unsigned int, unsigned long);
extern void blk_start_queue(request_queue_t *q);
extern void blk_stop_queue(request_queue_t *q);
extern void __blk_stop_queue(request_queue_t *q);
extern void blk_run_queue(request_queue_t *q);
extern void blk_queue_activity_fn(request_queue_t *, activity_fn *, void *);

static inline request_queue_t *bdev_get_queue(struct block_device *bdev)
{
 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] bdev_get_queue() Begin .. \n"));

 USBMS_DBG_MEM(iprintf("[USBMS MEM] bdev_get_queue() : bdev=%08XH \n",
	bdev));
 USBMS_DBG_MEM(iprintf("[USBMS MEM] bdev_get_queue() : bdev->bd_disk=%08XH \n",
	bdev->bd_disk));
 #ifdef USBMS_BS_ASSERT
	if ( ! (IS_VALID_ADDR(bdev->bd_disk)) ) {
		iprintf("[ASSERT][USBMS] bdev_get_queue(1) : " ) ;
	    iprintf("Error : Invalid Address !!\n" ) ;
        iprintf("[ASSERT][USBMS] bdev->bd_disk=%08XH \n",
				bdev->bd_disk ) ; ;
        iprintf("[ASSERT][USBMS] Continue ..\n") ;
	   }
 #endif // USBMS_BS_ASSERT
 USBMS_DBG_MEM(iprintf("[USBMS MEM] bdev_get_queue() : bdev->bd_disk->queue=%08XH \n",
	bdev->bd_disk->queue));
 #ifdef USBMS_BS_ASSERT
	if ( ! (IS_VALID_ADDR(bdev->bd_disk->queue)) ) {
		iprintf("[ASSERT][USBMS] bdev_get_queue(2) : " ) ;
	    iprintf("Error : Invalid Address !!\n" ) ;
        iprintf("[ASSERT][USBMS] bdev->bd_disk->queue=%08XH \n",
				bdev->bd_disk->queue ) ; ;
        iprintf("[ASSERT][USBMS] Continue ..\n") ;
	   }
 #endif // USBMS_BS_ASSERT
 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] bdev_get_queue() End. \n"));
 return bdev->bd_disk->queue;
}

/*
 * end_request() and friends. Must be called with the request queue spinlock
 * acquired. All functions called within end_request() _must_be_ atomic.
 *
 * Several drivers define their own end_request and call
 * end_that_request_first() and end_that_request_last()
 * for parts of the original function. This prevents
 * code duplication in drivers.
 */
extern int end_that_request_first(struct request *, int, int);
extern int end_that_request_chunk(struct request *, int, int);
extern void end_that_request_last(struct request *);
extern int process_that_request_first(struct request *, unsigned int);
extern void end_request(struct request *req, int uptodate);

static inline void blkdev_dequeue_request(struct request *req)
{
 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_dequeue_request() Begin .. \n"));

 USBMS_DBG_MEM(iprintf("[USBMS MEM] blkdev_dequeue_request() : req=%08XH \n",req));
 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
 USBMS_DBG_MEM(iprintf("[USBMS MEM] blkdev_dequeue_request() : req->queuelist=%08XH \n",req->queuelist));

 USBMS_DBG_INIT(iprintf("[USBMS INIT] blkdev_dequeue_request() : BUG_ON(list_empty(&req->queuelist)) .. \n"));
 /*
 BUG_ON(list_empty(&req->queuelist));
 */
 /*
 #ifndef _ETCPIP
 */
	if(list_empty(&req->queuelist)) {
 /*
 #else
	if(!((list_empty(req->queuelist))!=0)) {
 #endif
 */
	dprintf("[USBMS] BUG : Badness in %s at %s:%d\n", __FUNCTION__, __FILE__, __LINE__);
   }
 #endif // ndef NO_ELEVATOR

 #ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_dequeue_request() : list_del_init() .. \n"));
 /*
 #ifndef _ETCPIP
 */
	list_del_init(&req->queuelist);
 /*
 #else
	list_del_init(req->queuelist);
 #endif
 */
 #endif // ndef NO_ELEVATOR
 if(req->q)
   {
	#ifndef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
		elv_remove_request(req->q, req);
	#endif // ndef NO_ELEVATOR 
   }
 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_dequeue_request() End. \n"));
}

/*
 * Access functions for manipulating queue properties
 */
/*
extern request_queue_t *blk_init_queue(request_fn_proc *, spinlock_t *);
*/
extern request_queue_t *blk_init_queue(request_fn_proc *rfn
	/*
	#ifndef NO_SPINLOCK
		, spinlock_t *lock
	#endif // ndef NO_SPINLOCK
	*/
   ) ;

extern void blk_cleanup_queue(request_queue_t *);
// #ifndef USB_NO_VMM // vitrtul memory management
	extern void blk_queue_make_request(request_queue_t *, make_request_fn *);
// #endif // ndef USB_NO_VMM
#ifdef CONFIG_HIGHMEM
	extern void blk_queue_bounce_limit(request_queue_t *, u64);
#endif // CONFIG_HIGHMEM
extern void blk_queue_max_sectors(request_queue_t *, unsigned short);
extern void blk_queue_max_phys_segments(request_queue_t *, unsigned short);
extern void blk_queue_max_hw_segments(request_queue_t *, unsigned short);
extern void blk_queue_max_segment_size(request_queue_t *, unsigned int);
extern void blk_queue_hardsect_size(request_queue_t *, unsigned short);
extern void blk_queue_stack_limits(request_queue_t *t, request_queue_t *b);
extern void blk_queue_segment_boundary(request_queue_t *, unsigned long);
extern void blk_queue_prep_rq(request_queue_t *, prep_rq_fn *pfn);
#ifndef USB_NO_VMM // vitrtul memory management
	extern void blk_queue_merge_bvec(request_queue_t *, merge_bvec_fn *);
#endif // ndef USB_NO_VMM
extern void blk_queue_dma_alignment(request_queue_t *, int);
#ifndef NO_BACKDEV 
	extern struct backing_dev_info *blk_get_backing_dev_info(struct block_device *bdev);
#endif // ndef NO_BACKDEV 

#ifndef NO_SCATTER_LIST
	// struct scatterlist is on include/asm-xxx/scatterlist.h
	extern int blk_rq_map_sg(request_queue_t *, struct request *, struct scatterlist *);
#endif // ndef NO_SCATTER_LIST
extern void blk_dump_rq_flags(struct request *, char *);
extern void generic_unplug_device(void *);
extern long nr_blockdev_pages(void);

int blk_get_queue(request_queue_t *);
/*
#ifndef _ETCPIP
	request_queue_t *blk_alloc_queue(int);
 #else
*/
request_queue_t *blk_alloc_queue(void) ;
/*
#endif
*/

#define blk_put_queue(q) blk_cleanup_queue((q))

/*
 * tag stuff
 */
#define blk_queue_tag_depth(q)		((q)->queue_tags->busy)
#define blk_queue_tag_queue(q)		((q)->queue_tags->busy < (q)->queue_tags->max_depth)
#define blk_rq_tagged(rq)		((rq)->flags & REQ_QUEUED)
extern int blk_queue_start_tag(request_queue_t *, struct request *);
extern struct request *blk_queue_find_tag(request_queue_t *, int);
extern void blk_queue_end_tag(request_queue_t *, struct request *);
extern int blk_queue_init_tags(request_queue_t *, int, struct blk_queue_tag *);
extern void blk_queue_free_tags(request_queue_t *);
extern int blk_queue_resize_tags(request_queue_t *, int);
extern void blk_queue_invalidate_tags(request_queue_t *);
extern void blk_congestion_wait(int rw, long timeout);

// #ifndef USB_NO_VMM // vitrtul memory management
	extern void blk_rq_bio_prep(request_queue_t *, struct request *, struct bio *);
// #endif // ndef USB_NO_VMM

extern void blk_rq_prep_restart(struct request *);

#define MAX_PHYS_SEGMENTS 128
#define MAX_HW_SEGMENTS 128
#define MAX_SECTORS 255

#define MAX_SEGMENT_SIZE	65536

#define blkdev_entry_to_request(entry) list_entry((entry), struct request, queuelist)

extern void drive_stat_acct(struct request *, int, int);

static inline int queue_hardsect_size(request_queue_t *q)
{
 int retval = 512;


 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] queue_hardsect_size() Begin .. \n"));
 if (q && q->hardsect_size)
		retval = q->hardsect_size;

 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] queue_hardsect_size() End. \n"));
 return retval;
}

static inline int bdev_hardsect_size(struct block_device *bdev)
{
 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] bdev_hardsect_size() : queue_hardsect_size() .. \n"));
 return queue_hardsect_size(bdev_get_queue(bdev));
}

static inline int queue_dma_alignment(request_queue_t *q)
{
	int retval = 511;

	if (q && q->dma_alignment)
		retval = q->dma_alignment;

	return retval;
}

static inline int bdev_dma_aligment(struct block_device *bdev)
{
	return queue_dma_alignment(bdev_get_queue(bdev));
}

#define blk_finished_io(nsects)	do { } while (0)
#define blk_started_io(nsects)	do { } while (0)

/* assumes size > 256 */
/*
#ifndef INODE_REDUCED  
static inline unsigned int blksize_bits(unsigned int size)
{
	unsigned int bits = 8;
	do {
		bits++;
		size >>= 1;
	} while (size > 256);
	return bits;
}
#endif // ndef INODE_REDUCED  
*/
/*
#ifndef INODE_REDUCED  
extern inline unsigned int block_size(struct block_device *bdev)
{
 return bdev->bd_block_size;
}
#endif // ndef INODE_REDUCED  
*/

/*
#ifndef USB_NO_VMM // vitrtul memory management
	// struct page is on include/linux/mm.h
	typedef struct {struct page *v;} Sector;
 #else
*/
	// B. S. Liaw : Please use unsigned char *Sector_buf;
	/*
	typedef struct {unsigned char *v_buf ;} Sector;
	*/
/*
#endif
*/

/*
#ifndef USB_NO_VMM // vitrtul memory management
	unsigned char *read_dev_sector(struct block_device *, sector_t, Sector *);
 #else
*/
int read_dev_sector(struct inode *inode, struct block_device *, sector_t,
					unsigned int num_sectors ,
					unsigned char *Sector_buf);
/*
#endif
*/

// 2003/12/23 B. S. Liaw Add this function ..
// unsigned char *write_dev_sector(struct inode *inode, struct block_device *bdev,
int write_dev_sector(struct inode *inode, struct block_device *bdev,
					sector_t n,
					unsigned int num_sectors ,
					unsigned char *Sector_buf) ;

/*
#ifndef USB_NO_VMM // vitrtul memory management
	static inline void put_dev_sector(Sector p)
 #else
*/
	static inline void put_dev_sector(unsigned char *Sector_buf)
/*
#endif
*/
{
 /*
 #ifndef USB_NO_VMM // vitrtul memory management
	page_cache_release(p.v);
 #endif // ndef USB_NO_VMM
 */
}
/*
#ifndef NO_WORKQUEUE
	struct work_struct;
	int kblockd_schedule_work(struct work_struct *work);
#endif // ndef NO_WORKQUEUE
*/
void kblockd_flush(void);

#ifdef CONFIG_LBD
/*
# include <asm/div64.h>
*/
#include "div64.h"

# define sector_div(a, b) do_div(a, b)
#else
# define sector_div(n, b)( \
{ \
	int _res; \
	_res = (n) % (b); \
	(n) /= (b); \
	_res; \
} \
)
#endif 
/* 
#define MODULE_ALIAS_BLOCKDEV(major,minor) \
	MODULE_ALIAS("block-major-" __stringify(major) "-" __stringify(minor))
#define MODULE_ALIAS_BLOCKDEV_MAJOR(major) \
	MODULE_ALIAS("block-major-" __stringify(major) "-*")
*/

// #ifdef NO_ELEVATOR // struct elevator_s , // include/linux/elevator.h 
	// B. S. Liaw Add these ..
	extern struct request  *global_rq ;
// #endif // NO_ELEVATOR

#ifdef USBMS_ONLY_ONE_DISK
	// 2003/12/17 B. S. Liaw add these ..
	// on sd.c
	// innode replaced by disk_global_bdev->bd_inode
	// extern struct inode *disk_global_inode ;
	extern struct block_device *disk_global_bdev[USBMS_MAX_MINORS+1] ;
	extern struct block_device *whole;

	extern int UsbDiskOpened[USBMS_MAX_MINORS+1] ;

	extern unsigned char *disk_global_Sector_buf ; // on check.c
#endif // USBMS_ONLY_ONE_DISK


#endif
