
// drivers/block/ioctl.c

// #ifdef _ETCPIP
#define __KERNEL__
        #ifdef _NEWLIB
          #include "string.h"
        #endif
   	#include "EtcpipDbg.h" // 2002/10/25 B. S. Liaw
       // for deciding whether to compile
       //  Debug Version or Release Version
#include "etcpip.h"
#include "UsbDbg.h"
#include "PoList.h" // osport_list.h
#include "UsbCfg.h" // Config and Setting
#include "UsbMsCfg.h" // Config and Setting for Mass Storage Class
#include "UsbMsDbg.h"
#include "UsOsport.h" // "usb_osport.h"
#ifndef NO_WAITQUEUE
	#include  "PoWait.h" // osport_wait.h
#endif // ndef NO_WAITQUEUE
#include "UsMemLib.h" // UsbMemLib.h
// #endif // _ETCPIP


#ifndef _ETCPIP
	#include <linux/sched.h>		/* for capable() */
#endif // ndef _ETCPIP
/*
#include <linux/blkdev.h>
*/
#include "bitops.h" // B. S. Liaw add for test_bit()
#include "blkdev.h"
/*
#include <linux/blkpg.h>
#include <linux/backing-dev.h>
*/
#include "backing-dev.h"
/*
#include <linux/buffer_head.h>
*/
#include "buffer_head.h"
/*
#include <asm/uaccess.h>
*/

/*
static int blkpg_ioctl(struct block_device *bdev, struct blkpg_ioctl_arg *arg)
{
	struct block_device *bdevp;
	struct gendisk *disk;
	struct blkpg_ioctl_arg a;
	struct blkpg_partition p;
	long long start, length;
	int part;
	int i;

 #ifndef _ETCPIP
	// CAP_SYS_ADMIN is on include/linux/capability.h
	if (!capable(CAP_SYS_ADMIN))
		return -EACCES;
 #endif // ndef _ETCPIP
	if (copy_from_user(&a, arg, sizeof(struct blkpg_ioctl_arg)))
		return -EFAULT;
	if (copy_from_user(&p, a.data, sizeof(struct blkpg_partition)))
		return -EFAULT;
	disk = bdev->bd_disk;
	if (bdev != bdev->bd_contains)
		return -EINVAL;
	part = p.pno;
	if (part <= 0 || part >= disk->minors)
		return -EINVAL;
	switch (a.op) {
		case BLKPG_ADD_PARTITION:
			start = p.start >> 9;
			length = p.length >> 9;
			// check for fit in a hd_struct
			if (sizeof(sector_t) == sizeof(long) && 
			    sizeof(long long) > sizeof(long)) {
				long pstart = start, plength = length;
				if (pstart != start || plength != length
				    || pstart < 0 || plength < 0)
					return -EINVAL;
			}
			// partition number in use? 
 #ifndef NO_SEMPHORE
			down(&bdev->bd_sem);
 #endif // ndef NO_SEMPHORE
			if (disk->part[part - 1]) {
 #ifndef NO_SEMPHORE
				up(&bdev->bd_sem);
 #endif // ndef NO_SEMPHORE
				return -EBUSY;
			}
			// overlap?
			for (i = 0; i < disk->minors - 1; i++) {
				struct hd_struct *s = disk->part[i];

				if (!s)
					continue;
				if (!(start+length <= s->start_sect ||
				      start >= s->start_sect + s->nr_sects)) {
 #ifndef NO_SEMPHORE
					up(&bdev->bd_sem);
 #endif // ndef NO_SEMPHORE
					return -EBUSY;
				}
			}
			// all seems OK 
			add_partition(disk, part, start, length);
 #ifndef NO_SEMPHORE
			up(&bdev->bd_sem);
 #endif // ndef NO_SEMPHORE
			return 0;
		case BLKPG_DEL_PARTITION:
			if (!disk->part[part-1])
				return -ENXIO;
			if (disk->part[part - 1]->nr_sects == 0)
				return -ENXIO;
			USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkpg_ioctl() : bdget_disk() .. \n"));
			bdevp = bdget_disk(disk, part);
 USBMS_DBG_MEM(iprintf("[USBMS MEM] blkpg_ioctl() : bdev=%08XH \n",bdev));
			if (!bdevp)
				return -ENOMEM;
 #ifndef NO_SEMPHORE
			down(&bdevp->bd_sem);
 #endif // ndef NO_SEMPHORE
		USBMS_DBG_INIT(iprintf("[USBMS INIT] blkpg_ioctl() : bdev->bd_openers=%d \n",
			bdev->bd_openers
			));
			if (bdevp->bd_openers) {
 #ifndef NO_SEMPHORE
				up(&bdevp->bd_sem);
 #endif // ndef NO_SEMPHORE
				bdput(bdevp);
				return -EBUSY;
			}
			// all seems OK
			fsync_bdev(bdevp);
			invalidate_bdev(bdevp, 0);

 #ifndef NO_SEMPHORE
			down(&bdev->bd_sem);
 #endif // ndef NO_SEMPHORE
			delete_partition(disk, part);
 #ifndef NO_SEMPHORE
			up(&bdev->bd_sem);
			up(&bdevp->bd_sem);
 #endif // ndef NO_SEMPHORE
			bdput(bdevp);

			return 0;
		default:
			return -EINVAL;
	}
}
*/
static int blkdev_reread_part(struct block_device *bdev)
{
 struct gendisk *disk = bdev->bd_disk;
 int res;

 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_reread_part() Begin .. \n"));
	if (disk->minors == 1 || bdev != bdev->bd_contains)
		return -EINVAL;
 /*
 #ifndef _ETCPIP
	// CAP_SYS_ADMIN is on include/linux/capability.h
	if (!capable(CAP_SYS_ADMIN))
		return -EACCES;
 #endif // ndef _ETCPIP
 */
 #ifndef NO_SEMPHORE
	if (down_trylock(&bdev->bd_sem))
		return -EBUSY;
 #endif // ndef NO_SEMPHORE

 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_reread_part() : rescan_partitions() .. \n"));
 #ifndef USB_NO_VMM // vitrtul memory management
	res = rescan_partitions(disk, bdev);
  #else
	res = rescan_partitions(bdev->bd_inode,disk, bdev);
 #endif
 #ifndef NO_SEMPHORE
	up(&bdev->bd_sem);
 #endif // ndef NO_SEMPHORE
 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_reread_part() End. \n"));
 return res;
}

static int put_ushort(unsigned long arg, unsigned short val)
{
 /*
	return put_user(val, (unsigned short *)arg);
 */
}

static int put_int(unsigned long arg, int val)
{
 /*
	return put_user(val, (int *)arg);
 */
}

static int put_long(unsigned long arg, long val)
{
 /*
	return put_user(val, (long *)arg);
 */
}

static int put_ulong(unsigned long arg, unsigned long val)
{
 /*
	return put_user(val, (unsigned long *)arg);
 */
}

static int put_u64(unsigned long arg, u64 val)
{
 /*
	return put_user(val, (u64 *)arg);
 */
}

int blkdev_ioctl(struct inode *inode, struct file *file, unsigned cmd,
			unsigned long arg)
{
 struct block_device *bdev = inode->i_bdev;
 struct gendisk *disk = bdev->bd_disk;
 #ifndef NO_BACKDEV 
	struct backing_dev_info *bdi;
 #endif // ndef NO_BACKDEV 
 int holder;
 int ret, n;


 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_ioctl() Begin .. \n"));

 switch (cmd) {
	case BLKRAGET:
	case BLKFRAGET:
		if (!arg)
			return -EINVAL;
	#ifndef NO_BACKDEV 
		bdi = blk_get_backing_dev_info(bdev);
		if (bdi == NULL)
			return -ENOTTY;
	#endif // ndef NO_BACKDEV 
	#ifndef USB_NO_VMM // no vitrtul memory management
		return put_long(arg, (bdi->ra_pages * PAGE_CACHE_SIZE) / 512);
	#endif // ndef USB_NO_VMM
	case BLKROGET:
		return put_int(arg, bdev_read_only(bdev) != 0);
	case BLKBSZGET: /* get the logical block size (cf. BLKSSZGET) */
		return put_int(arg, block_size(bdev));
	case BLKSSZGET: /* get block device hardware sector size */
		return put_int(arg, bdev_hardsect_size(bdev));
	case BLKSECTGET:
		return put_ushort(arg, bdev_get_queue(bdev)->max_sectors);
	case BLKRASET:
	case BLKFRASET:
 /*
 #ifndef _ETCPIP
	// CAP_SYS_ADMIN is on include/linux/capability.h
		if(!capable(CAP_SYS_ADMIN))
			return -EACCES;
 #endif // ndef _ETCPIP
 */
 #ifndef NO_BACKDEV 
		bdi = blk_get_backing_dev_info(bdev);
		if (bdi == NULL)
			return -ENOTTY;
 #endif // ndef NO_BACKDEV 
 #ifndef USB_NO_VMM // no vitrtul memory management
		bdi->ra_pages = (arg * 512) / PAGE_CACHE_SIZE;
 #endif // ndef USB_NO_VMM
		return 0;
	case BLKBSZSET:
		/* set the logical block size */
 /*
 #ifndef _ETCPIP
	// CAP_SYS_ADMIN is on include/linux/capability.h
		if (!capable(CAP_SYS_ADMIN))
			return -EACCES;
 #endif // ndef _ETCPIP
 */
		if (!arg)
			return -EINVAL;
/*
		if (get_user(n, (int *) arg))
			return -EFAULT;
*/
		if (bd_claim(bdev, &holder) < 0)
			return -EBUSY;
		USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_ioctl() : set_blocksize() .. \n"));
		ret = set_blocksize(bdev, n);
		bd_release(bdev);
		return ret;
	/*
	case BLKPG:
		return blkpg_ioctl(bdev, (struct blkpg_ioctl_arg *) arg);
	*/
	case BLKRRPART:
		USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_ioctl() : blkdev_reread_part() .. \n"));
		return blkdev_reread_part(bdev);
	case BLKGETSIZE:
#if 1  /* Charles 20040525 */
		if (bdev->bd_inode->i_size > ~0UL)
			return -EFBIG;
		return put_ulong(arg, bdev->bd_inode->i_size);
#else
		if ((bdev->bd_inode->i_size >> 9) > ~0UL)
			return -EFBIG;
		return put_ulong(arg, bdev->bd_inode->i_size >> 9);
#endif
	case BLKGETSIZE64:
		return put_u64(arg, bdev->bd_inode->i_size);
	case BLKFLSBUF:
 /*
 #ifndef _ETCPIP
	// CAP_SYS_ADMIN is on include/linux/capability.h
		if (!capable(CAP_SYS_ADMIN))
			return -EACCES;
 #endif // ndef _ETCPIP
 */
		if (disk->fops->ioctl) {
			ret = disk->fops->ioctl(inode, file, cmd, arg);
			if (ret != -EINVAL)
				return ret;
		}
 
		fsync_bdev(bdev);
 
		invalidate_bdev(bdev, 0);
		return 0;
	case BLKROSET:
		if (disk->fops->ioctl) {
			ret = disk->fops->ioctl(inode, file, cmd, arg);
			if (ret != -EINVAL)
				return ret;
		}
		/*
		#ifndef _ETCPIP
			// CAP_SYS_ADMIN is on include/linux/capability.h
			if (!capable(CAP_SYS_ADMIN))
				return -EACCES;
		#endif // ndef _ETCPIP
		*/
		/*
		if (get_user(n, (int *)(arg)))
			return -EFAULT;
		*/
		set_device_ro(bdev, n);
		return 0;
	default:
		if (disk->fops->ioctl)
			return disk->fops->ioctl(inode, file, cmd, arg);
   }

 USBMS_DBG_FLOW(iprintf("[USBMS FLOW] blkdev_ioctl() End with Fail !! \n"));
 return -ENOTTY;
}
