/*
#include <linux/pagemap.h>
#include <linux/blkdev.h>
*/
#include "bitops.h" // B. S. Liaw add for test_bit()
#include "blkdev.h"

/*
 * add_gd_partition adds a partitions details to the devices partition
 * description.
 */
/*
enum { MAX_PART = 256 };
*/
enum { MAX_PART = USBMS_MAX_PARTITIONS };

struct parsed_partitions {
 #ifdef USB_DBGSTRING_ON
	char name[BDEVNAME_SIZE];
 #endif // USB_DBGSTRING_ON
 struct {
		sector_t from;
		sector_t size;
		int flags;
	} parts[MAX_PART];
 int next;
 int limit;
};

static inline void
put_partition(struct parsed_partitions *p, int n, sector_t from, sector_t size)
{
 if(n < p->limit) {
	p->parts[n].from = from;
	p->parts[n].size = size;
	#ifdef USB_DBGSTRING_ON
		/*
		printk(" %s%d", p->name, n);
		*/
		USBMS_DBG_PARTITION(iprintf(
			"[USBMS PARTITION] put_partition() : Disk Major Name [%s] Minor %d \n",
			p->name, n));
	 #else
		USBMS_DBG_PARTITION(iprintf(
			"[USBMS PARTITION] put_partition() : Disk Minor Number %d \n",
			n));
	#endif // ndef USB_DBGSTRING_ON
   }
}

extern int warn_no_part;

extern void parse_bsd(struct parsed_partitions *state,
			struct block_device *bdev, u32 offset, u32 size,
			int origin, char *flavour, int max_partitions);

